#include <stdio.h>
#include <stdlib.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "graphic.h"
#include "command.h"

#define Ids(name) ai_ ## name, fi_ ## name ## _discovered

typedef struct {
    area_id_t id;
    flag_id_t discovered_id;
    char *name;
    char *description;
    int (*f)(verb_id_t, noun_id_t, int *exist);
    void (*post)(int time_passed);
    void (*draw)(void);
} area_t;

area_t areas[] = {
    {Ids(title), "ȥ",
     "ưפ⤷ϡư ̾פηϤƤ",
     area_title, NULL,
     draw_title,
    },
    {Ids(game_over), "४С",
     "ʤϻˤޤ",
     area_game_over, NULL,
     draw_game_over,
    },
    {Ids(ending), "ꥢ",
     "ǤȤʤ̵˲ߤæФ",
     area_ending, NULL,
     draw_ending,
    },
    {Ids(achievements), "ã",
     "ã٤",
     area_achievements, NULL,
     draw_achievements,
    },


    {Ids(mailbox), "͹ؼ",
//     "ʤϲߤϤˤ롣",
     "ʤϲߤϤƧ߹Ȥ",
     area_mailbox, NULL,
     draw_mailbox,
    },
    {Ids(entrance), "",
     "ʤϸؤˤ롣",
     area_entrance, NULL,
     draw_entrance,
    },
    {Ids(opened_window), "β",
     "ʤϸرɺݤˤ롣",
     area_opened_window, NULL,
     draw_opened_window,
    },
    {Ids(washtub), "",
     "ʤϲߤθرˤ롣",
     area_washtub, NULL,
     draw_washtub,
    },
    {Ids(backdoor), "΢",
     "ʤ΢ˤ롣",
     area_backdoor, NULL,
     draw_backdoor,
    },
    {Ids(under_tree), "΢",
     "ʤϲߤ΢ˤ롣",
     area_under_tree, NULL,
     draw_under_tree,
    },
    {Ids(garden), "",
     "ʤˤ롣",
     area_garden, NULL,
     draw_garden,
    },






    {Ids(entrance_hall), "إۡ",
     "ʤϸإۡˤ롣",
     area_entrance_hall, NULL,
     draw_entrance_hall,
    },
    {Ids(corridor_1f_fl), "쳬ϭ",
     "ʤϰ쳬ϭˤ롣",
     area_corridor_1f_fl, NULL,
     draw_corridor_1f_fl,
    },
    {Ids(corridor_1f_bl), "쳬ϭ",
     "ʤϰ쳬ϭˤ롣",
     area_corridor_1f_bl, NULL,
     draw_corridor_1f_bl,
    },
    {Ids(corridor_1f_fr), "쳬ϭ",
     "ʤϰ쳬ϭˤ롣",
     area_corridor_1f_fr, NULL,
     draw_corridor_1f_fr,
    },
    {Ids(corridor_1f_mr), "쳬ϭ",
     "ʤϰ쳬ϭˤ롣",
     area_corridor_1f_mr, NULL,
     draw_corridor_1f_mr,
    },
    {Ids(corridor_1f_br), "1ϭ",
     "ʤ1ϭˤ롣",
     area_corridor_1f_br, NULL,
     draw_corridor_1f_br,
    },
    {Ids(bathroom), "Ἴ",
     "ʤἼˤ롣",
     area_bathroom, NULL,
     draw_bathroom,
    },
    {Ids(dining), "Ʋ",
     "ʤϿƲˤ롣",
     area_dining, NULL,
     draw_dining,
    },
    {Ids(kitchen), "",
     "ʤˤ롣",
     area_kitchen, NULL,
     draw_kitchen,
    },
    {Ids(laundry), "",
     "ʤˤ롣",
     area_laundry, NULL,
     draw_laundry,
    },
    {Ids(living), "",
     "ʤϵ֤ˤ롣",
     area_living, post_living,
     draw_living,
    },
    {Ids(guestroom_1f), "Ҽ",
     "ʤϵҼˤ롣",
     area_guestroom_1f, NULL,
     draw_guestroom_1f,
    },
    {Ids(storage), "ʪ",
     "ʤʪˤ롣",
     area_storage, NULL,
     draw_storage,
    },
    {Ids(playroom), "ͷ",
     "ʤͷˤ롣",
     area_playroom, NULL,
     draw_playroom,
    },
    {Ids(landing), "٤",
     "ʤϳ󳬤٤ˤ롣",
     area_landing, NULL,
     draw_landing,
    },
    {Ids(corridor_2f_l), "󳬳ϭ",
     "ʤ󳬤ϭˤ롣",
     area_corridor_2f_l, NULL,
     draw_corridor_2f_l,
    },
    {Ids(corridor_2f_c), "󳬳ϭ",
     "ʤ󳬤ϭˤ롣",
     area_corridor_2f_c, NULL,
     draw_corridor_2f_c,
    },
    {Ids(corridor_2f_cr), "󳬳ϭ",
     "ʤ󳬤ϭˤ롣",
     area_corridor_2f_cr, post_corridor_2f_cr,
     draw_corridor_2f_cr,
    },
    {Ids(corridor_2f_r), "󳬳ϭ",
     "ʤ󳬤ϭˤ롣",
     area_corridor_2f_r, NULL,
     draw_corridor_2f_r,
    },



    {Ids(boys_room), "Ҷ",
     "ʤϻҶˤ롣",
     area_boys_room, NULL,
     draw_boys_room,
    },
    {Ids(bed), "ʥ٥åɾ",
     "ʤʥ٥åɤҤξˤ롣",
     area_bed, NULL,
     draw_bed,
    },
    {Ids(girls_room), "Ҷ",
     "ʤϻҶˤ롣",
     area_girls_room, NULL,
     draw_girls_room,
    },
    {Ids(guestroom_2f), "Ҽ",
     "ʤϵҼˤ롣",
     area_guestroom_2f, post_guestroom_2f,
     draw_guestroom_2f,
    },
    {Ids(study), "",
     "ʤϽؤˤ롣",
     area_study, post_study,
     draw_study,
    },
    {Ids(library), "޽",
     "ʤϿ޽񼼤ˤ롣",
     area_library, post_library,
     draw_library,
    },
    {Ids(bookshelf), "êξ",
     "ʤҤ˾äêξ򸫤Ƥ롣",
     area_bookshelf, NULL,
     draw_bookshelf,
    },
    {Ids(bedroom), "",
     "ʤϿˤ롣",
     area_bedroom, NULL,
     draw_bedroom,
    },
    {Ids(ladys_room), "ؿ",
     "ʤؿˤ롣",
     area_ladys_room, NULL, //post_ladys_room,
     draw_ladys_room,
    },
    {Ids(wardrobe), "ý",
     "ʤýڤˤ롣",
     area_wardrobe, NULL, //post_wardrobe,
     draw_wardrobe,
    },
    {Ids(secret_room), "",
     "ʤϱˤ롣",
     area_secret_room, NULL,
     draw_secret_room,
    },
    {Ids(music_room), "ڼ",
     "ʤϲڼˤ롣",
     area_music_room, NULL,
     draw_music_room,
    },
    {Ids(bathroom_2f), "Ἴ",
     "ʤἼˤ롣",
     area_bathroom_2f, NULL,
     draw_bathroom_2f,
    },
    {Ids(balcony), "Х륳ˡ",
     "ʤϥХ륳ˡˤ롣",
     area_balcony, NULL,
     draw_balcony,
    },
    {Ids(balcony_down), "Х륳ˡ",
     "ʤϥХ륳ˡ򸫲Ƥ롣",
     area_balcony_down, NULL,
     draw_balcony_down,
    },

    {Ids(cellar), "ϲ",
     "ʤϲˤ롣",
     area_cellar, NULL,
     draw_cellar,
    },
    {Ids(boiler_room), "ܥ顼",
     "ʤϥܥ顼ˤ롣",
     area_boiler_room, NULL,
     draw_boiler_room,
    },
    {Ids(corridor_0f), "ϲϩ",
     "ʤϲزäƤϩˤ롣",
     area_corridor_0f, NULL,
     draw_corridor_0f,
    },
    {Ids(temple), "",
     "ʤϿ¤ˤ롣",
     area_temple, post_temple,
     draw_temple,
    },
    {Ids(temple_ceiling), "¤ŷ",
     "ʤϿ¤ŷ򸫾夲Ƥ롣",
     area_temple_ceiling, NULL,
     draw_temple_ceiling,
    },
    // @note Ƿ֡ǡߴΤĤ
    {Ids(cave_entrance), "ƶ",
     "ʤƶΩäƿ¤Ǥ롣",
     NULL, NULL,
     NULL
     //     area_cave_entrance, NULL,
     //     draw_cave_entrance,
    },
    {Ids(cave), "ƶ",
     "ʤƶˤ롣",
     area_cave, NULL,
     draw_cave,
    },
    {Ids(under_cliff), "",
     "ƶФȡϳߤä"
     "֤ȡȤ˿줿βƶθƤꡢ"
     "ξˤϡߤζںʲƤ롣",
     //     "ʤϳߤγˤ롣",
     area_under_cliff, NULL,
     draw_under_cliff,
    },




    {Ids(working), "",
     "ʤϹˤ롣"
     "ϤƥȤ뤿ΥߡΤ褦",
     area_working, NULL,
     draw_test_room,
    },
};

#define AREA_NUM (sizeof(areas)/sizeof(area_t))

static area_id_t new_area_id = ai_invalid;

void init_area(void){
    int i;

	assert(ai_end <= 256);  // ֥եarea_id_t8ӥåȤ˼ޤ뤳Ȥ
    for (i = ai_begin ; i < ai_end ; i++){
        if (areas[i].id != i){
            printf("ƥ२顼: "
                   "ꥢ%sפID(%d->%d)Ƥޤ\n", 
                   areas[i].name, i, areas[i].id);
            exit(1);
        }
    }        
}

void describe_area(area_id_t id){
    //    puts_term(areas[id].description);
    message(areas[id].description);
}

int call_area(area_id_t id, verb_id_t vid, noun_id_t nid, int *exist){
    return areas[id].f(vid, nid, exist);
}
void post_area(area_id_t id, int time_passed){
    if (areas[id].post){
        areas[id].post(time_passed);
    }
}
void cancel_move(void){
    new_area_id = ai_invalid;
}
void move_area(area_id_t id){
    new_area_id = id;
}
area_id_t new_area(void){
    return new_area_id;
}
void update_current_area(void){
    if (new_area_id == ai_invalid) return;
    set_area(new_area_id);
    set_flag(areas[new_area_id].discovered_id);
    // ưȶ˻(Ƥޤäʤ)ϡư̤򤷤ʤ
    if (Not(dead)){
        describe_area(current_area());
    }
    draw_graphic();
    new_area_id = ai_invalid;
}
int is_area_discovered(area_id_t aid){
    return is_flag_on(areas[aid].discovered_id);
}

void draw_area(area_id_t id){
     areas[id].draw();
}

void gameover(void){
    message("      + + + + + + +  ४С  + + + + + + + +");
    move_area(ai_game_over);
	update_current_area(); // msg_to_title()describe_area¹ԤΤŪupdate.
    update_achievements();
	msg_to_title();
}

void move_to_title(void){
    clear_status();
    message("Mastery of the Houseؤ褦");
    move_area(ai_title);
    show_help_basic();
    msg_to_start();
}
void move_to_ending(void){
    message("      + + + + + + +  ९ꥢ  + + + + + + + +");
    move_area(ai_ending);    
	update_current_area(); // msg_to_title()describe_area¹ԤΤŪupdate.
    update_achievements();
    message("ʤΥϥեǤꡢ"
            "ºߤοʪΡ⡦ࡦ˥ᡦ̡衦ۼ"
            "ʤɤˤϰڴطޤ");
	msg_to_title();
}
// ꥢե饰ɡåȤƤã٤˰ư
void move_to_achievements(void){
    load_achievements_flags();
    update_achievements_complete_flags();
#ifdef DEBUG
    // ֶػ߻˻Ȥachivementsɻ˥åȤΤǲ
    Reset(save_forbidden);
#else
    Set(save_forbidden);
#endif
    move_area(ai_achievements);
}

void start_game(void){
    msg_start();
    clear_status();
    get_item(ni_newspaper); // ʹϺǽ餫äƤ
    // ֤ǷΤ֤ƤΤǡ򥢥Хְˤ
    Set(dining_toy_swordman_put);
    Set(dining_put_boy);
    move_area(ai_mailbox);
}
void die(void){
    message("ʤΰռϤΤޤڤ줿ġ");
    set_wait_return_callback(gameover);
    Set(dead);
}
void die_touching_water(void){
    msg_touching_water();
    Set(death_by_touching_water);
    die();
}
void die_touching_shadow(void){
    msg_touching_shadow();
    Set(death_by_touching_shadow);
    die();
}
void die_killed_by_armor(void){
    msg_killed_by_armor();
    Set(death_by_armor);
    die();
}
void die_exiting_window(void){
    msg_exiting_window();
    Set(death_by_exiting_window);
    die();
}
void die_starved(void){
    msg_starved();
    Set(death_by_starvation);
    die();
}
void die_tentacle(void){
    msg_tentacle_in();
    msg_tentacle_death();
    Set(death_by_tentacle);
    die();
}

void game_clear(void){
    message("      + + + + + + +  ९ꥢ  + + + + + + + +");
    message("ǤȤʤϤȤꤢƲߤæФ");
    msg_to_title();
}

