#ifndef AREA_H
#define AREA_H
#include "verb.h"
#include "noun.h"

// ID
// ºݤϰưǤġβսǤꡢȤϸ¤ʤ
// (֥åΥѥ饰դ˶ᤤ)
// ȶʤɤ˥ष֤ʤɤΰȤư

typedef enum {
    ai_invalid = -1,
    ai_begin = 0,
    ai_system_begin = 0,
    ai_title = 0,
    ai_game_over = 1,
	ai_ending = 2,
	ai_achievements = 3,
    ai_system_end = 4,

    ai_mailbox = 4,
    ai_entrance,
    ai_opened_window,
    ai_washtub,
    ai_backdoor,
    ai_under_tree,
    ai_garden,

    ai_entrance_hall,
    ai_corridor_1f_fl,
    ai_corridor_1f_bl,
    ai_corridor_1f_fr,
    ai_corridor_1f_mr,
    ai_corridor_1f_br,
    ai_bathroom,
    ai_dining,
    ai_kitchen,
    ai_laundry,
    ai_living,
    ai_guestroom_1f,
	ai_storage,
	ai_playroom,

    ai_landing,
    ai_corridor_2f_l,
    ai_corridor_2f_c,
    ai_corridor_2f_cr,
    ai_corridor_2f_r,
	
    ai_boys_room,
    ai_bed,
    ai_girls_room,
    ai_guestroom_2f,
    ai_study,
    ai_library,
    ai_bookshelf,
    ai_bedroom,
    ai_ladys_room,
    ai_wardrobe,
    ai_secret_room,
    ai_music_room,
    ai_bathroom_2f,
	ai_balcony,
	ai_balcony_down,

    ai_cellar,
    ai_boiler_room,
    ai_corridor_0f,
    ai_temple,
	ai_temple_ceiling,
	ai_cave_entrance, // @note פǡߴΤĤ
    ai_cave,
    ai_under_cliff,

    ai_working,
    ai_end
} area_id_t;



#define RedoArea(vid, nid) \
    return call_area(current_area(), vid, nid, exist)
#define DescribeArea     \
    describe_area(current_area())


void init_area(void);
void describe_area(area_id_t id);
int call_area(area_id_t id, verb_id_t vid, noun_id_t nid, int *exist);
void post_area(area_id_t id, int time_passed);
// post
void cancel_move(void);
void move_area(area_id_t id);
area_id_t new_area(void);
void update_current_area(void);
int is_area_discovered(area_id_t aid);
void draw_area(area_id_t id);

void move_to_title(void);
void move_to_ending(void);
void move_to_achievements(void);

int area_title(verb_id_t vid, noun_id_t nid, int *exist);
int area_game_over(verb_id_t vid, noun_id_t nid, int *exist);
int area_ending(verb_id_t vid, noun_id_t nid, int *exist);
int area_achievements(verb_id_t vid, noun_id_t nid, int *exist);
void update_achievements_complete_flags(void);

int area_mailbox(verb_id_t vid, noun_id_t nid, int *exist);
int area_entrance(verb_id_t vid, noun_id_t nid, int *exist);
int area_opened_window(verb_id_t vid, noun_id_t nid, int *exist);
int area_washtub(verb_id_t vid, noun_id_t nid, int *exist);
int area_backdoor(verb_id_t vid, noun_id_t nid, int *exist);
int area_under_tree(verb_id_t vid, noun_id_t nid, int *exist);
int area_garden(verb_id_t vid, noun_id_t nid, int *exist);

int area_entrance_hall(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_1f_fl(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_1f_bl(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_1f_fr(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_1f_mr(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_1f_br(verb_id_t vid, noun_id_t nid, int *exist);

int area_bathroom(verb_id_t vid, noun_id_t nid, int *exist);
int area_dining(verb_id_t vid, noun_id_t nid, int *exist);
int area_kitchen(verb_id_t vid, noun_id_t nid, int *exist);
int area_laundry(verb_id_t vid, noun_id_t nid, int *exist);
int area_living(verb_id_t vid, noun_id_t nid, int *exist);
void post_living(int time_passed);


int area_guestroom_1f(verb_id_t vid, noun_id_t nid, int *exist);
int area_storage(verb_id_t vid, noun_id_t nid, int *exist);
int area_playroom(verb_id_t vid, noun_id_t nid, int *exist);

int area_landing(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_2f_l(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_2f_c(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_2f_cr(verb_id_t vid, noun_id_t nid, int *exist);
void post_corridor_2f_cr(int time_passed);
int area_corridor_2f_r(verb_id_t vid, noun_id_t nid, int *exist);

int area_boys_room(verb_id_t vid, noun_id_t nid, int *exist);
int area_bed(verb_id_t vid, noun_id_t nid, int *exist);
int area_girls_room(verb_id_t vid, noun_id_t nid, int *exist);
int area_guestroom_2f(verb_id_t vid, noun_id_t nid, int *exist);
void post_guestroom_2f(int time_passed);
int area_study(verb_id_t vid, noun_id_t nid, int *exist);
void post_study(int time_passed);
int area_library(verb_id_t vid, noun_id_t nid, int *exist);
void post_library(int time_passed);
//void move_dragon_in_corridor_2f(void);
int area_bookshelf(verb_id_t vid, noun_id_t nid, int *exist);
int area_bedroom(verb_id_t vid, noun_id_t nid, int *exist);
int area_ladys_room(verb_id_t vid, noun_id_t nid, int *exist);
//void post_ladys_room(int time_passed);
int area_wardrobe(verb_id_t vid, noun_id_t nid, int *exist);
//void post_wardrobe(int time_passed);
int area_secret_room(verb_id_t vid, noun_id_t nid, int *exist);
int area_music_room(verb_id_t vid, noun_id_t nid, int *exist);
int area_bathroom_2f(verb_id_t vid, noun_id_t nid, int *exist);
int area_balcony(verb_id_t vid, noun_id_t nid, int *exist);
int area_balcony_down(verb_id_t vid, noun_id_t nid, int *exist);

int area_cellar(verb_id_t vid, noun_id_t nid, int *exist);
int area_boiler_room(verb_id_t vid, noun_id_t nid, int *exist);
int area_corridor_0f(verb_id_t vid, noun_id_t nid, int *exist);
int area_temple(verb_id_t vid, noun_id_t nid, int *exist);
void post_temple(int time_passed);
int area_temple_ceiling(verb_id_t vid, noun_id_t nid, int *exist);
int area_cave_entrance(verb_id_t vid, noun_id_t nid, int *exist);
int area_cave(verb_id_t vid, noun_id_t nid, int *exist);
int area_under_cliff(verb_id_t vid, noun_id_t nid, int *exist);


void gameover(void);
void game_clear(void);
void start_game(void);
void die(void);
void die_touching_water(void);
void die_touching_shadow(void);
void die_killed_by_armor(void);
void die_exiting_window(void);
void die_starved(void);
void die_tentacle(void);
int area_working(verb_id_t vid, noun_id_t nid, int *exist);

#endif
