#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_bathroom(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("äƱ¦ˤ%nl¦ˤ%nl롣", 
                    ni_washstand, ni_bathtub);
            message("ˤ%nl롣", ni_toilet);
            message("ظˤϭ³⤬롣");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(corridor_1f_fr, bathroom);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
			return 1;
		}
		break;
    case ni_wall:
        switch(vid){
        case vi_look:
        case vi_examine:
            if (Not(mirror_taken)){
                message("ξˤ%nl롣", ni_mirror);
            }
            else {
                message("%nnΤäˤʤˤ񤤤Ƥ롣", ni_mirror);
            }
            return 1;
        case vi_read:
            if (Is(mirror_taken)){
                msg_read_bathroom_1f_wall();
                Set(bathroom_1f_message_read);
                return 1;
            }
            break;
        default:
            break;
        }
        break;
    case ni_bathtub:
        switch(vid){
        case vi_look:
            message(noun_description(nid));
            if (Not(bathtub_empty)){
                message("ˤϡҤɤ%nlޤäƤ롣", ni_water);
                message("̤ˤϡ%nl⤫Ǥ롣", ni_rubber_duck);
                message("αˤϺ٤%nlդƤ롣",
                        ni_chain);
            }
            else {
                message("϶");
                if (!has_item(ni_rubber_duck)){
                    message("%nlžäƤ롣", ni_rubber_duck);
                }
                if (!has_item(ni_glasses)){
                    message("%nlžäƤ롣", ni_glasses);
                }
            }
            return 1;
        case vi_examine:
            message("ο򵤤ˤʤС弫ΤѤäȤϤʤ");
            return 1;
        case vi_enter:
            if (Is(bathtub_empty)){
                message("äƤߤ");
                return 1;
            }
            else {
                die_touching_water();
            }
            return 1;
        default:
            break;
		}
        break;
    case ni_water:
        if (Is(bathtub_empty)){
			*exist = 0;
			return 0;
		}
        switch(vid){
        case vi_look:
            message("줬ίޤäȤϻפʤ̾񤤿򤷤"
                    "ɽ̤ˤԵ̣ˢ⤫Ǥ롣");
            return 1;
        case vi_examine:
            message("ͤʿο̤򸫤ĤƤȡ"
                    "̤鷺ưƤ褦ʵƤ롣");
            return 1;
        case vi_get:
        case vi_touch:
            die_touching_water();
            return 1;
        default:
            break;
        }
        break;
    case ni_chain:
        switch(vid){
        case vi_look:
        case vi_examine:
			message(noun_description(nid));
            if (Not(bathtub_empty)){
                message("α狼˿첼äƤ롣");
            }
            else {
                message("˷ҤäƤ롣");
            }
            return 1;
        case vi_move:
            message("ñ˰ĥ줽");
            return 1;
        case vi_get:
            message("ꤵƤü򳰤Τ̵");
            return 1;
        case vi_pull:
            if (Not(bathtub_empty)){
                message("ȡݤ򤬳줿");
                message("ܤܤȷʲ򤿤Ƥơ"
                        "ޤο夬ӿ˵ۤޤƤ");
                message("ˤ᤭Τ褦ʲĤơ϶ˤʤä");
                Set(bathtub_empty);
            }
            else {
                message("⤦ĥäƤ̣ʤ");
            }
            return 1;
        default:
            break;
		}
        break;
    case ni_rubber_duck:
		if (has_item(ni_rubber_duck)){
			*exist = 0;
			return 0;
		}
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            if (Is(bathtub_empty)){
                message("ˤʤäžäƤ롣");
            }
            return 1;
        case vi_examine:
            msg_need_to_get();
            return 1;
        case vi_get:
            if (Is(bathtub_empty)){
                command_get_item(ni_rubber_duck, fi_duck_taken);
                return 1;
            }
            else {
                die_touching_water();
            }
            return 1;
        case vi_touch:
            if (Is(bathtub_empty)){
                msg_no_effect();
                return 1;
            }
            else {
                die_touching_water();
            }
            return 1;
        default:
            break;
		}
        break;
    case ni_glasses:
		if (has_item(ni_glasses) || Not(bathtub_empty)){
			*exist = 0;
			return 0;
		}
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            msg_need_to_get();
            return 1;
        case vi_get:
            command_get_item(ni_glasses, fi_glasses_taken);
            return 1;
        case vi_touch:
            msg_no_effect();
            return 1;
        default:
            break;
		}
        break;
    case ni_washstand:
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            if (Not(mirror_taken)){
                message("ξˤ%nl롣", ni_mirror);
            }
            return 1;
        case vi_examine:
        case vi_use:
            message("ظҤͤäƤϽФʤ");
            return 1;
        default:
            break;
		}
        break;
    case ni_mirror:
		if (Is(mirror_taken)){
			*exist = 0;
			return 0;
		}
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
        case vi_get:
            message("%nlɤ˸ꤵƤ롣", ni_screw);
            return 1;
        default:
            break;
        }
        break;
    case ni_screw:
		if (Is(mirror_taken)){
			*exist = 0;
			return 0;
		}
        switch(vid){
        case vi_examine:
        case vi_get:
        case vi_remove:
			message("äߤƤ롣ˤƻɬפ");
			return 1;
		default:
			break;
		}
        break;
    case ni_screwdriver:
        if (!has_item(nid)) ReturnNotExist;
        switch(vid){
        case vi_use:
            if (Is(mirror_taken)){
                message("⤦ΤϤʤ");
            }
            else {
                message("ͤ󤷤Ǥͤ򳰤");
                command_get_item(ni_mirror, fi_mirror_taken);
            }
            return 1;
		default:
			break;
		}
        break;
    case ni_toilet:
        switch(vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("С򲡤Ƥήʤ\\");
			if (Not(toilet_used)){
	            message("ش\\");
			}
            message("ⴥäƤ롣");
            return 1;
        case vi_use:
            if (Is(toilet_used)){
                message("ޤѤ­");
            }
            else {
                message("Ѥ­");
                Set(toilet_used);
			}
            return 1;
        default:
            break;
		}
        break;
    case ni_floor:
    case ni_ceiling:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}


