#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void bathroom_ghost(void);
void bathroom_ghost_end(void);

int area_bathroom_2f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("̤%nl%nl롣", 
                    ni_bathtub, ni_washstand);
            message("ظˤϲڼ³⤬롣");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(music_room, bathroom_2f);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
		break;
    case ni_wall:
        switch(vid){
        case vi_look:
            message("%nnξˤ%nlݤäƤ褦", 
                    ni_washstand, ni_mirror);
			return 1;
        case vi_examine:
			if (Is(bathroom_2f_ghost_seen)){
				TestAndSet(bathroom_2f_message_found,
						   "ͱƤؤĴ٤Ƥߤȡ"
						   "ɻ椬᤯졢β˾ʤˤ񤤤Ƥ롣",
						   "ɤʸʳѤäȤϤʤ");
	            return 1;
			}
            break;
		case vi_read:
			if (Is(bathroom_2f_message_found)){
				msg_read_bathroom_2f_wall();
                Set(bathroom_2f_message_read);
				return 1;
			}
			break;
        default:
            break;
        }
        break;
    case ni_floor:
        switch(vid){
        case vi_look:
        case vi_examine:
            message("%nnμ%nnҤФäƤ롣", 
                    ni_washstand, ni_mirror);
            return 1;
        default:
            break;
        }
        break;
    case ni_bathtub:
        switch(vid){
        case vi_look:
            message("֤ȸŤӤ%nn",
                    ni_bathtub);
            return 1;
        case vi_examine:
            message("϶ũĤäƤʤ");
            RedoArea(vi_use, ni_bathtub);
            return 1;
        case vi_use:
            message("ظҤͤäƤϽФʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_washstand:
        switch(vid){
        case vi_look:
            RedoArea(vi_look, ni_wall);
        case vi_examine:
        case vi_use:
            message("ظҤͤäƤϽФʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_mirror:
        switch(vid){
        case vi_look:
        case vi_examine:
            if (Not(mirror_put)){
                message("ʴ˳Ƥ롣");
                if (has_item(ni_mirror)){
                    message("긵ζϲƤʤ");
                }
            }
            else {
				// Υ٥Ȥϰ󤷤ʤ
				if (Not(bathroom_2f_ghost_seen)){
					bathroom_ghost();
				}
				else {
					message("⤦ˤϡθʤǤäƤʤ");
				}
            }
            return 1;
        case vi_get:
            if (Is(mirror_put)){
                // ե饰ΩƤʤΤǤget_item()
                message("ƤӼä");
                get_item(ni_mirror);
                Reset(mirror_put);
            }
            else {
                message("ҤǤΩˤʤ");
            }
            return 1;
        case vi_put:
            if (!has_item(ni_mirror)) ReturnNotExist;
            message("줿Τäˡ1Ἴζ֤Ƥߤ");
            lose_item(ni_mirror);
            Set(mirror_put);
            return 1;
        default:
            break;
        }
        break;
    case ni_ceiling:
    case ni_window:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void bathroom_ghost(void){
    message("֤Τȡ"
            "ʤظˤäȽλѤǤäƤ롣"
			"ɤΰؤθʻ򤳤˸Ƥ롣");
    Set(bathroom_ghost_appeared);
    set_wait_return_callback(bathroom_ghost_end);
}

void bathroom_ghost_end(void){
    message("䤬ƽλѤϡäȾäƤä");
    Reset(bathroom_ghost_appeared);
    Set(bathroom_2f_ghost_seen);
}
