#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void stop_cycrotron(void);

int area_boiler_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ܤˤϡȤʤ%nlդƤ롣",
					ni_machine);
            message("ظˤϡϲؤ³%nl롣",
                    ni_door);
            return 1;
		case vi_backward:
		case vi_exit:
            EnterDoor(cellar, boiler_room);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
	case ni_machine:
        switch (vid){
        case vi_look:
			message(noun_description(nid));
			return 1;
        case vi_examine:
			if (Is(cycrotron_activated)){
				message("㤤ӹ򤢤ưƤ롣");
			}
			else {
				message("ۤƤ롣");
			}
			message("̥ѥͥ%nwϡ褦ˤʤäƤ롣"
					"¦ˤ%nlꡢξˤ%nl롣",
					ni_panel, ni_round_door, ni_small_door);
			message("ˤֿп礭ʥܥ%nw%nw롣",
					ni_red_button, ni_green_button);
			return 1;
        case vi_destroy:
        case vi_hit:
        case vi_kick:
			message("褯狼ʤΤΤϤƤ");
			return 1;
        default:
            break;
        }
        break;
	case ni_panel:
        switch (vid){
        case vi_look:
			if (Is(cycrotron_panel_open)){
				message("ѥͥ򳫤ʬ顢Ȥ롣");
			}
			else {
				message("°̥ѥͥ");
			}
            return 1;
        case vi_examine:
			message("褦ˤʤäƤ롣");
			if (Is(cycrotron_panel_open)){
				message("ϡ¿%nlĥ餵Ƥ롣",
					    ni_cable);
			}
			return 1;
        case vi_open:
        case vi_pull:
			TestAndSet(cycrotron_panel_open, 
					   "ѥͥ򳫤",
					   "ѥͥϤ⤦Ƥ롣");
			return 1;
        case vi_close:
        case vi_push:
			TestAndReset(cycrotron_panel_open, 
					   "ѥͥĤ",
					   "ѥͥϤ⤦ĤƤ롣");
			return 1;
        default:
            break;
        }
        break;
	case ni_cable:
		if (Not(cycrotron_panel_open)) ReturnNotExist;
        switch (vid){
        case vi_look:
			if (Is(rubber_duck_put)){
				message("֥δ֤%nlǤ롣",
						ni_rubber_duck);
			}
			else {
				message("֥ΰܤ첼ꡢ"
						"륱֥ܿƤ롣");
			}
			return 1;
        case vi_examine:
			if (Is(rubber_duck_put)){
				message("硼ȤƤ֥%nl路Ƥ롣",
						ni_rubber_duck);
			}
			else {
				message("ܿƤ륱֥줬Ƥ롣"
						"ΤޤŤХ硼Ȥ");
			}
			return 1;
        default:
            break;
        }
        break;
	case ni_rubber_duck:
		if (!has_item(nid) && Not(rubber_duck_put)) ReturnNotExist;
		if (Not(cycrotron_panel_open)) ReturnNotExist;
		if (Not(rubber_duck_put)){
			if (vid == vi_put || vid == vi_use){
				message("%nn򶴤ǡ硼ȤƤ륱֥路", nid);
				Set(rubber_duck_put);
				lose_item(nid);
				return 1;
			}
			break;
		}
		else {
	        switch (vid){
		    case vi_look:
				message("֥δ֤˶Ǥ롣");
				return 1;
	        case vi_examine:
				message("硼ȤƤ֥路Ƥ롣");
				return 1;
//        case vi_get:
	        default:
		        break;
			}
		}
		break;
	case ni_round_door:
        switch (vid){
        case vi_look:
			message(noun_description(nid));
			return 1;
        case vi_examine:
			if (Not(cycrotron_round_door_open)){
				message("ü󤻤г");
			}
			else {
				message("ˤ϶°«Τ褦ʤΤäƤ롣");
			}
			return 1;
        case vi_open:
        case vi_pull:
			TestAndSet(cycrotron_round_door_open, 
					   "򳫤",
					   "Ϥ⤦Ƥ롣");
			if (Is(cycrotron_activated)){
				message("ǳפȽ񤫤줿פ\\");			
				stop_cycrotron();
			}
			return 1;
        case vi_close:
        case vi_push:
			TestAndReset(cycrotron_round_door_open, 
					   "Ĥ",
					   "Ϥ⤦ĤƤ롣");
			return 1;
        default:
            break;
        }
        break;
	case ni_small_door:
        switch (vid){
        case vi_look:
			message(noun_description(nid));
            return 1;
        case vi_examine:
			message("ü󤻤г");
			return 1;
        case vi_open:
        case vi_pull:
			TestAndSet(cycrotron_small_door_open, 
					   "򳫤",
					   "Ϥ⤦Ƥ롣");
			if (Is(cycrotron_activated)){
				message("ֿޡפȽ񤫤줿פ\\");			
				stop_cycrotron();
			}
		return 1;
        case vi_close:
        case vi_push:
			TestAndReset(cycrotron_small_door_open, 
					   "Ĥ",
					   "Ϥ⤦ĤƤ롣");
			return 1;
        default:
            break;
        }
        break;
	case ni_chicken_bone:
	case ni_human_bone:
        // äƤʤ(֤⤷Ƥʤ)ˤϤʤ
        if (!((nid == ni_chicken_bone) ?
              Is(chicken_bone_taken) : Is(human_bone_taken))){
            ReturnNotExist;
        }
		if (Not(cycrotron_small_door_open)) ReturnNotExist;
		if (Not(chicken_bone_put) && Not(human_bone_put)){
			if (vid == vi_put){
				message("%nn줿", nid);
                if (nid == ni_chicken_bone){
                    Set(chicken_bone_put);
                }
                else {
                    Set(human_bone_put);
                }
				lose_item(nid);
				return 1;
			}
			break;
		}
		else {
	        switch (vid){
		    case vi_look:
	        case vi_examine:
				message("˼ޤäƤ롣");
				return 1;
//        case vi_get:
	        default:
		        break;
			}
		}
		break;
	case ni_button:
		switch (vid){
		case vi_look:
			message("֤Ф礭ʥܥ%nw%nw",
                    ni_red_button, ni_green_button);
			return 1;
		case vi_push:
		case vi_hit:
            message("ܥʣ롣");
			return 1;
		default:
		    break;
		}
		break;
	case ni_red_button:
		switch (vid){
		case vi_look:
			message("ֿ礭ʥܥ");
			return 1;
		case vi_push:
		case vi_hit:
			// ǤʤѲʤ
			if (Not(cycrotron_activated)){
				msg_no_effect();
			}
			else {
				stop_cycrotron();
			}
			return 1;
		default:
		    break;
		}
		break;
	case ni_green_button:
		switch (vid){
		case vi_look:
			message("п礭ʥܥ");
			return 1;
		case vi_push:
		case vi_hit:
			// Ǥ˲ƯʤѲʤ
			if (Is(cycrotron_activated)){
				msg_no_effect();
			}
			// 硼ȤޤޤʤѲʤ
			else if (Not(rubber_duck_put)){
				msg_no_effect();
			}
			else {
				message("㤤ӹ겻ȶˡưФ\\");
				if ((Not(chicken_bone_put) && Not(human_bone_put)) ||
                    Is(cycrotron_small_door_open)){
					message("ֿޡפȽ񤫤줿פߤƤޤä");
				}
				else if (Is(cycrotron_round_door_open)){
					message("ǳפȽ񤫤줿פߤƤޤä");
				}
				else {
					message("");
					Set(cycrotron_activated);
				}
			}
			return 1;
		default:
		    break;
		}
		break;
	case ni_door:
		msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
			return 1;
		}
        break;
    case ni_wall:
        switch (vid){
		case vi_look:
		case vi_examine:
			message("񤤤Ƥ롣");
			return 1;
		case vi_read:
            msg_read_boiler_room_wall();
			Set(boiler_room_note_read);
			return 1;
        default:
            break;
        }
        break;
    case ni_ceiling:
        switch (vid){
		case vi_look:
			message("ӤѥפŷؤȷҤäƤ롣");
			return 1;
        default:
            break;
        }
        break;
    case ni_floor:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void stop_cycrotron(void){
	message("ưߤޤä");
	Reset(cycrotron_activated);
}

