#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_boys_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("äƱ¦ˤ%nlꡢ¦ˤ%nl롣", 
                    ni_bed, ni_treasure_chest);
            message("ظˤϭ³⤬롣");
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_2f_c, boys_room);
            return 1;
        case vi_up:
            message("ʥ٥åɤˤǤ夬äƤߤ뤫");
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    // ٥åɤ̼˰ۤʤΤΤ뤿ᡢ
    // ʥ٥åɸͭνϤ˽
    case ni_bed:
        switch(vid){
        case vi_look:
            message("ʥ٥åɤ\\");
            if (Not(ladder_taken)){
                message("%nlդƤ롣", ni_ladder);
            }
            else {
                message("");
            }
            return 1;
        case vi_examine:
            message("ʤˤʤ褦ġ");
            return 1;
        case vi_up:
            if (Not(ladder_taken)){
                RedoArea(vi_up, ni_ladder);
            }
            else {
                message("褸ФΤ񤷤");
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_ladder:
        if (has_item(ni_ladder)){
            if (vid == vi_put){
                message("%nn򸵤ᤷ", ni_ladder);
                lose_item(ni_ladder);
                Reset(ladder_taken);
                return 1;
            }
            else {
				*exist = 0;
                return 0;
            }
        }
        else {
			if (Is(ladder_taken)){
				*exist = 0;
				return 0;
			}
            switch (vid){
            case vi_examine:
                msg_nothing_special(); // msg_need_to_get򥪡Х饤
                return 1;
            case vi_get:
                command_get_item(ni_ladder, fi_ladder_taken);
                return 1;
            case vi_up:
                message("ҤФä");
                move_area(ai_bed);
                return 1;
            break;
            default:
                break;
            }
        }
        break;
    case ni_wooden_key:
        if (has_item(nid)){
            switch (vid){
            case vi_use:
				if (Not(treasure_chest_unlocked) && Not(treasure_chest_broken)){
					message("");
					Set(treasure_chest_unlocked);
					lose_item(nid);
				}
				else {
					message("⤦ϳݤäƤʤ");
				}
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
            ReturnNotExist;
		}
        break;
    case ni_treasure_chest:
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            if (Is(treasure_chest_opened)){
                message("϶");
            }
			if (Is(treasure_chest_moved) &&
	            Not(slingshot_taken))
		    {
			    message("ǽȢäȤˤϡ%nl",
	                    ni_slingshot);
		    }
            return 1;
        case vi_examine:
            message("礭ʸ꤬롣");
            return 1;
        case vi_get:
            msg_too_large();
            return 1;
        case vi_hit:
        case vi_kick:
        case vi_destroy:
            if (Is(treasure_chest_unlocked)){
                message("⤦ϳݤäƤʤ");
            }
            else if (Is(treasure_chest_broken)){
                message("⤦ϲƤ롣");
            }
            else {
				Set(treasure_chest_broken);
                message("á");
            }
            return 1;
        case vi_open:
            if (Not(treasure_chest_opened)){
                if (Is(treasure_chest_unlocked) || Is(treasure_chest_broken)){
                    message("Ȣ椫%nl%nlФƤ",
                            ni_box, ni_billiard_ball);
                    Set(treasure_chest_opened);
                }
                else {
                    message("ݤäƤ롣");
                }
            }
            else {
                message("ȢϤ⤦Ƥ롣");
            }
            return 1;
        case vi_close:
            TestAndReset(treasure_chest_opened,
                         "ȢĤ",
                         "ȢĤޤäƤ롣");
            return 1;
        case vi_move:
        case vi_push:
            TestAndSet(treasure_chest_moved,
                       "Ȣư",
                       "ȢϤ⤦ưƤ롣");
            return 1;
        default:
            break;
        }
        break;
    case ni_billiard_ball:
        ReturnIfHasItem;
        if (Is(billiard_ball_taken) ||
            Not(treasure_chest_opened))
        {
			ReturnNotExist;
		}
        switch (vid){
		case vi_get:
			command_get_item(nid, fi_billiard_ball_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_slingshot:
        ReturnIfHasItem;
        if (Is(slingshot_taken) ||
            Not(treasure_chest_moved))
        {
			ReturnNotExist;
		}
        switch (vid){
		case vi_get:
			command_get_item(nid, fi_slingshot_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_box:
        if (Not(treasure_chest_opened)) ReturnNotExist;
        switch (vid){
		case vi_look:
            message("ҶδȢ"
                    "äܥåȤĻ饤󷿤ΥᥫΤ볨Ƥ롣");
			return 1;
		case vi_examine:
		case vi_open:
            message("ȢȤ϶");
			return 1;
		case vi_get:
            message("ȢäƹԤäƤˤΩʤ");
            return 1;
		default:
			break;
		}
        break;
    case ni_floor:
        switch (vid){
		case vi_look:
			message("ξˤ\\");
			if (Not(treasure_chest_opened)){
		        message("%nl롣",
			            ni_treasure_chest);
			}
			else{
				if (Is(billiard_ball_taken)){
			        message("%nl%nl롣",
				            ni_treasure_chest, ni_box);
				}
				else {
			        message("%nl%nl%nl롣",
				            ni_treasure_chest, ni_box, ni_billiard_ball);
				}
			}
			if (Is(treasure_chest_moved) &&
	            Not(slingshot_taken))
		    {
			    message("ǽȢäȤˤϡ%nl",
	                    ni_slingshot);
		    }
        return 1;
		default:
			break;
		}
		break;
    case ni_wall:
    case ni_ceiling:
	case ni_window:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}
