#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

typedef enum {
    ap_begin, ap_man=ap_begin, ap_woman, ap_girl, ap_boy, ap_end
} avator_pos_t;

typedef struct {
    noun_id_t nid;
    flag_id_t fid;
    avator_pos_t pos;
} avator_info_t;

#define Avator(name, pos)  {ni_ ## name, fi_dining_ ## name ## _put, ap_ ## pos}

avator_info_t avator_infos[] = {
    //    {ni_glasses, fi_dining_glasses_put, ap_man},
    Avator(glasses, man),
    Avator(necklace, woman),
    Avator(plush_cat, girl),
    Avator(large_robot, boy),
    Avator(fishing_rod, man),
    Avator(bottle, woman),
    Avator(fossil, man),
    Avator(screwdriver, man),
    Avator(girl_doll, girl),
    Avator(witch_doll, girl),
    Avator(marble, boy),
    Avator(poker, man),
    Avator(toy_swordman, boy),
    Avator(toy_lion, boy),
    Avator(toy_bird, boy),
    Avator(robot, boy),
    Avator(toy_dragon, boy),
    Avator(billiard_ball, man),
    Avator(rubber_duck, man),
    Avator(slingshot, boy),
    Avator(ladder, man),
    Avator(diary, girl),
    Avator(score, girl),
    Avator(origami_plane, boy),
    Avator(essay, boy),
    Avator(paper, girl),
    Avator(lantern, man),
    Avator(mirror, woman),
    Avator(medal, girl),
};
#define AVATOR_INFO_NUM (sizeof(avator_infos)/sizeof(avator_info_t))
static flag_id_t avator_flags[] = {
    fi_dining_put_man,
    fi_dining_put_woman,
    fi_dining_put_girl,
    fi_dining_put_boy
};
flag_id_t correct_avators[] = {
    fi_dining_glasses_put,
    fi_dining_necklace_put,
    fi_dining_plush_cat_put,
    fi_dining_large_robot_put
};


void dining_move_backward(void);
avator_info_t *dining_get_avator_info(noun_id_t nid);
// ꤷХ֤ˤΤnid֤
// ʤni_invalid֤
noun_id_t get_avator_nid(avator_pos_t pos);
void dining_put_avator(noun_id_t nid);
int is_avator_put(noun_id_t nid);
// ХȤ֤줿ΤȤ
void dining_get_avator(noun_id_t nid);
void dining_look_chair(void);
void necromancy(void);
void necromancy_end(void);

int area_dining(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;

    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("%nlμ%nlĤ¤Ǥ롣",
	  				ni_table, ni_chair);
            message("ظȺ%nw%nw%nw롣",
                    ni_back_door, ni_left_door, ni_right_door);
            
            if (Is(hall_dining_door_opened)){
                message("ظϸإ̤ۡƤ롣");
            }
            if (Is(dining_living_door_opened) &&
                Is(dining_kitchen_door_opened))
            {
                message("ϡ줾줾֤̤Ƥ롣");
            }
            else if (Is(dining_living_door_opened)){
                message("¦ϵ֤̤Ƥ롣");
            }
            else if (Is(dining_kitchen_door_opened)){
                message("¦̤Ƥ롣");
            }
            return 1;
        case vi_backward:
			if (Not(hall_dining_door_unlocked)){
				msg_door_unlocked_by_opening();
		        Set(hall_dining_door_unlocked);
			}
		    EnterDoor(entrance_hall, hall_dining);
			return 1;
        case vi_left:
            EnterDoor(living, dining_living);
            return 1;
        case vi_right:
            EnterDoor(kitchen, dining_kitchen);
            return 1;
		case vi_pray:
			necromancy();
			return 1;
        default:
            break;
		}
		break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
	case ni_table:
        switch (vid){
    	case vi_look:
			if (Is(candle_lit)){
				message("ơ֥ξˤϡ򤷤ο郎¤Ǥ롣\\");
				if (Not(chicken_bone_taken)){
					message("λˤϡ%nlĤäƤ롣",
				     		ni_chicken_bone);
				}
				else {
					message("");
				}
			}
			else {
				message("ơ֥ξˤϿ郎¤ӡ줫鿩Ϥ褦ȤƤ뤫Τ褦");
			}
			if (Not(candle_taken)){
				message("ơ֥üοˤ%nlΩäƤ롣",
						ni_candle);
			}
            return 1;
		default:
			break;
		}
		break;
	case ni_chicken_bone:
		if (Not(candle_lit)) ReturnNotExist;
		if (has_item(nid)) ReturnNotExist;
        switch (vid){
    	case vi_get:
			command_get_item(nid, fi_chicken_bone_taken);
            return 1;
		default:
			break;
		}
		break;
	case ni_chair:
        switch(vid){
    	case vi_look:
            dining_look_chair();
            return 1;
        default:
            break;
        }
		break;
	case ni_chicken:
        if (has_item(nid)){
            switch(vid){
            case vi_put:
				command_put_item(nid, fi_chicken_put, NULL);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(chicken_put)){
				ReturnNotExist;
			}
            switch (vid){
            case vi_get:
                // ƼʤΤfi_chicken_takenϤǤON
                command_get_item(nid, fi_invalid);
                Reset(chicken_put);
                return 1;
            default:
                break;
            }
		}
        break;
    // ΰ
    case ni_glasses:         // δ
    case ni_necklace:        // ׿ͤΥͥå쥹
    case ni_large_robot:     // ˤλҤεܥå
    case ni_plush_cat:       // λҤΤ̤ߡ
    // ְä
    case ni_medal:           // Υ

	case ni_toy_swordman:    // ˤλҤεܥåȥѡ
    case ni_toy_lion:        // ˤλҤεܥåȥѡ
    case ni_toy_bird:        // ˤλҤεܥåȥѡ
    case ni_robot:           // ˤλҤεܥåȥѡ
    case ni_toy_dragon:      // ˤλҤεܥåȥѡ
    case ni_girl_doll:       // Ӥοͷߡ
    case ni_witch_doll:      // οͷߡ
    case ni_slingshot:       // Ѥ
    case ni_marble:          // ӡ̡Ѥ󤳤
    case ni_poker:           // Ф
	case ni_rubber_duck:     // Υҥ
    case ni_mirror:          // Ἴζ
    case ni_screwdriver:     // ͤ
    case ni_billiard_ball:   // ӥ䡼ɤζ
    case ni_origami_plane:   // Ե
	case ni_score:           // 
    case ni_fishing_rod:     // 
    case ni_ladder:          // ʥ٥åɤ
	case ni_bottle:          // 
    case ni_diary:           // !̼Ģ
    case ni_paper:           // !(̼ĢΥڡʬ򤷤Ե)
    case ni_lantern:         // 󥿥
	case ni_essay:           // !©Ҥκʸ()
    case ni_fossil:          // 


    // ֤ǽΤʤƥ
    //   Ǥ˻Ѻ
    //case ni_brass_key:       // ؤθ
    //   ɬ̤
    // ٥Ƚλޤ꤬ʤϲȱˤϹԤʤ
    //case ni_hat:             // 纴˹
    //case ni_belt:            // μ
    //case ni_amulet:          // ΰ
    // ٥ȸ˽и 
	//case ni_chicken_bone:    // ܤι

    //   СǤǤʤ
	//case ni_postcard:        // !纴鶵ؤս
	//case ni_logbook:         // !Ǹͤ
    //case ni_screw:           // ἼζΤͤΤȤꥢƥǤϤʤ
	//case ni_cuckoo:          // ĻܤؤäȷפΥå̤о

        if (has_item(nid)){
            switch(vid){
            case vi_put:
				dining_put_avator(nid);
                return 1;
            default:
                break;
            }
        }
		else {
			if (!is_avator_put(nid)){
				ReturnNotExist;
			}
            switch(vid){
            case vi_get:
                if (Is(candle_lit)){
                    message("⤦ɬפʤ");
                }
                else {
                    puts("get avator");
                    dining_get_avator(nid);
                }
                return 1;
            default:
                break;
            }
		}
		break;
    // 餫˰ǤϤʤ
    case ni_newspaper:       // ǽ餫äƤ뿷ʹڤȴ
    case ni_leaflet:         // ͹ؼΤ餷
    case ni_wooden_key:      // ΥߡθȢθ
    case ni_bronze_key:      // 2٤θ
	case ni_steel_key:       // ؤδθ
	case ni_golden_key:      // θ
    case ni_silver_key:      // ѻߥƥࡣ΢ʥꥪѡ
    case ni_branch:          // ԤڤλޡѤ󤳤
    case ni_rubber_strip:    // Ѥ󤳤Υɳ
    case ni_sponge:          // ݥ
	case ni_wastepaper:      // !
        if (has_item(nid)){
            switch(vid){
            case vi_put:
                message("ϴطʤ");
                return 1;
            default:
                break;
            }
        }
        else {
            ReturnNotExist;
        }
		break;
	case ni_candle:
		if (has_item(nid)){
		    switch (vid){
			case vi_put:
				message("Ϲᤷ");
				lose_item(ni_candle);
				Reset(candle_taken);
				return 1;
			default:
				break;
			}
		}
		else {
	        switch (vid){
			case vi_get:
				command_get_item(nid, fi_candle_taken);
				return 1;
			default:
				break;
			}
		}
		break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}


avator_info_t *dining_get_avator_info(noun_id_t nid){
    int i;
    for (i = 0 ; i < AVATOR_INFO_NUM ; i++){
        if (avator_infos[i].nid == nid){
            printf("avator found i=%d nid=%d fid=%d pos=%d\n", i, nid, avator_infos[i].fid, avator_infos[i].pos);
            return &avator_infos[i];
        }
    }
    assert(0); // ֤ΤˤĤƤΤߤδؿƤ֤Ϥ
    return NULL;
}

noun_id_t get_avator_nid(avator_pos_t pos){
    int i;
    for (i = 0 ; i < AVATOR_INFO_NUM ; i++){
        if (is_flag_on(avator_infos[i].fid) && avator_infos[i].pos == pos){
            //            printf("avator found i=%d nid=%d fid=%d pos=%d\n", i, nid, avator_infos[i].fid, avator_infos[i].pos);
            return avator_infos[i].nid;
        }
    }
    return ni_invalid;
}


void dining_put_avator(noun_id_t nid){
    avator_info_t *avator_info;

    avator_info = dining_get_avator_info(nid);
    assert(avator_info != NULL);

    if (is_flag_on(avator_flags[avator_info->pos])){
        message("Ǥ̤ΤΤ֤Ƥ롣");
        return;
    }
    command_put_item(nid, avator_info->fid, NULL);
    set_flag(avator_flags[avator_info->pos]);
    return ;
}

int is_avator_put(noun_id_t nid){
    avator_info_t *avator_info;

    avator_info = dining_get_avator_info(nid);
    assert(avator_info != NULL);

    printf("is_avator_put:%d\n", is_flag_on(avator_info->fid));

    return is_flag_on(avator_info->fid);
}

void dining_get_avator(noun_id_t nid){
    avator_info_t *avator_info;

    if (nid == ni_toy_swordman){
        Set(toy_swordman_taken);
    }

    avator_info = dining_get_avator_info(nid);
    assert(avator_info != NULL);

    reset_flag(avator_info->fid);
    reset_flag(avator_flags[avator_info->pos]);
    get_item(nid);
    message("%nnä", nid);
}

void dining_look_chair(void){
    int m=1, n, i;
    noun_id_t nid;

    message("4ӤΰػҤ롣\\");
    n = count_on_flags(4, 
                       fi_dining_put_man,
                       fi_dining_put_woman,
                       fi_dining_put_girl,
                       fi_dining_put_boy);
    //                message("%dĤΤΤ롣", n);
    switch (n){
    case 0:
        message("");
        break;
    case 1:
        for (i = ap_begin ; i < ap_end ; i++){
            if ((nid = get_avator_nid(i)) != ni_invalid) break;
        }
        assert(nid != ni_invalid);
        message("ػҤΰĤˤ%nl֤Ƥ롣", nid);
        break;
    case 2:
        for (i = ap_begin ; i < ap_end ; i++){
            if ((nid = get_avator_nid(i)) != ni_invalid){
                if (m == 1){
                    message("ػҤξˤ%nl\\", nid);
                    m++;
                }
                else {
                    message("%nl֤Ƥ롣", nid);
                    break;
                }
            }
        }
        break;
    case 3:
    case 4:
        message("ػҤξˤ\\");
        for (i = ap_begin ; i < ap_end ; i++){
            if ((nid = get_avator_nid(i)) != ni_invalid){
                if (m < n){
                    message("%nl\\", nid);
                    m++;
                }
                else {
                    message("%nl֤Ƥ롣", nid);
                    break;
                }
            }
        }
        break;
    default:
        assert(0);
    }
    return;
}
#ifdef DUMMY
            // !!! 󤶤ΤäƤΤɽ
			if (Not(toy_swordman_taken)){
				message("ػҤΰĤˤ%nläƤ롣",
						ni_toy_swordman);
			}
            else {
                message("ػҤξˤϤʤˤäƤʤ");
            }
			return 1;
		default:
			break;
		}
#endif


void necromancy(void){
    int i, avator_check = 0;

    for (i = 0 ; i < 4 ; i++){
        if (is_flag_on(correct_avators[i])){
            avator_check += (1 << i);
        }
    }
    printf("avator check value:%d\n", avator_check);

    switch (avator_check){
    case 1+2+4+8: // 
		if (Not(chicken_put)){
			message("ïʢѤͤ񤤤褦ʵ");
			return;
		}
		if (Is(candle_taken)){
			message("ï̵ǰί©ϳ餷");
			return;
		}
		// 桢äɽä
        for (i = 0 ; i < 4 ; i++){
            reset_flag(correct_avators[i]);
            //		Reset(necklace_put);
            //		Reset(plush_cat_put);
            //		Reset(large_robot_put);
        }
		Set(candle_lit);
		Set(ghost_appeared);
		message("ʤͤοͱƤƲäƤ");
		message("ǯ˽ȻҶ\\");
        if (Is(photo_checked)){
            message("̿Υ襷ζȤ");
        }
        else {
            message("ï");
        }
		message("餬ˤĤϹꡢ"
				"Ϥޤä"
				"ڤ˲ä路Ƥ褦"
				"餫ˤμԤǤϤʤϡʤˤʹʤ");
		set_wait_return_callback(necromancy_end);
        break;
    case 2+4+8:
		message("ˡΤ㤯褦ʹ롣");
        break;
    case 1+4+8:
		message("ˡΤ㤯褦ʹ롣");
        break;
    case 1+2+8:
		message("ˡΤ㤯褦ʹ롣");
        break;
    case 1+2+4:
		message("ˡǯΤ㤯褦ʹ롣");
        break;
    default:  // 夬2İʾ­
		message("ˡʣοͤ㤯褦ʹ롣");
        break;
    }
}
void necromancy_end(void){
    int i;

    message("䤬ƿȡ\\");
    if (Is(photo_checked)){
        message("׿\\");
    }
    else {
        message("\\");
    }
    message("ȻҶϿƲФƹԤä"
            "Ĥä\\");
    if (Is(photo_checked)){
        message("襷ζ\\");
    }
    else {
        message("\\");
    }
    message("ϲϹؤȡ"
            "ʻҤθɤä");


	// ϻĤ
    for (i = 0 ; i < 4 ; i++){
        set_flag(correct_avators[i]);
    }
    //	Set(glasses_put);
    //	Set(necklace_put);
    //	Set(plush_cat_put);
    //	Set(large_robot_put);
	// äƤݾƤѤ
	Reset(chicken_put);
	// ͩ
	Reset(ghost_appeared);
}
