#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_entrance(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("Ͻš%nwĤƤ롣", ni_door);
            if (Not(flowerpot_destroyed)){
                message("Ƥˤ%nl롣", ni_flowerpot);
            }
            else {
                message("Ƥˤ%nlλĳ롣", ni_flowerpot);
            }
            return 1;
        case vi_forward:
            message("⤬ĤޤäƤ롣");
            return 1;
        case vi_backward:
            move_area(ai_mailbox);
            return 1;
        case vi_left:
            move_area(ai_garden);
            return 1;
        case vi_right:
            move_area(ai_opened_window);
            return 1;
        default:
            break;
        }
        break;
    case ni_door:
        switch(vid){
        case vi_look:
            message("ʬΤ̵");
            return 1;
        case vi_examine:
            msg_nothing_special();
            return 1;
        case vi_open:
        case vi_push:
        case vi_pull:
            if (Is(entrance_unlocked)){
                message("Ť򳫤ƲƧ߹");
                message("Х󡣿Ƨ߽Фȡ"
                            "ظ⤬礭ʲΩƤĤޤä");
                Set(entered_house);
                move_area(ai_entrance_hall);
            }
            else {
                message("ݤäƤƤӤȤ⤷ʤ");
            }
            return 1;
        case vi_close:
            message("ǽ餫ĤޤäƤ롣");
            return 1;
        case vi_hit:
            message("áƤߤïʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_flowerpot:
        switch(vid){
        case vi_look:
            if (Is(flowerpot_destroyed)){
                message("դȭλĳ");
                if (!has_item(ni_brass_key)){
                    message("ĳ%nl롣", ni_brass_key);
                }
            }
            else {
                message("ǾƤοȭ"
                        "ƤʪϸϤƤޤäƤ롣"
						"ĤƤϱ¦ˤĤä餷"
						"ҤФäƤ롣");
            }
            if ((Is(flowerpot_moved) ||
				 Is(flowerpot_destroyed)) &&
                 !has_item(ni_wooden_key))
            {
                message("ȭΤäȤ%nlƤ롣", 
                        ni_wooden_key);
            }
            return 1;
        case vi_get:
            if (Is(flowerpot_destroyed)){
                message("ǤʴˤʤäƤ롣");
            }
            else {
                message("äƹԤˤϽŤ롣");
            }
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            if (Is(flowerpot_moved)){
                message("ȭϤ⤦ưƤ롣");
            }
			else if (Is(flowerpot_destroyed)){
                message("⤦ʴ");
			}
            else {
                message("ȭβ%nlФƤ", ni_wooden_key);
                Set(flowerpot_moved);
            }
            return 1;
        case vi_destroy:
        case vi_hit:
        case vi_kick:
            TestAndSet(flowerpot_destroyed,
                       "󡣿ȭá",
                       "ȭϤǤ˲Ƥ롣");
            return 1;
        default:
            break;
        }
        break;
    case ni_brass_key:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
                TestAndSet(entrance_unlocked,
                           MSG_DOOR_UNLOCKED,
                           MSG_DOOR_ALREADY_UNLOCKED);
                lose_item(nid);
                return 1;
            default:
                break;
            }
            return 0;
        } 
        if (Is(flowerpot_destroyed)){
            switch(vid){
            case vi_look:
                message(noun_description(nid));
                return 1;
            case vi_get:
                command_get_item(ni_brass_key, fi_brass_key_taken);
                return 1;
            default:
                break;
            }
        }
        else { // ȭ˲Ƥʤ
            *exist = 0;
        }
        break;
    case ni_wooden_key:
        if (has_item(ni_wooden_key)){
            switch(vid){
            case vi_use:
                msg_key_unmatched();
                return 1;
            default:
                break;
            }
			*exist = 0;
            return 0;
        } 
        if ((Is(flowerpot_moved) ||
             Is(flowerpot_destroyed)))
        {
            switch(vid){
            case vi_look:
                message(noun_description(nid));
                return 1;
            case vi_get:
                command_get_item(ni_wooden_key, fi_wooden_key_taken);
                return 1;
            default:
                break;
            }
        }
        else { // ȭưƤʤ
			*exist = 0;
        }
        break;
    case ni_house:
    case ni_wall:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}
