#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_entrance_hall(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("ظˤϸؤ%nw"
                    "̤Ⱥˤ⤽줾%nw%nw%nw롣",
                    ni_back_door, ni_front_door, ni_left_door, ni_right_door);
            if (Is(hall_dining_door_opened)){
                message("̤θˤϿƲ롣");
            }
            if (Is(hall_right_door_opened) &&
                Is(hall_left_door_opened))
            {
                message("θˤϭ³Ƥ롣");
            }
            else if (Is(hall_left_door_opened)){
                message("θˤϭ³Ƥ롣");
            }
            else if (Is(hall_right_door_opened)){
                message("θˤϭ³Ƥ롣");
            }
            message("ʤ󳬤ؤ³Ƥ롣");
            return 1;
        case vi_backward:
            message("ؤϸǤĤƤ롣");
            return 1;
        case vi_forward:
            if (Is(hall_dining_door_unlocked)){
                EnterDoor(dining, hall_dining);
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_right:
            if (Is(hall_right_door_unlocked)){
                EnterDoor(corridor_1f_fr, hall_right);
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_left:
            EnterDoor(corridor_1f_fl, hall_left);
            return 1;
        case vi_up:
            move_area(ai_landing);
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
        }
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
        }
        break;
    case ni_back_door:
        switch(vid){
        case vi_look:
            message("ʬΤ̵");
            return 1;
        case vi_examine:
            message("ϤäƤʤΤ˳ʤ");
            return 1;
        case vi_open:
        case vi_push:
        case vi_pull:
        case vi_close:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
        case vi_touch:
            message("ؤϸǤĤƤ롣");
            return 1;
        default:
            break;
        }
        break;
    case ni_stairs:
        if (vid == vi_up || vid == vi_use){
            RedoArea(vi_up, ni_invalid);
        }
        break;
    case ni_brass_key:
		// ˤʤ鿿﫤θɬäƤΤǥåϾά
		switch(vid){
        case vi_use:
            message("ؤθϤǤ˳Ƥ");
            return 1;
        default:
            break;
        }
    default:
	    *exist = 0;
        break;
    }
    return 0;
}

