#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_guestroom_1f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ɺݤˤϤ줾%nl%nl롣"
                    "ˤ%nl%nl롣",
					ni_cabinet, ni_bed, ni_table, ni_chair);
            //			message("ˤϰѤ%nl%nl%nl롣",
            //					ni_bed, ni_chair, ni_cabinet);
            message("ظˤϭ³⤬롣");
//            if (Is(dragon_guestroom_1f) && Not(dragon_shotdown)){
            if (Is(dragon_in_guestroom_1f)){
                message("ŷ᤯ˡ%nl⤤Ƥ롣",
                        ni_toy_dragon);
            }
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_1f_fl, guestroom_1f);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
	case ni_cabinet:
		switch (vid){
		case vi_look:
            if (Is(guestroom_1f_cabinet_opened)){
                message("϶");
                return 1;
            }
            break;
		case vi_open:
            if (Is(guestroom_1f_table_moved)){
                message("%nn", ni_table);
                return 1;
            }
            if (Not(guestroom_1f_cabinet_opened)){
                message("%nn򳫤", ni_cabinet);
                Set(guestroom_1f_cabinet_opened);
            }
            else {
                message("%nnϤ⤦Ƥ롣", ni_cabinet);
            }
            return 1;
		case vi_close:
            if (Is(guestroom_1f_table_moved)){
                message("%nn", ni_table);
                return 1;
            }
            if (Is(guestroom_1f_cabinet_opened)){
                message("%nnĤ᤿", ni_cabinet);
                Reset(guestroom_1f_cabinet_opened);
            }
            else {
                message("%nnĤƤ롣", ni_cabinet);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
        default:
            break;
        }
        break;
    case ni_toy_dragon:
//        if (Not(dragon_guestroom_1f) || Is(dragon_shotdown)) ReturnNotExist;
//        if (Not(dragon_guestroom_1f)) ReturnNotExist;
        if (Not(dragon_in_guestroom_1f) && Not(dragon_shotdown)) ReturnNotExist;
        if (Is(dragon_taken)) ReturnNotExist;
        switch(vid){
        case vi_look:
            if (Not(dragon_shotdown)){
                message("ѤѤư⤫Ǥ롣"
                        "­ˤ%nlϤǤ롣",
                        ni_golden_key);
            }
            else {
                message("ξžäƤ롣");
            }
            return 1;
        case vi_examine:
            if (Not(dragon_shotdown)){
                message("ɤƤ⤿δ"
                        "ʤǤ롣");
            }
            else {
                message("⤦ԤȤưʤ");
            }
            return 1;
        case vi_get:
            if (Not(dragon_shotdown)){
                message("ѤѤưϤʤ⤵⤤Ƥ롣");
            }
            else {
                command_get_item(nid, fi_dragon_taken);
            }
            return 1;
        case vi_hit:
        case vi_kick:
        case vi_fight:
        case vi_destroy:
            if (Not(dragon_shotdown)){
                message("Ǽǹ⤷褦ȤƤϤʤ");
            }
            else {
                message("ɤƤ򤫤ɬפϤʤ");
            }
            return 1;
		case vi_shoot:
			RedoArea(vi_use, ni_slingshot);
        default:
            break;
        }        
        break;
    case ni_golden_key:
//        if (Not(dragon_guestroom_1f) || Not(dragon_shotdown)) ReturnNotExist;
//        if (Not(dragon_guestroom_1f)) ReturnNotExist;
        if (Not(dragon_in_guestroom_1f) && Not(dragon_shotdown)) ReturnNotExist;
        if (Is(golden_key_taken)) ReturnNotExist;
        switch(vid){
        case vi_look:
            if (Not(dragon_shotdown)){
                message("%nn­Ϥޤ⤤Ƥ롣",
                        ni_toy_dragon);
            }
            else {
                message("ξžäƤ롣");
            }
            return 1;
        case vi_get:
            if (Not(dragon_shotdown)){
                message("Ϥʤ⤵⤤Ƥ롣");
            }
            else {
                command_get_item(nid, fi_golden_key_taken);
            }
            return 1;
        case vi_hit:
        case vi_destroy:
            if (Not(dragon_shotdown)){
                message("ǼǤȤΤ̵");
            }
            else {
                message("ɤƤ򤫤ɬפϤʤ");
            }
            return 1;
        default:
            break;
        }        
        break;
    case ni_slingshot:
        if (!has_item(nid)) ReturnNotExist;
        switch(vid){
        case vi_use:
            if (Is(dragon_shotdown)){
                message("⤦ȤΤϤʤ");
	            return 1;
            }
            else if (Is(dragon_in_guestroom_1f)){
                if (Is(slingshot_repaired) && Has(marble)){
                    message("%nn%nnĤȸ%nn̿椷",
                            ni_slingshot,
                            ni_marble,
                            ni_toy_dragon
                            );
	                proceed_flag_sequence(fs_dragon);
		            lose_item(ni_marble);
		            lose_item(ni_slingshot);
		            return 1;
                }
            }
			break;
        default:
            break;
        }
        break;
	case ni_table:
        switch (vid){
        case vi_move:
            if (Not(guestroom_1f_table_moved)){
                message("%nnư",
                        ni_table);
                Set(guestroom_1f_table_moved);
            }
            else {
                message("%nn򸵤ξᤷ",
                        ni_table);
                Reset(guestroom_1f_table_moved);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
	    default:
		    break;
        }
        break;
	case ni_chair:
        switch (vid){
        case vi_move:
            if (Not(guestroom_1f_chair_moved)){
                message("%nnư",
                        ni_chair);
                Set(guestroom_1f_chair_moved);
            }
            else {
                message("%nn򸵤ξᤷ",
                        ni_chair);
                Reset(guestroom_1f_chair_moved);
            }
            return 1;
        case vi_up:
            if (Is(dragon_in_guestroom_1f)){
                message_dragon_too_high(nid);
                return 1;
            }
            break;
	    default:
		    break;
        }
        break;
    case ni_floor:
        if (Is(dragon_shotdown)){
            if (Not(dragon_taken) && Not(golden_key_taken)){
                message("%nl%nlƤ롣", ni_toy_dragon, ni_golden_key);
            }
            else if (Not(dragon_taken)){
                message("%nlƤ롣", ni_toy_dragon);
            }
            else if (Not(golden_key_taken)){
                message("%nlƤ롣", ni_golden_key);
            }
            else {
                msg_nothing_any_more();
            }
        }
        else {
            msg_nothing_special();
        }
		break;
    case ni_ceiling:
    case ni_wall:
	case ni_window:
	case ni_bed:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

