#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void guestroom_2f_upset_armor(void);
//void return_armor_in_guestroom(void);

int area_guestroom_2f(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;

    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            //            if (Is(armor_in_guestroom)){
            //                msg_armor_standing();
            //            }
			message("ɺݤˤϤ줾%nl%nl롣"
                    "ˤ%nl%nl롣",
					ni_cabinet, ni_bed, ni_table, ni_chair);
            message("ظˤϭ³⤬롣");
            return 1;
        case vi_backward:
        case vi_exit:
            EnterDoor(corridor_2f_l, guestroom_2f);
            //            return_armor_in_guestroom();
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    case ni_wall:
        switch (vid){
        case vi_look:
            if (Not(portrait_removed)){
                message("ɤˤ%nlݤäƤ롣",
                        ni_portrait);
            }
            else {
                message("ʤʤä顢夤롣");
            }
			return 1;
        default:
            break;
        }
        break;
	case ni_cabinet:
		switch (vid){
		case vi_look:
            if (Is(guestroom_2f_cabinet_opened)){
                //                message("%nläƤ", ni_note);
                message("%nl%nläƤ롣", 
                        ni_bottle, ni_sponge);
                return 1;
            }
            break;
		case vi_open:
			guestroom_2f_upset_armor();
            if (Not(guestroom_2f_table_moved)){
                message("%nn", ni_table);
                return 1;
            }
            if (Not(guestroom_2f_cabinet_opened)){
                message("%nn򳫤", ni_cabinet);
                Set(guestroom_2f_cabinet_opened);
            }
            else {
                message("%nnϤ⤦Ƥ롣", ni_cabinet);
            }
            return 1;
		case vi_close:
            if (Not(guestroom_2f_table_moved)){
                message("%nn", ni_table);
                return 1;
            }
            if (Is(guestroom_2f_cabinet_opened)){
                message("%nnĤ᤿", ni_cabinet);
                Reset(guestroom_2f_cabinet_opened);
            }
            else {
                message("%nnĤƤ롣", ni_cabinet);
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_bottle:
        ReturnIfHasItem;
        if (Not(guestroom_2f_cabinet_opened)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_bottle_taken);
			guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_sponge:
        ReturnIfHasItem;
        if (Not(guestroom_2f_cabinet_opened)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_sponge_taken);
			guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
	case ni_portrait:
		switch (vid){
		case vi_look:
			message("ΤäȸĤƤ褦˴롣");
			return 1;
		case vi_examine:
			message("Ťեåɤ˳ݤƤ롣");
			return 1;
		case vi_move:
			message("ݤƤʤΤǡñ˳");
			return 1;
		case vi_remove:
		case vi_turn:
            Set(portrait_has_removed);
            TestAndSet(portrait_removed,
                       "ɤ鳰΢֤֤",
                       "Ϥ⤦Ƥ롣");
			return 1;
		case vi_get:
			msg_too_large();
			return 1;
		case vi_put:
            TestAndReset(portrait_removed,
                         "ޤɤ˳ݤ",
                         "ɤ˳ݤäƤ롣");
            return 1;
	    default:
		    break;
		}
		break;
    case ni_table:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("ơ֥ξˤ%nlѤޤƤ롣", ni_book);
            return 1;
        case vi_move:
            if (Not(guestroom_2f_table_moved)){
                if (Not(guestroom_2f_book_moved)){
                    message("˾äƤ%nn", ni_book);
                    return 1;
                }
                if (Not(guestroom_2f_chair_moved)){
                    message("%nn", ni_chair);
                    return 1;
                }
                message("%nnαư",
                        ni_table);
                Set(guestroom_2f_table_moved);
				guestroom_2f_upset_armor();
            }
            else {
                // ᤹⡢ػҤˤȼ
                if (Not(guestroom_2f_chair_moved)){
                    message("%nn", ni_chair);
                    return 1;
                }
                message("%nn򸵤ξᤷ",
                        ni_table);
                Reset(guestroom_2f_table_moved);
            }
            return 1;
	    default:
		    break;
        }
        break;
	case ni_chair:
        switch (vid){
        case vi_move:
            if (Not(guestroom_2f_chair_moved)){
                message("%nnαư",
                        ni_chair);
                Set(guestroom_2f_chair_moved);
				guestroom_2f_upset_armor();
            }
            else {
                message("%nn򸵤ξᤷ",
                        ni_chair);
                Reset(guestroom_2f_chair_moved);
            }
            return 1;
	    default:
		    break;
        }
        break;
	case ni_book:
        switch (vid){
        case vi_look:
            message("ؽ񤬲ѤǤ롣");
            return 1;
        case vi_examine:
            message("褯Ȱ%nlΤ褦", ni_logbook);
            Set(logbook_found);
            return 1;
        case vi_read:
            message("Τ褦äѤǤʤ");
            return 1;
        case vi_get:
            message("äƹԤäƤ⡢Ωˤʤ");
            return 1;
        case vi_remove:
        case vi_move:
            if (Not(guestroom_2f_book_moved)){
                message("%nn%nnξˤɤ",
                        ni_book, ni_cabinet);
                Set(guestroom_2f_book_moved);
				guestroom_2f_upset_armor();
            }
            else {
                // ơ֥ΰ֤ˤäᤷΥեå2ѰդΤ
                // ݤʤΤǡ᤻ʤ褦ˤ
                message("%nnϤ⤦ɤƤ롣",
                        ni_book);
                /*
                message("%nn%nnξᤷ",
                        ni_book, ni_table);
                Reset(guestroom_2f_book_moved);
                */
            }
            return 1;
	    default:
		    break;
        }
        break;
    case ni_logbook:
        ReturnIfHasItem;
        //        if (Not(logbook_found) || Is(logbook_taken)){
        if (Not(logbook_found)){
			ReturnNotExist;
		}
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("ǸϿΤ褦");
            guestroom_2f_upset_armor();
            return 1;
        case vi_get:
            //            command_get_item(nid, fi_logbook_taken);
            //			guestroom_2f_upset_armor();
            msg_no_need_to_carry();
            return 1;
        case vi_read:
            msg_read_logbook();
            Set(logbook_read);
            guestroom_2f_upset_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_armor:
        if (Not(armor_in_guestroom)) ReturnNotExist;
        switch (vid){
        case vi_look:
        case vi_examine:
            msg_look_standing_armor();
            return 1;
        default:
            break;
        }
        break;
    case ni_sword:
        if (Not(armor_in_guestroom)) ReturnNotExist;
        switch (vid){
        case vi_look:
            msg_look_standing_armor_sword();
            return 1;
        case vi_examine:
        case vi_touch:
        case vi_get:
            return 1;
        default:
            break;
        }
        break;
    case ni_floor:
    case ni_ceiling:
    case ni_window:
	case ni_bed:
		break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

void guestroom_2f_upset_armor(void){
	if (Not(portrait_removed) && Not(portrait_eyes_right) &&
		Not(armor_dead) && NotActive(armor_to_guestroom))
        //		Not(armor_dead) && Not(start_armor_to_guestroom))
	{
        // åϥޥɤؤΥåθǽФΤǡե饰åȤΤ
        start_flag_sequence(fs_armor_to_guestroom);
        if (IsActive(armor_from_guestroom)){
            // ʤ顢ؤФեФ
            if (Is(armor_moving_from_guestroom)){
                printf("armor moving to study!!!!\n");
                jump_flag_sequence(fs_armor_to_guestroom, 
                                   //                                   fi_armor_moving_to_guestroom);
                                   fi_armor_in_guestroom);
            }
            clear_flag_sequence(fs_armor_from_guestroom);
        }
	}
}


void post_guestroom_2f(int time_passed){
    if (!time_passed) return;

    // ܤư
    Toggle(portrait_eyes_right);
    /* 
   // ٥
    if (Is(armor_in_guestroom) && Staying(guestroom_2f)){
        die_killed_by_armor();
    }
    */
}


    /*
void return_armor_in_guestroom(void){
    clear_flag_sequence(fs_armor_to_guestroom);
    start_flag_sequence(fs_armor_from_guestroom);
    // ФȡƵ
    if (Is(armor_to_guestroom) || Is(armor_in_guestroom)){
        Reset(guestroom_2f_chair_moved);
        Reset(guestroom_2f_book_moved);
        Reset(guestroom_2f_table_moved);
        Reset(guestroom_2f_cabinet_opened);
        Reset(start_armor_to_guestroom);
        Reset(armor_to_guestroom);
        Reset(armor_in_guestroom);
    }
}
*/
