#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_kitchen(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("̤ˤ%nlꡢκ%nl%nl롣",
				    ni_counter, ni_cupboard, ni_icebox);
            message("%nw%nw롣",
                    ni_left_door, ni_right_door);
            if (Is(dining_kitchen_door_opened) &&
                Is(kitchen_corridor_door_opened))
            {
                message("Ϥ줾쿩Ʋϭ̤Ƥ롣");
            }
            else if (Is(dining_kitchen_door_opened)){
                message("¦ϿƲ̤Ƥ롣");
            }
            else if (Is(kitchen_corridor_door_opened)){
                message("¦ϭ̤Ƥ롣");
            }
            return 1;
        case vi_left:
            EnterDoor(dining, dining_kitchen);
            return 1;
        case vi_right:
            EnterDoor(corridor_1f_br, kitchen_corridor);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_counter:
        switch (vid){
        case vi_look:
            message("%nl%nlդƤ롣",
                    ni_sink, ni_range);
            return 1;
        default:
            break;
        }
        break;
    case ni_sink:
        switch (vid){
        case vi_use:
            message("ظҤͤäƤϽФʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_range:
        switch (vid){
        case vi_look:
            message("β%nl¢Ƥ롣",
                    ni_oven);
            return 1;
        case vi_use:
            message("ϤĤʤƤʤ褦");
            return 1;
        default:
            break;
        }
        break;
    case ni_oven:
        switch (vid){
    	case vi_look:
    	case vi_examine:
			if (Is(oven_opened)){
				if (Not(chicken_taken)){
					message("֥%nl롣", ni_chicken);
				}
				else {
					message("֥ˤϡ⤦ʤ");
				}
				return 1;
			}
			else {  // ĤޤäƤʤǥեȤlook
				return 0;
			}
            break;
        case vi_use:
            message("֥ϤĤʤ̤Ƥʤ褦");
            return 1;
        case vi_open:
            TestAndSet(oven_opened,
                       "֥򳫤",
                       "֥Ϥ⤦Ƥ롣");
            return 1;
        case vi_close:
            TestAndReset(oven_opened,
                         "֥Ĥ",
                         "֥ĤޤäƤ롣");
            return 1;
        default:
            break;
        }
        break;
	case ni_chicken:
		if (Is(chicken_taken)){
			*exist = 0;
			return 0;
		}
		if (Is(oven_opened)){
	        switch(vid){
			case vi_get:
                command_get_item(ni_chicken, fi_chicken_taken);
				return 1;
	        default:
	            break;
	        }
		}
		else { // ֥󤬳Ƥʤ
			*exist = 0;
		}
		break;
    case ni_icebox:
        switch (vid){
        case vi_examine:
            message("䤨Ƥʤŵ̤Ƥʤ褦");
            return 1;
        case vi_open:
            message("ˤϴӤڶ餤ʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_cupboard:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("οʴ˳ƤޤäƤ롣");
            return 1;
        case vi_open:
            message("ˤϻȤʤΤϤʤ");
            return 1;
        default:
            break;
        }
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}

