#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void enter_2f(void);
void moved_on_2f(void);

int area_landing(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("̤ˤ⤬\\");
            if (Is(landing_door_opened)){
                message("ꡢθǤϺϭӤƤ롣");
            }
            else {
                message("롣");
            }
            message("ˤϰ쳬˲볬ʤ롣");
            return 1;
        case vi_forward:
            if (Is(landing_door_unlocked)){
                enter_2f();
            }
            else {
                msg_door_locked();
            }
            return 1;
        case vi_right:
        case vi_left:
        case vi_down:
            move_area(ai_entrance_hall);
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
        break;
    case ni_door:
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
		}
		break;
    case ni_stairs:
        if (vid == vi_down || vid == vi_use){
            RedoArea(vi_down, ni_invalid);
        }
        break;
    case ni_bronze_key:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
                if (Not(landing_door_unlocked)){
                    msg_door_unlocked();
                    Set(landing_door_unlocked);
                    lose_item(nid);
                }
                else {
                    msg_door_already_unlocked();
                }
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			*exist = 0;
		}
        break;
    case ni_brass_key:
    case ni_wooden_key:
    case ni_steel_key:
    case ni_golden_key:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
                msg_key_unmatched();
                return 1;
            default:
                break;
            }
            return 0;
        } 
		else {
			ReturnNotExist;
		}
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

void enter_2f(void){
    if (Not(attacked_on_2f)){
        msg_attacked_on_2f();
        set_wait_return_callback(moved_on_2f);
    }
    else {
        enter_door(ai_corridor_2f_c, fi_landing_door_opened);
    }
}

void moved_on_2f(void){
    msg_moved_on_2f();
    move_area(ai_study);
    Set(attacked_on_2f);
    update_current_area();
}
