#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int describe_rods(void);
void msg_dog_growl(void);
int command_callback_talk_dog(char *line);

int area_laundry(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("̤ظ%nw%nw롣\\",
                    ni_front_door, ni_back_door);
            if (Is(dog_stood_up)){
                message("ˤ%nl롣\\",
                        ni_hatch);
            }
            message("ظϭ\\");
            if (Is(laundry_cellar_door_opened)){
                message("Υϥåϲˡ줾\\");
            }
            message("³Ƥ롣");
            message("¦ˤ%nl%nl롣",
                    ni_washer, ni_dryer);
            if (Not(dog_stood_up)){
                message("¦ˤ%nl¤äƤ롣", ni_dog);
            }
            else if (Not(dog_gone)){
                message("ˤ%nlΩäƤ롣", ni_dog);
            }
            return 1;
        case vi_forward:
            message("ϳ줽ˤʤ");
            return 1;
        case vi_backward:
            EnterDoor(corridor_1f_br, laundry_corridor);
            return 1;
        case vi_down:
            if (Is(dog_stood_up)){
                if (has_light()){
#ifndef DEBUG
                    Set(save_forbidden);
#endif
                    EnterDoor(cellar, laundry_cellar);
                }
                else {
                    msg_no_light();
                }
            }
            else {
                msg_dog_growl();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
        switch (vid){
        case vi_look:
            message("¦ĤǤĤƤ롣");
            return 1;
        case vi_open:
        case vi_push:
        case vi_pull:
        case vi_destroy:
        case vi_examine:
            message("ŤƤ롣򳫤Τ̵");
            return 1;
        default:
            break;
        }
        break;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
			return 1;
		}
        break;
    case ni_hatch:
        switch (vid){
        case vi_look:
            message("ؤΤ褦");
            return 1;
        case vi_examine:
			if (Is(dog_stood_up)){
                message("ǳñʥϥå"
                        "βˤϲؤγʤ褦");
			}
			else {
                msg_dog_growl();
			}
            return 1;
        case vi_open:
        case vi_enter:
        case vi_pull:
            RedoArea(vi_down, ni_invalid);
			return 1;
        default:
            break;
        }
        break;
    case ni_washer:
        switch (vid){
        case vi_look:
			if (Is(washer_opened)){
	            message("ˤ%nl켰äƤ롣",
					    ni_clothes);
                describe_rods();
			}
			else {
                message("դ줿ư");
                describe_rods();
			}
            return 1;
		case vi_examine:
			if (Is(washer_opened)){
	            message("ˤ%nl켰äƤ롣",
					    ni_clothes);
			}
			else {
				message("äƤ褦");
			}
            return 1;
        case vi_open:
			if (Not(washer_opened)){
				message("%nnγ򳫤", ni_washer);
				Set(washer_opened);
			}
			else {
				message("%nnγϤ⤦Ƥ", ni_washer);
			}
			return 1;
        case vi_close:
			if (Is(washer_opened)){
				message("%nnγĤ᤿", ni_washer);
				Reset(washer_opened);
			}
			else {
				message("%nnγĤޤäƤ", ni_washer);
			}
			return 1;
        case vi_use:
            message("Ÿʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_dryer:
        switch (vid){
        case vi_look:
			if (Is(dryer_opened)){
	            message("϶");
			}
			else {
                message("դ줿ưδ絡");
			}
            return 1;
		case vi_examine:
			if (Is(dryer_opened)){
	            message("äƤʤ");
			}
			else {
                message("äƤʤ褦");
			}
            return 1;
        case vi_open:
			if (Not(dryer_opened)){
				message("%nnγ򳫤", ni_dryer);
				Set(dryer_opened);
			}
			else {
				message("%nnγϤ⤦Ƥ", ni_dryer);
			}
			return 1;
        case vi_close:
			if (Is(dryer_opened)){
				message("%nnγĤ᤿", ni_dryer);
				Reset(dryer_opened);
			}
			else {
				message("%nnγĤޤäƤ", ni_dryer);
			}
			return 1;
        case vi_use:
            message("Ÿʤ");
            return 1;
        default:
            break;
        }
        break;
	case ni_clothes:
        switch (vid){
        case vi_look:
			message("Ѥΰ켰ޤǤ롣");
			if (Is(man_checked)){
				message("̿Υ襷ζƤ˻Ƥ롣");
			}
			return 1;
        case vi_examine:
			if (Not(bronze_key_found)){
				message("ΥݥåȤ%nlä",
						ni_bronze_key);
				Set(bronze_key_found);
			}
			else {
				message("¾ˤϲʤ褦");
			}
			return 1;
        case vi_get:
			message("ؤɬפʤ");
			return 1;
		default:
			break;
		}
		break;
    case ni_fishing_rod:
        ReturnIfHasItem;
        if (Is(fishing_rod_taken)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_fishing_rod_taken);
            return 1;
		default:
			break;
		}
		break;
    case ni_poker:
        ReturnIfHasItem;
        if (Is(poker_taken)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_poker_taken);
            return 1;
		default:
			break;
		}
		break;
	case ni_bronze_key:
		if (Not(bronze_key_found) || Is(bronze_key_taken)){
			*exist = 0;
			return 0;
		}
		if (vid == vi_get){
			command_get_item(nid, fi_bronze_key_taken);
			return 1;
		}
		break;
    case ni_dog:
		if (Is(dog_gone)){
			*exist = 0;
			return 0;
		}
        switch (vid){
        case vi_look:
            message("%nl򤷤Ƥ롣Τ褦",
                    ni_belt);
			return 1;
        case vi_examine:
            message("ȤʤĴ٤Ƥ줽ˤʤ");
            return 1;
        case vi_talk:
            message("ä?");
            set_command_callback(command_callback_talk_dog);
            set_term_prompt(QUERY_PROMPT);
            return 1;
		case vi_hit:
		case vi_touch:
		case vi_push:
		case vi_pull:
		case vi_move:
		case vi_remove:
		case vi_fight:
			message("ʤμ϶ڤä");
			return 1;
		case vi_kick:
			message("ʤ­϶ڤä");
			return 1;
        default:
            break;
        }
        break;
    case ni_hat:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
        case vi_throw:
        case vi_put:
        case vi_give:
        case vi_show:
            message("˹ҤܤˤȡϤ󤯤̤"
                    "ưᤷ򤢤ȡäȾäƤä");
            lose_item(ni_hat);
            Set(dog_gone);
            return 1;
        default:
            break;
        }
        break;
    case ni_chicken:
    case ni_chicken_bone:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
        case vi_throw:
        case vi_put:
        case vi_give:
        case vi_show:
			message("Ϥ%nn򸫤"
					"ΤޤޤäݤƤޤä",
					nid);
            return 1;
        default:
            break;
        }
        break;
    case ni_belt:
        if (Is(belt_taken)) ReturnNotExist;
		if (Not(dog_gone)){
			RedoArea(vi_examine, ni_dog);
		}
        switch (vid){
        case vi_look:
            message("ꥪμؤ");
            return 1;
        case vi_get:
            command_get_item(ni_belt, fi_belt_taken);
            return 1;
        default:
            break;
        }
        break;
    case ni_wall:
        switch (vid){
        case vi_look:
            if (describe_rods() == 0){
                msg_nothing_any_more();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
        case vi_examine:
            if (Is(laundry_cellar_door_opened)){
                message("ξˤϲؤ%nl롣",
                        ni_hatch);
            }
            else {
                message("ξ%nl롣", ni_hatch);
            }
            if (Is(dog_gone) && Not(belt_taken)){
                message("ξ%nlƤ", ni_belt);
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_ceiling:
        break;
    default:
        *exist = 0;
        break;
    }
    return 0;
}


int describe_rods(void){
    if (Not(fishing_rod_taken)){
        message("ˡ%nlΩƤƤ롣",
                ni_fishing_rod);
        return 1;
    }
    else if (Not(poker_taken)){
        message("ˡ%nlΩƤƤ롣",
                ni_poker);
        return 1;
    }
    return 0;
}

void msg_dog_growl(void){
    message("%nnξ˺¤Ǥ븤"
            //            "ӹ夲ƤˤǤ롣",
            "ˤǤ롣",
            ni_hatch);
}

// ޤ뤳Ȥ󡣾ŷarea_laundry()¦ǤϤ
int command_callback_talk_dog(char *line){
    char *noun;
    noun_id_t nid;

    if (*line != '\0'){
        parse_noun(line, &noun);
        nid = get_noun_id(noun);
        switch (nid){
        case ni_orion:
            if (Not(dog_stood_up)){
                message("̾Ƥ֤ȡ"
                        "ޤǤ̵ؿäΩ夬ä");
                Set(dog_stood_up);
            }
            else {
                message("ʤ򤷤ˡä򿶤äƤ롣");
            }
            break;
        default:
            if (Is(dog_stood_up)){
                message("äȤ򸫤ĤƤ롣");
            }
            else {
                message("äݤޤޡȿ⼨ʤ");
            }
            break;
        }
    }
    //    clear_command_callback();
    //    set_console_prompt(NULL);
    return 0;
}
