#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void describe_plane(void);
void upset_armor_in_library(void);
//void return_armor_in_library(void);


int area_library(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            if (Is(armor_in_library)){
                msg_armor_standing();
            }
            message("̤Ⱥ%nn%nw%nw%nw¤Ǥ롣",
                    ni_bookshelf, ni_front_bookshelf,
                    ni_left_bookshelf, ni_right_bookshelf);
			message("̤ȱ¦%nw%nw롣",
					ni_front_door, ni_right_door);
			message("̤Ͻؤ\\");
			if (Is(library_corridor_door_opened)){
				message("¦ϭ³Ƥ롣");
			}
			else {
				message("³Ƥ롣");
			}
            if (Is(bookshelf_moved)){
                msg_secret_passage();
            }
			return 1;
        case vi_forward:
			if (Not(study_library_door_closed)){
                //                return_armor_in_library();
		        move_area(ai_study);
			}
			else {
				msg_door_closed();
			}
            return 1;
		case vi_right:
		case vi_exit:
            //            return_armor_in_library();
            EnterDoor(corridor_2f_r, library_corridor);
            //            move_dragon_in_corridor_2f();
            return 1;
        case vi_up:
            if (Is(library_ladder_set)){
                RedoArea(vi_up, ni_ladder);
            }
            break;
        default:
            break;
        }
        break;
    case ni_golden_key:
        if (IsActive(dragon) || Complete(dragon)) ReturnNotExist;
        switch (vid){
        case vi_get:
            message("򿭤Фȡ"
                    "ظ夫ʤˤӹǤ%nn򤵤ä"
                    "ξĻΤ褦ʤΤϡ"
                    "Τޤη֤γؤӵä",
                    ni_golden_key);
            start_flag_sequence(fs_dragon);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
        switch (vid){
        case vi_look:
            message("θϽؤ");
            return 1;
        case vi_open:
        case vi_push:
            TestAndReset(study_library_door_closed,
                         "ؤؤ򳫤",
                         "ؤؤϤ⤦Ƥ롣");
            return 1;
        case vi_close:
        case vi_pull:
            TestAndSet(study_library_door_closed,
                       "ؤؤĤ᤿",
                       "ؤؤϤ⤦ĤޤäƤ롣");
            return 1;
		case vi_enter:
            RedoArea(vi_forward, ni_invalid);
        default:
            break;
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
    case ni_bookshelf:
        msg_which_bookshelf();
        return 1;
    case ni_front_bookshelf:
        switch (vid){
        case vi_look:
            message("礭êˡ"
                    "¤Ǥ롣");
            return 1;
        case vi_examine:
            message("êˤϡȤѤäȤϤʤ褦");
            message("ܤϤۤȤɷкѽü˰ؽ¤Ǥ롣"
                    "ŤܤФٹΥ쥯");
            return 1;
        case vi_up:
            msg_cannot_climb();
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            msg_cannot_move();
            return 1;
        default:
            break;
        }
        break;
    case ni_left_bookshelf:
        switch (vid){
        case vi_look:
            message("礭êˡ"
                    "ŵ鸽ʸؤޤʸݺʤ¤Ǥ롣");
            describe_plane();
            return 1;
        case vi_examine:
            message("êˤϡȤѤäȤϤʤ褦");
            message("ͤĥꤽΩɤʽҤФ"
                    "κʤϤʤ褦ٹΥ쥯");
            describe_plane();
            return 1;
        case vi_up:
            if (Is(library_ladder_set)){
                RedoArea(vi_up, ni_ladder);
            }
            else {
                msg_cannot_climb();
            }
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            msg_cannot_move();
            return 1;
        default:
            break;
        }
        break;
    case ni_right_bookshelf:
        switch (vid){
        case vi_look:
            message("êˡ"
                    "夤ʷϵο޽񼼤˻"
                    "ʥܤ¤Ǥ롣");
            return 1;
        case vi_examine:
            upset_armor_in_library();
            message("Ѥ䰭ҤȤä"
                    "򤷤򰷤äܤ¤Ǥ롣"
                    "êܤǡʤɤ᤽ʤΤ%nl餤",
                    ni_easy_necromancy);
            if (Is(bookshelf_moved)){
                msg_secret_passage();
            }
            else if (Is(bookshelf_book_removed)){
                message("êαˡ%nl롣", ni_handle);
            }
            else {
                message("ܤη֤顢˲롣");
            }
            return 1;
        case vi_up:
            upset_armor_in_library();
            msg_cannot_climb();
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            upset_armor_in_library();
            if (Is(bookshelf_unlocked)){
                if (Not(bookshelf_moved)){
                    message("êưȱ줿%nl줿",
                            ni_passage);
                    Set(bookshelf_moved);
                }
                else {
                    message("êϤ⤦ưƤ롣");
                }
            }
            else {
                msg_cannot_move();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_book:
        switch (vid){
        case vi_look:
            message("ܤϤ󤶤ꤹۤɤ󤢤롣");
            return 1;
        case vi_read:
            message("ɤɤ⤦");
            return 1;
        case vi_examine:
            message("⤦êȤĴ٤Ƥߤ뤫");
            return 1;
        case vi_get:
        case vi_remove:
        case vi_move:
            upset_armor_in_library();
//            message("êܤɤȡʸ꤬ФƤ");
            message("êܤɤȡ%nl줿", ni_handle);
            Set(bookshelf_book_removed);
            return 1;
        default:
            break;
        }
        break;
	case ni_handle:
	    if (Not(bookshelf_book_removed)) ReturnNotExist;
		switch (vid){
        case vi_look:
            if (Is(bookshelf_unlocked)){
                message("%nnϲäƤ롣", ni_handle);
            }
            else {
                message("%nnϾ夬äƤ롣", ni_handle);
            }
            return 1;
        case vi_examine:
            message("ܤߤ˱äƾ岼ư褦");
            return 1;
        case vi_move:
        case vi_push:
        case vi_pull:
            upset_armor_in_library();
            message("Ϥ%nn򲡤ȡ"
                    "ê΢ǲ褦ʲ", ni_handle);
            Set(bookshelf_unlocked);
            return 1;
        default:
            break;
		}
		break;
    case ni_easy_necromancy:
        //        ReturnIfHasItem;
        upset_armor_in_library();
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("̸ΥܤΤ褦");
            return 1;
        case vi_read:
            msg_read_easy_necromancy();
            Set(easy_necromancy_read);
            return 1;
        case vi_get:
            msg_no_need_to_carry();
            //            command_get_item(ni_easy_necromancy, fi_easy_necromancy_taken);
            return 1;
        default:
            break;
        }
        break;
    case ni_ladder:
        if (has_item(nid)){
            switch (vid){
            case vi_use:
            case vi_put:
                message("ʤêҤݤ");
				Set(library_ladder_set);
                lose_item(nid);
                return 1;
            default:
                break;
            }
        }
		else {
			if (Not(library_ladder_set)){
				ReturnNotExist;
			}
            switch (vid){
            case vi_get:
                message("Ҥ줿");
                get_item(nid);
                Reset(library_ladder_set);
                return 1;
            case vi_use:
            case vi_put:
                message("ҤϤ⤦ΩƤƤ롣");
                return 1;
            case vi_up:
                message("ҤФä");
                move_area(ai_bookshelf);
                return 1;
            default:
                break;
            }
		}
        break;
    case ni_passage:
        if (Not(bookshelf_moved)) ReturnNotExist;
        switch (vid){
        case vi_examine:
             if (has_light() || (Is(candle_put))){
//				 if ((Has(candle) && Is(candle_lit)) ||
//                (Has(lantern) && Is(lantern_lit)) ||
//				(Is(candle_put)))
                message("ϩαˡ褦");
            }
            else {
                msg_no_light();
            }
            return 1;
        case vi_enter:
			// ɤ餫θäƤ뤫
			// ΤĤϹ֤ƤOK
			// ԤOKˤʤȡ󥿥ĤϹ֤ƽФ
			// ϥޤˤʤ
            if (has_light() || (Is(candle_put))){
                // ݤؤĤ᤺ȡ
                // Ĥƥ४СˤʤΤǡ
                // Ǥϥ֤ػߤ롣
                Set(save_forbidden);
                move_area(ai_secret_room);
            }
            else {
                msg_no_light();
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_armor:
        if (Not(armor_dead) &&
            Not(armor_in_library) &&
            Not(armor_crushed) &&
            Is(study_library_door_closed))
        {
            ReturnNotExist;
        }
        if (Is(armor_in_library)){
            switch (vid){
            case vi_look:
            case vi_examine:
                msg_look_standing_armor();
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_dead)){
            switch (vid){
            case vi_look:
                message("ξ˲äƤ롣"
                        "ϲžƤ롣");
                return 1;
            case vi_examine:
                message("γ⤦ưȤʤ");
                return 1;
            case vi_get:
                message("ʤΤ夿顢⤯ΤѤ");
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("⤦ϤʤäƤ");
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_crushed)){
            switch (vid){
            case vi_look:
                message("ξͤưʤ"
                        "ϲžƤ롣");
                return 1;
            case vi_examine:
                message("϶äݤ"
                        "ƹ¦%nlΤ褦ʤΤƤ롣",
                        ni_magic_circle);
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("˲Τ񤷤");
                return 1;
            default:
                break;
            }
        }
        else { // ؤ˺¤äƤ
            switch (vid){
            case vi_look:
                message("٤νؤα˺¤äƤ롣");
                return 1;
            case vi_examine:
            case vi_get:
            case vi_hit:
            case vi_kick:
            case vi_touch:
            case vi_destroy:
            case vi_move:
                msg_too_far();
                return 1;
            default:
                break;
            }
        }
        break;
    case ni_sword:
        if (Not(armor_dead) &&
            Not(armor_in_library) &&
            Is(study_library_door_closed))
        {
            ReturnNotExist;
        }
        if (Is(armor_dead)){
            switch (vid){
            case vi_look:
                message("¦Ƥ롣");
                return 1;
            case vi_examine:
                message("ʤΤڤ줿ҤȤޤʤ");
                return 1;
            case vi_get:
                message("ǿͤ󤹤ˤϴ롣");
                return 1;
            case vi_hit:
            case vi_kick:
            case vi_destroy:
                message("⤦ϤʤäƤ");
                return 1;
            default:
                break;
            }
        }
        else if (Is(armor_crushed)){
            switch (vid){
            case vi_look:
                message("ǤꤷƤ롣");
                return 1;
            case vi_examine:
            case vi_touch:
            case vi_get:
                return 1;
            default:
                break;
            }
        }
        else {
            switch (vid){
            case vi_look:
                msg_look_standing_armor_sword();
                return 1;
            case vi_examine:
            case vi_touch:
            case vi_get:
                return 1;
            default:
                break;
            }
        }
        break;
    case ni_magic_circle:
        if (Not(armor_crushed) && Not(armor_reviving)) ReturnNotExist;
        switch (vid){
        case vi_look:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                message("Ʊߤˡ"
                        "ʸȤ⵭ȤĤʤΤϢͤƤ롣");
            }
            return 1;
        case vi_examine:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                message("ƹ¦ˡϤƤ롣");
            }
            return 1;
        case vi_erase:
            if (Is(armor_dead)){
                msg_no_magic_circle();
            }
            else {
                if (has_item(ni_sponge)){
                    RedoArea(vi_use, ni_sponge);
                }
                else {
                    message("Ǥä餤ǤϾäˤʤ");
                }
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_sponge:
        if (!has_item(ni_sponge)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (Is(sponge_wet)){
                message("Ǩ줿ݥ󥸤ǳ¦򤳤ȡˡؤϾä");
                message("⤬Ƥλͻ褬Ϥ򼺤äȾξ");
                //                Reset(start_armor_to_library);
                //                Reset(armor_crushed);
                //                Reset(armor_reviving);
                clear_flag_sequence(fs_armor_to_library);
                Set(armor_dead);
                lose_item(ni_fishing_rod);
                lose_item(ni_sponge);
            }
            else {
                message("ݥ󥸤ǳ¦򤳤äƤߤ"
                        "ˡؤϾäʤ"
                        "Ǩ餵ʤ̵");
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_fossil:
        // äƤ
        if (has_item(nid)){
            switch (vid){
            case vi_put:
                message("%nnêαƤ֤",
                        nid);
                Set(fossil_set);
                lose_item(nid);
                return 1;
            default:
                break;
            }
        }
        // ֺѤߤξ
        else if (Is(fossil_set)){
            switch (vid){
            case vi_get:
                message("⤦ɬפʤ");
                return 1;
            default:
                break;
            }
        }
        // ޤꤷƤʤ
        else {
            ReturnNotExist;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
            if (NotActive(dragon) && NotComplete(dragon)){
                message("ξ%nlƤ",
                        ni_golden_key);
            }
            else {
                message("⤦Ƥʤ");
            }
            return 1;
        default:
            break;
        }        
        break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
	    *exist = 0;
        break;
    }
    return 0;
}

void describe_plane(void){
    if (Not(origami_plane_taken)){
        message("êξˡʤˤäƤ褦");
    }
}
void upset_armor_in_library(void){
    if (Not(armor_dead) && Not(study_library_door_closed) &&
        NotActive(armor_to_library))
    {
        printf("upset %d\n", fs_armor_to_library);
        start_flag_sequence(fs_armor_to_library);
        // åϥޥɤؤΥåθǽФΤǡե饰åȤΤ
        //        TestAndSet(start_armor_to_library,
        //                   NULL, NULL);
    }
}
/*
void return_armor_in_library(void){
	if (Is(armor_dead)) return;
    Reset(start_armor_to_library);
    Reset(armor_in_library);
    Reset(armor_crushed);
    Reset(armor_reviving);
    Reset(bookshelf_book_removed);
}
*/
/*
void move_dragon_in_corridor_2f(void){
    if (Is(dragon_corridor_2f_r)){
        message("ϭ˽ФȡʤΤʤӵä"
                "ϤΤޤ޳ؤȻѤä");
        proceed_flag_sequence(fs_dragon);
    }
}
*/

void post_library(int time_passed){
    if (!time_passed) return;

    // ٥
    // start_armor_to_library=>crushed=>revive, 
    // start_armor_to_library=>armor_in_libraryǤΤǡ
    // ƥ٥ȥڥ˵սȽꤹ
    /*
    if (Is(armor_reviving)){
    }
    else if (Is(armor_crushed)){
        Set(armor_reviving);
    }
    //    else if (Is(armor_in_library)){
    //        die_killed_by_armor();
    //    }
    else if (Is(start_armor_to_library)){
    }
    */
}
