#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void stop_phone_call(void);
void describe_silver_key(void);
void describe_fireplace_msg(void);
int command_callback_adjust_clock(char *line);
	
int area_living(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
    *exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("̤ˤ%nlꡢ"
					"κ¦ˤ%nl"
					"¦ζˤ%nl롣",
					ni_fireplace, ni_tv, ni_telephone);
            message("¦ظ%nw%nw\\",
                    ni_right_door, ni_back_door);
            if (Is(dining_living_door_opened) &&
                Is(living_corridor_door_opened))
            {
                message("ꡢ줾줾쿩Ʋϭ̤Ƥ롣");
            }
            else if (Is(dining_living_door_opened)){
                message("ꡢ¦ϿƲ̤Ƥ롣");
            }
            else if (Is(living_corridor_door_opened)){
                message("ꡢظϭ̤Ƥ롣");
            }
            else {
                message("롣");
            }
            return 1;
        case vi_backward:
		case vi_exit:
			stop_phone_call();
            EnterDoor(corridor_1f_bl, living_corridor);
            return 1;
        case vi_right:
			stop_phone_call();
            EnterDoor(dining, dining_living);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_wall:
		switch (vid){
		case vi_look:
			message("%nnξɤˤ%nlݤäƤ롣",
					ni_fireplace, ni_clock);
			return 1;
		default:
			break;
		}
		break;
    case ni_floor:
		switch (vid){
		case vi_look:
			message("%nnƤ%nlžäƤ롣",
					ni_tv, ni_videotape);
			return 1;
		default:
			break;
		}
        break;
    case ni_videotape:
		switch (vid){
		case vi_look:
		case vi_examine:
			message("ΤΥӥǥեȤ");
			message("ܤϥܥåȥ˥Τ褦ǡ"
                    "ѥåˤϥɥ饴ȥܥåȤΤ볨Ƥ롣"
					"⤦ܤϻҶ̡ǲǡ"
                    "㿧ͤ%nnǳǭäƤ볨Ƥ롣",
                    ni_slingshot);
			return 1;
		case vi_get:
            message("Ωˤʤ");
            return 1;
		default:
			break;
		}
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
        }
        break;
	case ni_fireplace:
		switch(vid){
        case vi_look:
			message(noun_description(nid));
            if (Not(fossil_taken)){
                message("ϧξˤ%nl%nläƤ롣", 
                        ni_photo, ni_fossil);
            }
            else {
                message("ϧξˤ%nläƤ롣", 
                        ni_photo);
            }
            describe_silver_key();
            describe_fireplace_msg();
			return 1;
        case vi_examine:
			message("ϧβФϾäƤ롣"
					"ŤǳԤ%nlѤäƤ롣", 
					ni_ash);
            describe_silver_key();
            describe_fireplace_msg();
			return 1;
        case vi_read:
            if (Is(silver_key_taken)){
                message("ۤϲФ");
                message("ʤΤȤ");
                Set(fireplace_message_read);
            }
            else {
                msg_cannot_read();
            }
            return 1;
		default:
			break;
		}
        break;
	case ni_clock:
		switch (vid){
		case vi_look:
			message("ȷפΤ褦\\");
			if (Not(clock_working)){
				message("%nlưϻߤޤäƤ롣",
                        ni_clock_hands);
			}
			else {
				message("%nlϥȻǤ롣",
                        ni_clock_hands);
			}
			if (Is(clock_bird_appeared)){
				if (Not(toy_bird_taken)){
                    message("ξ뤫%nlӽФƤ롣",
                            ni_toy_bird);
                }
                else {
                    message("ξ뤫ӽФХͤˤϡ"
                            "⤦äƤʤ");
                }
            }
			return 1;
		case vi_examine:
			message("λפϿ"
					"˿ΤĤ%nläƤ",
					ni_chain);
			return 1;
		case vi_adjust:
            message("ʬ˹碌?");
			msg_clock_adjusting_guide();
			set_command_callback(command_callback_adjust_clock);
			set_term_prompt(QUERY_PROMPT);
			return 1;
		default:
			break;
		}
        break;
    case ni_clock_hands:
        switch (vid){
        case vi_move:
        case vi_turn:
            RedoArea(vi_adjust, ni_clock);
        default:
            break;
        }
        break;
	case ni_chain:
		switch (vid){
		case vi_look:
			message("פ鲿ܤ%nnäƤꡢ"
                    "ĤˤϿդƤ롣",
                    ni_chain);
			return 1;
		case vi_examine:
			message("ν̤ǻפưȤߤ");
			return 1;
		case vi_pull:
		case vi_move:
			if (Not(clock_working)){
				message("ƿ򴬤夲ȡפư");
				Set(clock_working);
				if (Is(clock_adjusted)){
					Set(clock_striking);
				}
			}
			else {
				message("פϤޤưƤ롣"
						"Ф餯ϺɬפϤʤ");
			}
			return 1;
		default:
			break;
		}
        break;
	case ni_toy_bird:
		ReturnIfHasItem;
        if (Not(clock_bird_appeared)){
			ReturnNotExist;
		}
		switch (vid){
		case vi_get:            
			command_get_item(nid, fi_toy_bird_taken);
			return 1;
		default:
			break;
		}
		break;
	case ni_tv:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
			message("Ƥ%nlžäƤ롣",
					ni_videotape);
            return 1;
        case vi_use:
			message("Ÿå򲡤Ƥȿʤ"
					"ŵ̤Ƥʤ褦");
			return 1;
        case vi_get:
			message("ʸŤƽŤƥӤפʤ");
			return 1;
		default:
			break;
		}
        break;
	case ni_telephone:
		switch(vid){
        case vi_examine:
			message("õѤäȤϤʤ"
					"ɤ鿭ӤǤƤ롣");
			if (Not(phone_call_stopped)){
                message("դȵŤäۤƤ");
                Set(phone_call_stopped);
			}
			return 1;
        case vi_use:
        case vi_talk:
			if (Not(phone_call_stopped)){
				msg_answer_phone_call();
				Set(phone_call_answered);
				Set(phone_call_stopped);
			}
			else {
				message("äۤƤ롣");
			}
			return 1;
		default:
			break;
		}
        break;
	case ni_photo:
		switch(vid){
		case vi_look:
			message(noun_description(nid));
			message("ؤ餷ǯ˽%nw%nwȡ"
					"餷Ҷ%nw%nw̤äƤ롣",
					ni_man, ni_woman, ni_girl, ni_boy);
			Set(photo_checked);
			return 1;
		case vi_examine:
			message("̿΢ˡʤˤ񤤤Ƥ롣");
			return 1;
		case vi_read:
			message("1995ǯ 㡢ߥꥫȶˡ");
			return 1;
		case vi_get:
			message("ϤäȤƤ");
			return 1;
		case vi_touch:
			message("̿˿äƤߤ\\");
			msg_no_effect();
			return 1;
		case vi_hit:
		case vi_kick:
		case vi_destroy:
		case vi_push:
		case vi_pull:
			message("̿ˤΤϤ褦");
			return 1;
		default:
			break;
		}
        break;
	case ni_fossil:
        //        ReturnIfHasItem;
		if (Is(fossil_taken)){
			*exist = 0;
			return 0;
		}
		switch(vid){
        case vi_get:
            command_get_item(nid, fi_fossil_taken);
            return 1;
		default:
			break;
        }
        break;
	case ni_ash:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
            describe_silver_key();
            return 1;
		case vi_examine:
		case vi_move:
		case vi_remove:
            if (Is(silver_key_found)){
                msg_nothing_any_more();
            }
            else {
                message("ƻ򸫤ĤƤ");
            }
			return 1;
		default:
			break;
		}
        break;
    case ni_poker:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (Not(silver_key_found)){
                message("%nn򤫤󤹤%nlФƤ",
                        ni_ash, ni_silver_key);
                Set(silver_key_found);
                lose_item(nid);
            }
            else {
                msg_nothing_any_more();
            }
            return 1;
		default:
			break;
		}
        break;
    case ni_silver_key:
        ReturnIfHasItem;
        if (Not(silver_key_found) || Is(silver_key_taken)) ReturnNotExist;
        switch (vid){
        case vi_get:
            command_get_item(nid, fi_silver_key_taken);
            return 1;
		default:
			break;
		}
		break;
	case ni_man:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
			Set(man_checked);
            return 1;
		default:
			break;
		}
		break;
	case ni_woman:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
			Set(woman_checked);
            return 1;
		default:
			break;
		}
		break;
	case ni_girl:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
			Set(girl_checked);
            return 1;
		default:
			break;
		}
		break;
	case ni_boy:
		switch (vid){
        case vi_look:
            message(noun_description(nid));
			Set(boy_checked);
            return 1;
		default:
			break;
		}
		break;
    case ni_ceiling:
    case ni_window:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}


void stop_phone_call(void){
	if (Not(phone_call_stopped)){
		Set(stop_phone_call);
	}
}

void post_living(int time_passed){
    // å٥
    if (Is(phone_call_stopped)){
    }
    else if (Is(stop_phone_call)){
        msg_phone_call_stopped();
        Set(phone_call_stopped);
        Reset(stop_phone_call);
    }
    else if (Is(phone_call_continued)){
        msg_phone_call_continued();
    }
    // ץ٥
    if (time_passed){
        if (Is(clock_striking)){
            msg_clock_door_opened();
            Set(clock_bird_appeared);
            Reset(clock_striking);
            Reset(clock_adjusted);
        }
        else if (Is(clock_bird_appeared)){
            msg_clock_door_closed();
            Reset(clock_bird_appeared);
        }
    }
}

void describe_silver_key(void){
    if (Is(silver_key_found) && Not(silver_key_taken)){
        message("%nn%nl롣",
                ni_ash, ni_silver_key);
    }
}
void describe_fireplace_msg(void){
    if (Is(silver_key_taken)){
        message("%nnäˡʤˤĦäƤ롣",
                ni_silver_key);
    }
}

int command_callback_adjust_clock(char *line){
	int i, t, h, m;

    // 줺˥꥿󥭡
	if (strlen(line) == 0){
        message("פ碌Τ᤿");
		return 0;
	}
	if (strlen(line) != 4){
		msg_clock_adjusting_guide();
		return 1;
	}
	for (i = 0 ; i < 4 ; i++){
		if (!isdigit(line[i])){
			msg_clock_adjusting_guide();
            //			clear_command_callback();
            //			set_console_prompt(NULL);
			return 1;
		}
	}
	t = atoi(line);
	h = t / 100;
	m = t % 100;
	if (h >= 24 || m >= 60){
		msg_clock_adjusting_guide();
        //		clear_command_callback();
        //		set_console_prompt(NULL);
		return 1;
	}
	message("פ%d%dʬ˹碌", h, m);
	if (m == 0){
		set_flag(fi_clock_adjusted);
		if (is_flag_on(fi_clock_working)){
			set_flag(fi_clock_striking);
            //			set_post_message(msg_clock_door_opened);
		}
	}
    //    clear_command_callback();
    //    set_console_prompt(NULL);
    return 0;
}


