#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_mailbox(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            //            message("%nl%nlθؤؤȱӡƤˤ%nlΩäƤ롣",
            //                   ni_path, ni_house, ni_mailbox);
            message("ܤˤ%nl롣"
                    "%nl%nlθؤؤȱӡ"
                    "Ƥˤϰܤ%nlΩäƤ롣",
                    ni_mailbox, ni_path, ni_house, ni_tree);
            return 1;
        case vi_forward:
            move_area(ai_entrance);
            return 1;
        case vi_backward:
        case vi_left:
        case vi_right:
            message("ޤƵ櫓ˤϤʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_mailbox:
        switch(vid){
        case vi_look:
            message("դ°͹ؼ");
            if (Is(mailbox_opened)){
                if (has_item(ni_leaflet) && has_item(ni_medal)){
                    message("϶");
                }
                else if (has_item(ni_leaflet)){
                    message("%nläƤ롣", ni_medal);
                }
                else {
                    message("%nläƤ롣", ni_leaflet);
                }
            }
            return 1;
        case vi_open:
            if (Is(mailbox_opened)){
                message("͹ؼϤǤ˳Ƥ롣");
            }
            else {
                Set(mailbox_opened);
                message("͹ؼ򳫤\\");
                if (Not(leaflet_taken)){
                    message("ʤˤäƤ褦");
                }
                else {
                    message("");
                }
            }
            return 1;
        case vi_close:
            if (Is(mailbox_opened)){
                Reset(mailbox_opened);
                Set(mailbox_has_closed);
                message("͹ؼĤ᤿");
            }
            else {
                message("͹ؼĤޤäƤ롣");
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_tree:
        switch (vid){
        case vi_look:
            message("ޤ졢ϤƤޤäƤ롣");
            return 1;
        case vi_examine:
            message("ˤǤäΤޤƤ롣");
            return 1;
        case vi_get:
        case vi_move:
        case vi_push:
        case vi_pull:
            message("ä꺬ĥäƤꡢȤƤưˤʤ");
            return 1;
        case vi_destroy:
        case vi_hit:
        case vi_kick:
            message("ϤڤȤϤǼ˲Τ̵");
            return 1;
        case vi_up:
            message("Ф򤹤ۤɤι⤵ϻĤäƤʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_leaflet:
		if (has_item(ni_leaflet)){
			*exist = 0;
			return 0;
		}
        if (Is(mailbox_opened)){
            switch(vid){
            case vi_look:
                message(noun_description(nid));
                return 1;
            case vi_get:
                command_get_item(ni_leaflet, fi_leaflet_taken);
                return 1;
            default:
                break;
            }
        }
        else { // ͹ؼĤޤäƤ
			*exist = 0;
        }
        break;
    case ni_medal:
		if (has_item(ni_medal)){
			*exist = 0;
			return 0;
		}
        if (Is(mailbox_opened) && has_item(ni_leaflet)){
            switch(vid){
            case vi_look:
                message("ʥ");
                return 1;
            case vi_get:
                command_get_item(ni_medal, fi_medal_taken);
                return 1;
            default:
                break;
            }
        }
        else { // ͹ؼĤޤäƤ뤫˼椬äƤ
			*exist = 0;
        }
        break;
    case ni_path:
		break;
    case ni_house:
        switch(vid){
		case vi_look:
			message("ںʶΩɤʲȤ");
			return 1;
		case vi_examine:
			message("ŤƤߤʤȤ褯狼ʤ"
					"ѤäͻҤϸʤ");
			return 1;
        default:
            break;
        }
        break;
    default:
    	*exist = 0;
        break;
    }
    return 0;
}
