#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

void music_room_move_backward(void);

int area_music_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
			message("ˤ%nl%nl롣",
					ni_piano, ni_chair);
			message("¦ˤϻҶ³%nw롣",
					ni_right_door);
			message("̤ظˤ%nw%nw\\", 
					ni_front_door, ni_back_door);
			if (Is(balcony_door_opened) && Is(music_room_door_opened)){
				message("ꡢ줾Х륳ˡϭ³Ƥ롣");
			}
			else if (Is(balcony_door_opened)){
				message("ꡢ̤ϥХ륳ˡ³Ƥ롣");
			}
			else if (Is(music_room_door_opened)){
				message("ꡢظϭ³Ƥ롣");
			}
			else {
	            message("롣");
			}
			message("¦ˤ%nw\\", 
					ni_left_door);
			if (Is(bathroom_2f_door_opened)){
				message("ꡢἼ³Ƥ롣");
			}
            else {
	            message("롣");
            }
            return 1;
        case vi_forward:
			EnterDoor(balcony, balcony);
            return 1;
        case vi_backward:
		case vi_exit:
			music_room_move_backward();
            return 1;
        case vi_left:
		    EnterDoor(bathroom_2f, bathroom_2f);
            return 1;
        case vi_right:
		    EnterDoor(girls_room, music_room_right);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_front_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_forward, ni_invalid);
		}
        break;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
        break;
    case ni_left_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_left, ni_invalid);
		}
        break;
    case ni_right_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_right, ni_invalid);
		}
        break;
	case ni_piano:
		switch (vid){
		case vi_examine:
			if (Not(score_played)){
				msg_nothing_special();
			}
			else {
				message("DβΥϥޡ%nl廊Ƥ롣",
						ni_steel_key);
				Set(steel_key_found);
			}
			return 1;
		case vi_use:
			if (Not(score_set)){
				message("ʤϡ֤ͤդ󤸤äפƤ");
			}
			else {
				message("ʤϳ򸫤ʤʤȤ֥꡼ΤˡפƤ");
				message("䡢DβĤäƤʤ");
				Set(score_played);
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_steel_key:
		if (has_item(nid)){
			*exist = 0;
			return 0;
		}
		switch (vid){
		case vi_get:
			if (Is(steel_key_found)){
				command_get_item(nid, fi_steel_key_taken);
				return 1;
			}
			else {
				ReturnNotExist;
			}
		default:
			break;
		}
		break;
	case ni_score:
        if (has_item(nid)){
            switch (vid){
            case vi_put:
				TestAndSet(score_set,
                           "ʤ˳֤",
                           "Ϥ⤦֤Ƥ롣");
                lose_item(nid);
                return 1;
            default:
                break;
            }
            return 0;
        }
		else {
			if (Not(score_set)){
				ReturnNotExist;
			}
            switch (vid){
            case vi_get:
                message("⤦⤯ɬפʤ");
                return 1;
            case vi_read:
				// ֤ɤ褦
				command_read_item(nid);
                return 1;
            default:
                break;
            }
		}
        break;
    case ni_chair:
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
	case ni_window:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

void music_room_move_backward(void){
	if (Not(music_room_door_unlocked)){
        msg_door_unlocked_by_opening();
        Set(music_room_door_unlocked);
    }
    enter_door(ai_corridor_2f_l, fi_music_room_door_opened);
}
