#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int area_secret_room(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("ˤϲ%nl롣"
                    "ˤϾ%nl롣"
                    "ɤˤ%nl⤿줫äƤ롣",
                    ni_magic_circle, ni_table, ni_skeleton);
            message("ظˤϿ޽񼼤³⤬롣");
            return 1;
        case vi_backward:
		case vi_exit:
            if (Not(bookshelf_moved)){
                msg_locked_in_secret_room();
                if (Is(secret_room_note_read)){
                    die_starved();
                }
            }
            else {
                Reset(save_forbidden);
                move_area(ai_library);
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_floor:
        switch (vid){
        case vi_look:
			message("ˤϲ%nlƤ롣",
					ni_magic_circle);
			if (Is(pocket_notebook_dropped)){
                msg_looking_pocket_notebook();
			}
			return 1;
		default:
			break;
		}
		break;
    case ni_table:
        switch (vid){
        case vi_look:
			message("%nl%nl֤Ƥ롣",
					ni_book, ni_letter);
			return 1;
		default:
			break;
		}
		break;
    case ni_book:
        switch (vid){
        case vi_look:
            message("Ťܤܤ%nl꤬ĤƤ롣",
                    ni_another_world);
			return 1;
        case vi_examine:
			message("Ȥɤ˶Ƥ롣");
            return 1;
        case vi_get:
            msg_no_need_to_carry();
			return 1;
        case vi_read:
            msg_read_secret_room_book();
			Set(secret_room_book_read);
			return 1;
		default:
			break;
		}
		break;
    case ni_another_world:
        RedoArea(vid, ni_book);
    case ni_letter:
        switch (vid){
        case vi_look:
			message("Ť");
			return 1;
        case vi_examine:
            message("ޥɥʥɻ᰸μ"
                    "пͤϥեȤȤʤäƤ롣");
            return 1;
        case vi_get:
            //			command_get_item(nid, fi_postcard_taken);
            msg_no_need_to_carry();
			return 1;
        case vi_read:
            msg_read_letter();
			Set(secret_room_letter_read);
            return 1;
		default:
			break;
		}
		break;
	case ni_magic_circle:
        switch (vid){
        case vi_look:
			message("%nnΤˤϴ̯ʵ椬Ƥ롣"
					"ˤ%nl롣",
					ni_magic_circle, ni_altar);
            return 1;
        case vi_examine:
            if (Is(magic_circle_invoked)){
                msg_feeling_magic_circle_power();
            }
            else {
                message("ξľƤ롣");
            }
			return 1;
		default:
			break;
		}
		break;
	case ni_altar:
        switch (vid){
        case vi_look:
			if (Is(candle_put)){
				message("%nnξˤϿ椬ꡢϹäƤ롣",
						ni_altar);
			}
			else {
				message("%nnξˤϿ椬롣",
						ni_altar);
			}
			return 1;
		default:
			break;
		}
		break;
	case ni_skeleton:
        switch (vid){
        case vi_look:
			message("Τ"
					"ˤƤ롣"
					);
			if (Is(pocket_notebook_dropped)){
                msg_looking_pocket_notebook();
			}
			return 1;
        case vi_examine:
			message("ʤŤΤΤ褦µ%nlƤ롣"
					"˿Ƥ뤬ʤʤ",
                    ni_human_bone);
			if (Not(pocket_notebook_dropped)){
				message("ΤĴ٤Ƥȡ鲿");
				Set(pocket_notebook_dropped);
			}
			else {
                msg_looking_pocket_notebook();
			}
			return 1;
        case vi_hit:
        case vi_kick:
        case vi_destroy:
			message("Ԥ̲˸ΤϤƤ");
			return 1;
		default:
			break;
		}
		break;
	case ni_human_bone:
		if (Not(pocket_notebook_dropped)) ReturnNotExist;
        ReturnIfHasItem;
        // @note ƥȤƤιȤäƤ⡢ޤĤäƤΤǡ
        // ¾ΥƥΤ褦˰ʲΥɤȤȤϤǤʤ
        //		if (Is(human_bone_taken)){
        //			*exist = 0;
        //			return 0;
        //		}
		switch (vid){
		case vi_look:
			message("ǯäΤƤ롣");
			return 1;
		case vi_examine:
            message("ޤꤤ󤹤ΤŪʵ롣");
			return 1;
		case vi_get:
            if (Is(human_bone_taken)){
                message("Ȥϰ¤餫̲餻Ƥ");
            }
            else {
                command_get_item(nid, fi_human_bone_taken);
            }
			return 1;
		default:
			break;
		}
		break;
	case ni_pocket_notebook:
		if (Not(pocket_notebook_dropped)) ReturnNotExist;
		switch (vid){
		case vi_look:
			message("ŤӤƤ뤬ɽΩɤʼĢ");
			return 1;
		case vi_examine:
			message("ѤѤȤ᤯ȡ"
                    "ʤˤäȽ񤤤ƤڡĤä");
			return 1;
		case vi_read:
            msg_read_mcdonald_notebook();
			Set(secret_room_note_read);
			return 1;
		case vi_get:
            msg_no_need_to_carry();
			return 1;
		default:
			break;
		}
		break;
	case ni_bottle:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (Not(magic_circle_invoked)){
                if (Is(candle_put)){
                    message("ӤʴҤȤĤޤϹβФˤ٤ȡ"
                            "˴̯ʹ꤬ä");
                    msg_feeling_magic_circle_power();
                    Set(magic_circle_invoked);
                }
                else {
                    message("Ť˲Фɬפ");
                }
            }
            else {
                message("ʾ塢ʲɬפʤ");
            }
            return 1;
        default:
            break;
        }
        break;
	case ni_candle:
		if (Is(candle_put)){
		    switch (vid){
			case vi_look:
				message("ϹϿ֤Ƥ롣");
				return 1;
			case vi_put:
				message("ϹϤ⤦֤Ƥ롣");
				return 1;
			case vi_get:
				command_get_item(nid, fi_invalid);
				Reset(candle_put);
                if (Is(magic_circle_invoked)){
                    message("ˡؤϤ򴶤ʤʤä");
                    Reset(magic_circle_invoked);
                }
				return 1;
			default:
				break;
			}
		}
		else if (has_item(nid)){
		    switch (vid){
			case vi_put:
				message("Ϲ֤");
				lose_item(ni_candle);
				Set(candle_put);
				return 1;
			default:
				break;
			}
		}
		else {
			ReturnNotExist;
		}
		break;
    case ni_wall:
    case ni_ceiling:
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

