#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int storage_window_blocked(void);

int area_storage(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            message("%nl%nl%nlȤäȶ񤬵ͤޤƤ롣",
                    ni_chest, ni_table, ni_chair);
            message("ظˤϭ³⤬롣");
            return 1;
        case vi_backward:
		case vi_exit:
            EnterDoor(corridor_1f_mr, storage);
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        case vi_examine:
            RedoArea(vid, ni_floor);
        default:
            break;
        }
        break;
    case ni_door:
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
        }
        break;
    case ni_chest:
        switch (vid){
        case vi_look:
            message("%nl¤ýڤ",
                    ni_drawer);
            return 1;
        case vi_examine:
            RedoArea(vi_examine, ni_drawer);
        case vi_open:
        case vi_close:
            RedoArea(vid, ni_drawer);
        case vi_push:
        case vi_pull:
        case vi_move:
            msg_no_space_to_move();
            return 1;
        default:
            break;
        }
        break;
    case ni_drawer:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("¦ѤäȤϤʤ");
            if (Not(storage_drawers_closed)){
                message("϶");
            }
            return 1;
        case vi_close:
            TestAndSet(storage_drawers_closed,
                       "ФĤ",
                       "⤦ĤޤäƤ롣");
            return 1;
        case vi_open:
            TestAndReset(storage_drawers_closed,
                       "Ф򳫤",
                       "⤦Ƥ롣");
            return 1;
        case vi_move:
            if (Is(storage_drawers_closed)){
                RedoArea(vi_open, nid);
            }
            else {
                RedoArea(vi_close, nid);
            }
        default:
            break;
        }
        break;
    case ni_table:
        switch (vid){
        case vi_look:
            return 1;
        case vi_push:
            if (Not(storage_drawers_closed)){
                msg_no_space_to_move();
                return 1;
            }
            TestAndSet(storage_table_moved,
                       "ơ֥˰ư",
                       "ʾˤưʤ");
            return 1;
        case vi_pull:
            if (Not(storage_drawers_closed)){
                msg_no_space_to_move();
                return 1;
            }
            TestAndReset(storage_table_moved,
                       "ơ֥򸵤ΰ֤ᤷ",
                       "ʾ塢ˤưʤ");
            return 1;
        case vi_move:
            if (Not(storage_drawers_closed)){
                msg_no_space_to_move();
                return 1;
            }
            if (Is(storage_table_moved)){
                RedoArea(vi_pull, nid);
            }
            else {
                RedoArea(vi_push, nid);
            }
        default:
            break;
        }
        break;
    case ni_chair:
        switch (vid){
        case vi_look:
            return 1;
        case vi_push:
        case vi_pull:
        case vi_move:
            msg_no_space_to_move();
            return 1;
        default:
            break;
        }
        break;
	case ni_window:
        switch (vid){
        case vi_look:
            message("饹ΰƷ꤬Ƥ롣");
            if (!storage_window_blocked()){
                message("βˤ%nl롣",
                        ni_washtub);
            }
            return 1;
        case vi_examine:
            if (storage_window_blocked()){
                msg_blocked_by_furniture();
            }
            else {
                message("ΤΤʤ顢̤ꤽ");
            }
            return 1;
        default:
            if (storage_window_blocked()){
                msg_blocked_by_furniture();
                return 1;
            }
            else {
                break;
            }
        }
        break;
    case ni_washtub:
        if (storage_window_blocked()) ReturnNotExist;
        switch (vid){
        case vi_look:
        case vi_examine:
            message("%nlίޤäƤ롣",
                    ni_water);
            return 1;
        case vi_get:
        case vi_touch:
        case vi_push:
        case vi_pull:
        case vi_move:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
            message("꤫Ф餤ǤϤˤʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_water:
        if (storage_window_blocked()) ReturnNotExist;
        switch (vid){
        case vi_look:
        case vi_examine:
            message("夬ޤäΤ"
                    "դǤ뤬");
            return 1;
        case vi_get:
        case vi_touch:
        case vi_push:
        case vi_pull:
        case vi_move:
        case vi_hit:
        case vi_kick:
        case vi_destroy:
            message("꤫Ф餤ǤϤˤʤ");
            return 1;
        default:
            break;
        }
        break;
    case ni_fishing_rod:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (storage_window_blocked()){
                msg_blocked_by_furniture();
                return 1;
            }
            if (Not(fishing_rod_with_sponge)){
                message("ʤη꤫%nnͤФ%nn줿",
                        ni_fishing_rod, ni_washtub);
                message("ʤϤʤ褦");
            }
            else {
                if (Not(sponge_wet)){
                    message("ʤη꤫%nnͤФ"
                            "%nn%nn˹ߤ",
                            ni_fishing_rod, ni_sponge, ni_washtub);
                    message("Ф餯ư夲ȡ"
                            "%nnϤäפȿۤäƤ",
                            ni_sponge);
                    Set(sponge_wet);
                }
                else {
                    message("%nnϤǤ˿忻",
                            ni_sponge);
                }
            }
            return 1;
        default:
            break;
        }
        break;
    case ni_lantern:
		if (has_item(nid)){
			*exist = 0;
			return 0;
		}
		switch (vid){
		case vi_get:
			command_get_item(nid, fi_lantern_taken);
			return 1;
		default:
			break;
		}
		break;
    case ni_floor:
        switch (vid){
        case vi_look:
        case vi_examine:
            message("ζ%nl֤Ƥ롣",
                    ni_lantern);
			return 1;
		default:
			break;
		}
		break;
    case ni_ceiling:
    case ni_wall:
    default:
        *exist = 0;
        break;
    }
    return 0;
}


int storage_window_blocked(void){
    if (Not(storage_drawers_closed) || Not(storage_table_moved)){
        return 1;
    }
    return 0;
}
