#include <stdio.h>
#include "config.h"
#include "area.h"
#include "status.h"
#include "message.h"
#include "command.h"

int upset_armor_in_study(void);
void calm_armor_in_study(void);

int area_study(verb_id_t vid, noun_id_t nid, int *exist){
    assert(vid != vi_invalid);
	*exist = 1;
    switch(nid){
    case ni_invalid:
        switch(vid){
        case vi_look:
            DescribeArea;
            if (Is(armor_in_study)){
                msg_armor_standing();
            }
			message("¦ˤ%nl%nl\\",
                    ni_desk, ni_chair);
            if (Not(armor_in_study) && Not(armor_dead)){
                message("ꡢαˤ%nlƤ롣",
                        ni_armor);
            }
            else {
                message("롣");
            }
            message("̤ɤˤ%nlꡢκ¦ˤ%nw롣",
                    ni_bookshelf, ni_left_door);
            message("ظˤϭ³%nw롣",
                    ni_back_door);
            return 1;
        case vi_backward:
		case vi_exit:
            calm_armor_in_study();
            EnterDoor(corridor_2f_cr, study_corridor);
            //            move_dragon_in_corridor_2f();
            return 1;
        case vi_left:
			if (Not(study_library_door_closed)){
                calm_armor_in_study();
	            // ޽񼼤ȤϺǽ餫鳫Ƥ
		        move_area(ai_library);
			}
			else {
				msg_door_closed();
			}
            return 1;
        default:
            break;
        }
        break;
    case ni_room:
        switch (vid){
        case vi_look:
        case vi_exit:
            RedoArea(vid, ni_invalid);
        default:
            break;
        }
        break;
    case ni_door:
        msg_which_door();
        return 1;
    case ni_left_door:
        switch (vid){
        case vi_look:
            message("θϿ޽񼼤Τ褦");
            return 1;
        case vi_open:
        case vi_push:
            TestAndReset(study_library_door_closed,
                         "򳫤",
                         "Ϥ⤦Ƥ롣");
            return 1;
        case vi_close:
        case vi_pull:
            TestAndSet(study_library_door_closed,
                       "Ĥ᤿",
                       "Ϥ⤦ĤޤäƤ롣");
            return 1;
		case vi_enter:
            RedoArea(vi_left, ni_invalid);
        default:
            break;
        }
        break;
    case ni_back_door:
		if (vid == vi_open || vid == vi_push || vid == vi_pull){
            RedoArea(vi_backward, ni_invalid);
		}
        break;
    case ni_armor:
        if (Is(armor_dead)) ReturnNotExist;
        switch (vid){
        case vi_look:
            if (Not(armor_in_study)){
                message("¤äǾäƤ롣"
                        "ˤ%nl򺹤Ƥ롣",
                        ni_sword);
            }
            else {
                msg_look_standing_armor();
            }
            return 1;
        case vi_examine:
        case vi_touch:
        case vi_get:
            upset_armor_in_study();
            return 1;
        default:
            break;
        }
        break;
    case ni_sword:
        switch (vid){
        case vi_look:
            if (Not(armor_in_study)){
                message("Ǽޤäޤޡι˺Ƥ롣");
            }
            else {
                msg_look_standing_armor_sword();
            }
            return 1;
        case vi_examine:
        case vi_touch:
        case vi_get:
            upset_armor_in_study();
            return 1;
        default:
            break;
        }
        break;
    case ni_desk:
        if (vid != vi_look){
            if (upset_armor_in_study()) return 1;
        }
        switch (vid){
        case vi_look:
        case vi_examine:
			message("%nlդ",
					ni_drawer);
			message("%nl֤Ƥ롣",
					ni_postcard);
			return 1;
        default:
            break;
        }
        break;
    case ni_drawer:
        if (vid != vi_look){
            if (upset_armor_in_study()) return 1;
        }
        switch (vid){
        case vi_look:
        case vi_examine:
            if (Not(study_desk_opened)){
                message("ü˸꤬롣");
            }
            else {
                if (Not(screwdriver_taken)){
                    message("ͤ%nl%nl롣",
                            ni_notebook, ni_screwdriver);
                }
                else {
                    message("ͤ%nl롣",
                            ni_notebook);
                }
            }
			return 1;
        case vi_open:
        case vi_pull:
            if (Is(study_desk_unlocked)){
                TestAndSet(study_desk_opened,
                           "ͤ򳫤",
                           "ͤϤ⤦Ƥ롣");
            }
            else {
                message("ݤäƤ롣");
            }
            return 1;
        case vi_close:
        case vi_push:
            TestAndReset(study_desk_opened,
                         "ͤĤ᤿",
                         "ͤĤޤäƤ롣");
            return 1;
        default:
            break;
        }
        break;
    case ni_steel_key:
        if (!has_item(nid)) ReturnNotExist;
        switch (vid){
        case vi_use:
            if (upset_armor_in_study()) return 1;
            if (Not(study_desk_unlocked)){
                message("");
                Set(study_desk_unlocked);
                lose_item(nid);
            }
            else {
                message("⤦ϳݤäƤʤ");
            }
            return 1;
        default:
            break;
        }
        break;
	case ni_postcard:
        //        ReturnIfHasItem;
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("纴襷ζ줿Τ");
            return 1;
        case vi_get:
            //			command_get_item(nid, fi_postcard_taken);
            msg_no_need_to_carry();
			return 1;
        case vi_read:
            msg_read_postcard();
            Set(postcard_read);
            return 1;
        default:
            break;
        }
        break;
	case ni_notebook:
        if (vid != vi_look){
            if (upset_armor_in_study()) return 1;
        }
        //        if (upset_armor_in_study()) return 1;
        //        ReturnIfHasItem;
        switch (vid){
        case vi_look:
            message(noun_description(nid));
            return 1;
        case vi_examine:
            message("θΡȤΤ褦");
            return 1;
        case vi_get:
            msg_no_need_to_carry();
			return 1;
        case vi_read:
            msg_read_yoshino_notebook();
            Set(study_notebook_read);
            return 1;
        default:
            break;
        }
        break;
	case ni_screwdriver:
        ReturnIfHasItem;
        if (vid != vi_look){
            if (upset_armor_in_study()) return 1;
        }
		switch (vid){
		case vi_get:
			if (Is(study_desk_opened)){
				command_get_item(nid, fi_screwdriver_taken);
				return 1;
			}
			else {
				ReturnNotExist;
			}
		default:
			break;
		}
		break;
    case ni_chair:
        break;
    case ni_bookshelf:
		switch (vid){
		case vi_look:
            message("ʪؤ¤Ǥ롣");
            return 1;
		default:
			break;
		}
		break;
    case ni_book:
		switch (vid){
		case vi_look:
            message("ʪؤ");
            return 1;
		case vi_read:
            message("ƤϤäѤǤʤ");
            return 1;
		default:
			break;
		}
		break;
    case ni_wall:
    case ni_floor:
    case ni_ceiling:
	case ni_window:
        break;
    case ni_brass_key:
    case ni_wooden_key:
    case ni_bronze_key:
    case ni_golden_key:
        if (has_item(nid)){
            switch(vid){
            case vi_use:
                msg_key_unmatched();
                return 1;
            default:
                break;
            }
            return 0;
        } 
		else {
			ReturnNotExist;
		}
        break;
    default:
		*exist = 0;
        break;
    }
    return 0;
}

int upset_armor_in_study(void){
    if (Not(armor_dead)){
        // åϥޥɤؤΥåθǽФΤǡե饰åȤΤ
        TestAndSet(start_armor_to_study,
                   NULL, NULL);
        if (Is(armor_moving)){
            // Υǿ޽/ҼäƤʤ麣Υޥɤ̵
            if (Is(armor_restoring_library) || Is(armor_moving_from_guestroom)){
                return 1;
            }
            return 0;
        }
        else {
            return 1;
        }
    }
    else {
        return 0;
    }
}

void calm_armor_in_study(void){
    //    if (Is(start_armor_to_study) || Is(armor_in_study)){
    if (Is(armor_in_study)){
        message("Ф褦Ȥȡ"
                "­Τ褦˸ξäƤä");
        Reset(armor_moving);
        Reset(armor_in_study);
    }
}

void post_study(int time_passed){
    if (!time_passed) return;
    
    // ٥
    if (Is(armor_in_study) && Staying(study)){
        die_killed_by_armor();
    }
    else if (Is(start_armor_to_study)){
        if (Not(armor_moving)){
            message("¤äƤưФʤ˸äƤ!");
            Set(armor_moving);
            Set(armor_in_study);
            Reset(start_armor_to_study);
        }
    }
}

