#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "config.h"
#include "command.h"
#include "term.h"
#include "status.h"
#include "area.h"
#include "noun.h"
#include "verb.h"
#include "message.h"
#include "graphic.h"

static int (*command_callback)(char *line);
// vi_combine˻Ȥե饰
int combine_flags[ni_end];
// vi_combineΤȤ̾ID(ΡΥ١ƥ)
noun_id_t combine_base_nid;
// vi_combineɲϲ
int combine_query_count;
// vi_combineλꥢƥ
int combine_item_count;
/*
void (*exec_command_post_message)(void) = NULL;
*/

typedef struct {
	flag_id_t flag;
	noun_id_t nid;
	 void (*msg)(void);
} recall_entry_t;

static recall_entry_t recalls[] = {
	{fi_postcard_read, ni_postcard, msg_read_postcard},
	{fi_study_notebook_read, ni_study_note, msg_recall_yoshino_notebook},
	{fi_easy_necromancy_read, ni_easy_necromancy, msg_recall_easy_necromancy},
	{fi_bathroom_1f_message_read, ni_bathroom_1f_wall, msg_read_bathroom_1f_wall},
	{fi_bathroom_2f_message_read, ni_bathroom_2f_wall, msg_read_bathroom_2f_wall},
	{fi_secret_room_note_read, ni_secret_room_note, msg_recall_mcdonald_notebook},
	{fi_secret_room_letter_read, ni_secret_room_letter, msg_read_letter},
	{fi_secret_room_book_read, ni_another_world, msg_recall_secret_room_book},
	{fi_boiler_room_note_read, ni_boiler_room_note, msg_recall_boiler_room_wall},
    {fi_logbook_read, ni_logbook, msg_read_logbook},
};
#define RECALL_ENTRY_NUM (sizeof(recalls)/sizeof(recall_entry_t))

void init_command(void){
    noun_init();
    verb_init();
    clear_command_callback();
}

void interpret_line(char *line){
    char *verb, *noun;
    verb_id_t vid;
    noun_id_t nid;
    int time_passed;

    if (command_callback){
        // command_callback0֤顢
        // ХåϿõ̾ΥޥϤ
        // ʣ󥳡ХåȤϡХåؿ
        // ΥХå򥻥åȤ0֤Ф褤
        // ԡȤʤХåؿ%wȤȡ
        //   [꥿󥭡...]ϽФʤ
        //   ʲconsole_prompt뤿ᡣ
        if (command_callback(line) == 0){
            clear_command_callback();
            //            set_console_prompt(NULL);
        }
    }
    // Ϥʤǥ꥿󥭡Ȥϥޥɽʤ
	else if (*line != '\0'){
	    parse_command(line, &verb, &noun);
		nid = get_noun_id(noun);
	    vid = get_verb_id(verb, nid);
		//    printf("verb:%s:%d: noun:%s:%d:\n", verb, vid, noun, nid);
	    exec_command(vid, nid, verb, noun);
//    if (command_callback == NULL){
        time_passed = (vid == vi_look ||
					   vid == vi_inventory ||
					   vid == vi_load ||
					   vid == vi_save ||
                       vid == vi_unknown ||
                       nid == ni_unknown)
					   ? 0 : 1;
        post_area(current_area(), time_passed);
//    }
        // βưʤ顢ե饰ʹԤϰưŬ
        // Ȥϥե饰ʹԤ䥳ХåϤʤ
        if (Not(dead)){
            process_flag_sequences(time_passed);
        }
		update_current_area();
	}
    draw_graphic();
/*
	if (exec_command_post_message != NULL){
   		printf("set %p\n", exec_command_post_message);
		exec_command_post_message();
		exec_command_post_message = NULL;
	}
	*/
}

// lineverb, nounФ
// lineλؤϽ񤭴롣
// verb, nounlineγսؤ褦ѹ
// ưΤߤξ硢nounNULLȤʤ
// !!! ʸϾʸѴ롩
void parse_command(char *line, char **verb, char **noun){
    char *p = line;

    printf("|%s|\n", p);
    // nounΥǥեͤNULL
    *noun = NULL;
    p = parse_verb(p, verb);
    if (p){
        parse_noun(p, noun);
    }
}
char *parse_verb(char *line, char **verb){
    char *p = line;

    // ư˥ڡäɤФ
    while (*p == ' '){
        p++;
    }
    *verb = p;
    while (*p != '\0' && *p != ' '){
        p++;
    }
    // ̾礬ʤʤ齪λ
    if (*p == '\0'){
        return NULL;
    }
    // ư򥿡ߥ͡
    *p = '\0';
    return p+1;
}
void parse_noun(char *line, char **noun){
    char *p = line;
    char *q;

    // Ƭ(ư)Υڡ򤹤٤ɤФ
    while (*p == ' '){
        p++;
    }
    // ڡˤäѤ̾礬ʤʤ齪λ
    if (*p == '\0'){
        return;
    }
    // Ĥޤ̾찷
    *noun = p;
    // ̾϶ޤळȤǤΤǡʣ줫ʤ̾Ǥ褤
    // ʣζϢ³϶ĤѴƤ
    while (*p != '\0'){
        if (*p == ' '){
            p++;
            q = p;
            while (*p == ' '){
                p++;
            }
            strcpy(q, p);
            p = q;
        }
        else {
            p++;
        }
    }
    p--;
    // ˶򤬤оä
    while (*p == ' '){
        *p = '\0';
        p--;
    }
}




// ޥɤ¹Ԥ
// ŪIDǽ뤬åʸɬפʾ
// verb, noun
void exec_command(verb_id_t vid, noun_id_t nid, char *verb, char *noun){
    int exist = 0;
    assert(vid != vi_invalid);

    if (vid == vi_unknown){
        message("%sȤưϻȤʤ", verb);
        return;
    }
    if (nid == ni_unknown){
        message("%sȤ̾ϻȤʤ", noun);
        return;
    }
    if (call_area(current_area(), vid, nid, &exist)) return;
    if (nid == ni_invalid){
        switch (vid){
        case vi_forward:
        case vi_backward:
        case vi_left:
        case vi_right:
            message("ˤϿʤʤ");
            return;
        case vi_up:
            message("줽ʤȤϤʤ");
            return;
        case vi_down:
            message("ߤ줽ʤȤϤʤ");
            return;
        case vi_recall:
            command_recall(nid);
            return;
        case vi_help:
            show_help(nid, noun);
            return;
        case vi_inventory:
            show_inventory();
            return;
        case vi_load:
            if (load_data() == 0){
                message("ɤޤ");
                move_area(current_area());
            }
            else {
                message("Υɤ˼Ԥޤ");
            }
            return;
        case vi_save:
			if (Is(save_forbidden)){
                message("ϤƤ");
                //                message("ʾǤϤʤ");
                //				message(";͵Ϥʤ");
				return;
			}
            if (save_data() == 0){
                message("򥻡֤ޤ");
            }
            else {
                message("Υ֤˼Ԥޤ");
            }
            return;
        case vi_title:
            move_to_title();
            return;
            //        case vi_score:
            //            show_normal_score();
            //            show_maniac_score();
            //            return;
        case vi_config:
            config(nid, noun);
            return;
        case vi_quit:
            command_quit();
            return;
#ifdef DEBUG
        case vi_debug:
            show_debug();
            return;
        case vi_test:
            move_area(ai_working);
            return;
#endif
		case vi_wait:
			message("ʤϾ֤٤");
			return;
		case vi_examine:
        case vi_get:
        case vi_put:
        case vi_push:
        case vi_pull:
        case vi_destroy:
            message("");
            return;
        case vi_pray:
            message("Ƥʤ");
            return;
        default:
            break;
        }
    }
    else {  // ̾줬ꤵƤ
		// ξ¸ߤƤʤ̾ФƲǽʥޥɽ
		switch (vid){
        case vi_config:
            config(nid, noun);
            return;
        case vi_help:
            show_help(nid, noun);
            return;
        case vi_recall:
            command_recall(nid);
            return;
#ifdef DEBUG
		case vi_teleport:
            command_teleport(nid);
            return;
        case vi_summon:
            command_summon(nid);
            return;
        case vi_flag:
            command_flag(nid);
            return;
#endif
		default:
			break;
		}
        // ƥʤ¸ߥե饰ΩƤ
        if (IsNounItem(nid) && has_item(nid)){
            exist = 1;
        }
		if (IsNounItem(nid)){
            if (exec_command_item(vid, nid, exist)) return;
        }
        if (!exist){
            msg_no_object();
            return;
        }
        switch (vid){
        case vi_look:
            message(noun_description(nid));
//            msg_nothing_special();
            return;
        case vi_examine:
            switch(nid){
            case ni_ceiling:
                message("ΰ֤Ĵ٤Τ̵");
                return;
            default:
                msg_nothing_special();
                return;
            }
            return;
        case vi_get:
            message("ϼʤ");
            return;
        case vi_hit:
        case vi_kick:
        case vi_touch:
            switch (nid){
            case ni_ceiling:
                message("Ϥʤ");
                return;
            default:
                msg_no_effect();
                return;
            }
            break;
        case vi_up:
			switch (nid){
			case ni_table:
			case ni_chair:
			case ni_bed:
			case ni_desk:
			case ni_cabinet:
			case ni_chest:
			case ni_wardrobe:
			case ni_dressing_table:
			case ni_bookshelf:
                message("ԵΰȤϤƤ");
                return;
            default:
                break;
            }
            break;
        case vi_use:
			switch (nid){
			case ni_bed:
				message("Ĥ󡢿ƤǤϤʤ");
				return;
			default:
				break;
			}
			break;
        case vi_read:
            msg_cannot_read();
            return;
        case vi_destroy:
            msg_cannot_destroy();
            return;
		case vi_open:
			switch (nid){
			case ni_window:
				message("ȤӤĤƤΤǤƳʤ");
				return;
			default:
				break;
			}
			break;
		case vi_close:
            switch(nid){
            case ni_door:
            case ni_front_door:
            case ni_back_door:
            case ni_left_door:
            case ni_right_door:
				msg_door_already_closed();
				return;
			default:
				break;
			}
        default:
            break;
        }
    }
    msg_cannot_do();
}
/*
void set_post_message(void (*msg)(void)){
	printf("set %p\n", msg);
	exec_command_post_message = msg;
}*/

int exec_command_item(verb_id_t vid, noun_id_t nid, int exist){
    switch (vid){
    case vi_look:
        // ƥफξ¸ߤƤlookޥɤ¹
        // ˼ȸǰ㤦åФarea_xxxǽƤ
        if (exist){
            command_look_item(nid);
            return 1;
        }
        break;
    case vi_examine:
        if (has_item(nid)){
            command_examine_item(nid);
            return 1;
        }
        else if (exist){
            msg_need_to_get();
            return 1;
        }
        break;
    case vi_get:
        // ͭgetarea_xxxǽΤǡ
        // ΤѤߤξ礫оݤξˤʤ
        if (has_item(nid)){
            message("%nnϤ⤦äƤ롣", nid);
            return 1;
        }
        break;
    case vi_put:
        // ͭputarea_xxxǽΤǡ
        // ΤѤߤξ礫оݤξˤʤ
        if (has_item(nid)){
            msg_cannot_do();
            return 1;
        }
        break;
    case vi_use:
        // ͭusearea_xxxǽΤǡ
        // Τ̤ξ礫оݤξˤʤ礫
        // Ȥʤ
        if (has_item(nid)){
            command_use_item(nid);
            return 1;
        }
        break;
    case vi_read:
        if (has_item(nid)){
            command_read_item(nid);
            return 1;
        }
        else if (exist){
            msg_need_to_get();
            return 1;
        }
        break;
    case vi_touch:
        if (has_item(nid)){
            // ȤꤢäƤɤˤʤ륢ƥϤʤ
            msg_no_effect();
            return 1;
        }
        break;
    case vi_combine:
        if (has_item(nid)){
            command_combine_item(nid);
            return 1;
        }
        else {
            message("%nnäƤʤ", nid);
            return 1;
        }
        break;
    case vi_dismantle:
        if (has_item(nid)){
            command_dismantle_item(nid);
            return 1;
        }
        break;
    case vi_remove:
        command_remove_item(nid);
        return 1;
    default:
        break;
    }
    return 0;
}

void show_help(noun_id_t nid, char *noun){
    switch(nid){
    case ni_invalid:
        message("  %s %s: ܥޥ", vid2verb(vi_help), nid2noun(ni_basic));
        message("  %s %s: ư", vid2verb(vi_help), nid2noun(ni_verb));
        message("  %s %s: ̾", vid2verb(vi_help), nid2noun(ni_noun));
        message("  %s %s: ҥ", vid2verb(vi_help), nid2noun(ni_tips));
        message("  %s %s: ", vid2verb(vi_help), nid2noun(ni_key));
        message("  %s %s: ", vid2verb(vi_help), nid2noun(ni_assistance));
		// ǽȤvcppǡǽפ
        break;
    case ni_basic:
        show_help_basic();
        break;
    case ni_verb:
        show_help_verb();
        break;
    case ni_noun:
        show_help_noun();
        break;
    case ni_tips:
        show_help_tips();
        break;
    case ni_key:
        show_help_key();
        break;
    case ni_assistance:
        show_help_assistance();
        break;
    default:
        if (noun != NULL){
            message("%sϽʤ", noun);
        }
    }
}

void show_inventory(void){
    // !!! ʪɽԿĶ뤳ȤΤǡ
    // ȤꤢХåեդʤ褦礭ˤƤ
    // console¦ǡɽԿĶ褦ʤ꥿Ԥ򤹤褦ˤ
    char buf[CONSOLE_CHR_WIDTH * CONSOLE_CHR_HEIGHT * 4 ];
    int i, item_num;
	noun_id_t nid;
    char *p;

    puts_console("[ʪ]");
    buf[0] = '\0';
    p = buf;
	item_num = get_item_num();
    for (i = 0 ; i < item_num ; i++){
		nid = get_item_id(i);
        printf("%d\n", i);
        assert(nid2noun(nid) != NULL);
        sprintf(p, "%s[%s] ", noun_name(nid), nid2noun(nid));
        while (*p != '\0') p++;
    }
    if (p == buf){
        sprintf(buf, "(ʤ)");
    }
    puts(buf);
    puts_console(buf);
}

void show_debug(void){
    //    char buf[CONSOLE_CHR_WIDTH * CONSOLE_CHR_HEIGHT];
    char fbuf[fi_end+1];
    char ibuf[ni_item_end+1];
    int i;

    for (i = fi_begin ; i < fi_end ; i++){
        if (is_flag_on(i)){
            fbuf[i] = '1';
        }
        else {
            fbuf[i] = '0';
        }
    }
    fbuf[i] = '\0';
    puts(fbuf);
    puts_console(fbuf);

    for (i = ni_item_begin ; i < ni_item_end ; i++){
        if (has_item(i)){
            ibuf[i] = '1';
        }
        else {
            ibuf[i] = '0';
        }
    }
    ibuf[i] = '\0';
    puts(ibuf);
    puts_console(ibuf);

}

void config(noun_id_t nid, char *noun){
    switch(nid){
    case ni_invalid:
        message("ʲ꤬ǽǤ");
        message("  %s %s: ϸ", vid2verb(vi_config), nid2noun(ni_input));
        break;
    case ni_input:
        message("ɤڤؤޤ?(%nw%nw%nw)", 
                ni_english, ni_hiragana, ni_katakana);
        set_command_callback(command_callback_input);
        set_term_prompt(QUERY_PROMPT);
        break;
    default:
        message("%sǤޤ", noun);
    }
}
void command_quit(void){
    message("ץλޤ(%nw/%nw)?", ni_yes, ni_no);
    set_command_callback(command_callback_quit);
    set_term_prompt(QUERY_PROMPT);
}

int command_callback_quit(char *line){
    char *noun;
    noun_id_t nid;
    int result = 1;

    if (*line != '\0'){
        parse_noun(line, &noun);
        nid = get_noun_id(noun);
        switch (nid){
        case ni_yes:
            result = 1;
            break;
        default:
            result = 0;
            break;
        }
    }
    //    command_callback = NULL;
    //    set_console_prompt(NULL);
    if (result){
        puts("bye.");
        EzExitEventLoop();
    }
    return 0;
}
void command_recall(noun_id_t nid){
	int i;
	for (i = 0 ; i < RECALL_ENTRY_NUM ; i++){
		if (nid == recalls[i].nid && is_flag_on(recalls[i].flag)){
			recalls[i].msg();
			return;
		}
	}
	list_recall();
}
void list_recall(void){
    int ctr = 0;
	int i;
	for (i = 0 ; i < RECALL_ENTRY_NUM ; i++){
		if (is_flag_on(recalls[i].flag)){
	        message("%nl \\", recalls[i].nid);
			ctr ++;
		}
	}
    if (ctr > 0){
        message("");
        message("ʾΤȤפФ롣");
    }
    else {
        message("ޤפФ褦ʤȤϤʤ");
    }
}

	
/*	
	if (Is(postcard_read)){
        message("%nl \\", ni_postcard);
        ctr++;
    }
    if (Is(easy_necromancy_read)){
        message("%nl \\", ni_easy_necromancy);
        ctr++;
    }
	if (Is(bathroom_2f_message_read)){
        message("%nl \\", ni_bathroom_2f_wall);
        ctr++;
    }
    if (Is(study_notebook_read)){
        message("%nl \\", ni_study_note);
        ctr++;
    }
    if (Is(secret_room_note_read)){
        message("%nl \\", ni_secret_room_note);
        ctr++;
    }
    if (Is(secret_room_book_read)){
        message("%nl \\", ni_secret_room_book);
        ctr++;
    }
    if (Is(secret_room_book_read)){
        message("%nl \\", ni_secret_room_book);
        ctr++;
    }
	
*/


void command_look_item(noun_id_t nid){
    switch(nid){
    case ni_newspaper:
		msg_look_newspaper();
        Set(newspaper_looked);
        return;
    case ni_candle:
		if (Is(candle_lit)){
			message("ФΤĤ%nn", nid);
		}
		else {
			message("%nn", nid);
		}
		return;
	case ni_lantern:
        if (Is(lantern_lit)){
            message("ΤĤ%nn", nid);
        }
        else {
            message("⤭Ѥ%nn", nid);
        }
        return;
    case ni_slingshot:
		if (Is(slingshot_repaired)){
			message("%nn", nid);
		}
		else {
			message("줿%nn", nid);
		}
		return;
    case ni_belt:
        message("緿Ѥμؤʳޤ֤鲼äƤ롣");
        return;
    case ni_fishing_rod:
        message("̤%nn\\", nid);
		if (Is(fishing_rod_with_sponge)){
			message("ˤ%nnäƤ롣",
                    ni_sponge);
		}
        else {
            message("");
        }
		return;
    case ni_sponge:
        if (Is(fishing_rod_with_sponge)){
            message("ˤ˰ä\\");
        }
        message("ѤΥݥ󥸤\\");
		if (Is(sponge_wet)){
			message("򤿤äפȴޤǤ롣");
		}
		else {
            message("");
		}
		return;
	default:
		break;
	}
    message(noun_description(nid));
}
void command_examine_item(noun_id_t nid){
    switch(nid){
    case ni_glasses:
        if (Is(man_checked)){
            message("̿Υ襷ζƤΤ˻Ƥ롣");
        }
        else {
            msg_nothing_special();
        }
        break;
    case ni_toy_swordman:
    case ni_toy_lion:
    case ni_toy_bird:
    case ni_toy_dragon:
        message("ѷΤǤ褦ˤʤäƤ롣");
        break;
    case ni_robot:
        message("Ρ饤ĻδѷΤΤ");
        break;
    case ni_large_robot:
        message("ܥåȤȥɥ饴δѷΤΤ");
        break;
	case ni_score:
		message("ԥѤγΤ褦");
		break;
        //    case ni_card:
        //        message("ڡɤΥåΥɤʤˤ񤤤Ƥ롣");
        //        break;
    case ni_diary:
        msg_examine_diary();
        Set(diary_examined);
        break;
    case ni_paper:
        message("ĢΥڡˤΤΤ褦");
        break;
	case ni_wastepaper:
		message("Ƥߤȡʤˤ񤤤Ƥ롣");
		message("ɤҶ%nlΤ褦", ni_essay);
        get_item(ni_essay);
        lose_item(ni_wastepaper);
		break;
	case ni_slingshot:
		message("ϤǾФʤɤФ\\");
		if (Is(slingshot_repaired)){
			message("ޤ줿%nnѤƤ롣",
		            ni_branch);
		}
		else {
			message("ǰʤ顢ޤƤ뤿Ȥʤ");
		}
		break;
    case ni_belt:
        message("ؤˤ֤鲼줿ޤθ򳫤ȡ"
                "椫龮ǤΤ褦ʤΤФƤ");
        lose_item(ni_belt);
        get_item(ni_amulet);
        return;
	case ni_amulet:
		message("򿧤ξФ̯ĤΰĦƤ롣");
		break;   
	case ni_fossil:
		message("äȽŤ");
		break;   
	case ni_hat:
        if (Is(newspaper_looked)){
            message("ʹμ̿纴֤äƤΤƱ\\");
        }
        message("Τ褦ʡ㿧ߤäƤ롣");
        break;

    case ni_origami_plane:
        message("񤤤Ƥ롣"
                "ΡȤΥڡʤˤޤäƺä褦");
        break;
	case ni_mirror:
		message("΢¦ˤʤˤ񤤤Ƥ롣");
		break;
	case ni_chicken:
		message("֤ŤΤΤϤ"
				"Ի׵ĤʤȤ⤻Ǥ⿩٤줽˸롣");
		break;
	case ni_bottle:
		message("ˤϴ̯ʹΤʴäƤ롣");
		break;
	case ni_lantern:
        if (Is(lantern_lit)){
            message("󥿥Ƥ롣\\");
        }
        else {
            message("󥿥ϾäƤ롣\\");
        }
		message("ϤޤʬäƤ롣");
		break;
    default:
        msg_nothing_special();
    }
}
void command_get_item(noun_id_t nid, flag_id_t fid){
    message("%nn줿", nid);
	get_item(nid);
	if (fid != fi_invalid){
		set_flag(fid);
	}
}
void command_put_item(noun_id_t nid, flag_id_t fid, char *msg){
	if (msg == NULL){
		message("%nn֤", nid);
	}
	else {
		message(msg, nid);
	}
	lose_item(nid);
	if (fid != fi_invalid){
		set_flag(fid);
	}
}
void command_use_item(noun_id_t nid){
    switch(nid){
    case ni_slingshot:
        if (Not(slingshot_repaired)){
            message("ѥ󥳤ϲƤ롣");
        }
        else if (!has_item(ni_marble)){
            message("ƤˤΤʤ");
        }
        else {
            message("꤬ʤ");
        }
        return;
    case ni_lantern:
        if (Is(lantern_lit)){
            message("%nnϤ⤦Ƥ롣", nid);
        }
        else {
            if (Has(candle) && Is(candle_lit)){
                message("%nnȤä%nn", ni_candle, nid);
                Set(lantern_lit);
            }
            else {
                message("ǳäƤ뤬м郎ʤ");
            }
        }
        return;
	default:
        msg_cannot_do();
		break;
	}
}
void command_read_item(noun_id_t nid){
    switch(nid){
    case ni_leaflet:
        msg_read_leaflet();
        Set(leaflet_read);
        break;
    case ni_newspaper:
        msg_read_newspaper();
        Set(newspaper_read);
        break;
    case ni_score:
        message("֥꡼Τˡפγ");
        break;
        //    case ni_card:
        //        msg_read_card();
        //        break;
    case ni_origami_plane:
        message("ޤꤿǤΤǡΤޤޤǤɤʤ");
        break;
        //    case ni_postcard:
        //        msg_read_postcard();
        //        break;
    case ni_essay:
        msg_read_essay();
        Set(essay_read);
        break;
    case ni_diary:
        msg_read_diary();
        Set(diary_read);
        break;
    case ni_paper:
        msg_read_diary_piece();
        Set(diary_piece_read);
        break;
        //    case ni_letter:
        //        msg_read_letter();
        //        break;
    case ni_mirror:
        msg_read_mirror();
        Set(mirror_read);
        break;
        //    case ni_easy_necromancy:
        //        msg_read_easy_necromancy();
        //        break;
        //    case ni_logbook:
        //        msg_read_logbook();
        //        break;
    default:
        msg_cannot_read();
    }
}
void command_combine_item(noun_id_t nid){
    clear_combine_flags();
    if (nid == ni_toy_swordman ||
        nid == ni_toy_lion ||
        nid == ni_toy_bird)
        {
            combine_query_count = 2;
        }
    set_combine_flag(nid);
    combine_base_nid = nid;
    message("ȹΤ?");
    set_command_callback(command_callback_combine);
    set_term_prompt(QUERY_PROMPT);
}

void command_dismantle_item(noun_id_t nid){
    switch (nid){
    case ni_robot:
        lose_item(ni_robot);
        get_item(ni_toy_swordman);
        get_item(ni_toy_lion);
        get_item(ni_toy_bird);
        break;
    case ni_large_robot:
        lose_item(ni_large_robot);
        get_item(ni_robot);
        get_item(ni_toy_dragon);
        break;
	case ni_slingshot:
		lose_item(ni_slingshot);
		get_item(ni_rubber_strip);
		if (Is(slingshot_repaired)){
			get_item(ni_branch);
		}
        break;
    case ni_origami_plane:
        lose_item(ni_origami_plane);
        //        get_item(ni_diary_piece);
        get_item(ni_paper);
        break;
    case ni_fishing_rod:
    case ni_sponge:
        if (Is(fishing_rod_with_sponge)){
            message("%nn%nn鳰", ni_sponge, ni_fishing_rod);
            Reset(fishing_rod_with_sponge);
            return;
        }
        else {
            message("%nnʬǤʤ", nid);
            return;
        }
    default:
        message("%nnʬǤʤ", nid);
        return;
    }
    message("%nnʬ򤷤", nid);
}
        

void command_remove_item(noun_id_t nid){
    switch (nid){
    case ni_sponge:
        if (has_item(ni_fishing_rod) && Is(fishing_rod_with_sponge)){
            command_dismantle_item(ni_fishing_rod);
        }
        break;
    default:
        message("%nnϳʤ", nid);
    }
}


#ifdef DEBUG
void command_teleport(noun_id_t nid){
    switch(nid){
    case ni_entrance:
        move_area(ai_entrance);
        break;
    case ni_entrance_hall:
        move_area(ai_entrance_hall);
        break;
    case ni_kitchen:
        move_area(ai_kitchen);
        break;
    case ni_dining:
        move_area(ai_dining);
        break;
    case ni_living:
        move_area(ai_living);
        break;
    case ni_bathroom:
        move_area(ai_bathroom);
        break;
    case ni_boys_room:
        move_area(ai_boys_room);
        break;
    case ni_music_room:
        move_area(ai_music_room);
        break;
    case ni_study:
        move_area(ai_study);
        break;
    case ni_library:
        move_area(ai_library);
        break;
    case ni_cellar:
        move_area(ai_cellar);
        break;
    case ni_secret_room:
        move_area(ai_secret_room);
        break;
    case ni_cave:
        move_area(ai_cave);
        break;
    case ni_working_room:
        move_area(ai_working);
        break;
    default:
        message("%nnؤžܤǤʤ", nid);
        break;
    }
}
void command_summon(noun_id_t nid){
    if (IsNounItem(nid)){
        if (has_item(nid)){
            message("%nnϤ⤦äƤ롣", nid);
            return;
        }
        else {
            message("ƥ%nnפ򾤴", nid);
            get_item(nid);
        }
    }
}
void command_flag(noun_id_t nid){
    switch(nid){
    case ni_candle:
        toggle_flag(fi_candle_lit);
        break;
    case ni_easy_necromancy:
        toggle_flag(fi_ghost_appeared);
        break;
    case ni_armor:
        toggle_flag(fi_armor_dead);
        break;
    case ni_sponge:
        toggle_flag(fi_sponge_wet);
        break;
    case ni_magic_circle:
        toggle_flag(fi_magic_circle_invoked);
        break;
    case ni_machine:
        toggle_flag(fi_cycrotron_activated);
        break;
    case ni_water:
        toggle_flag(fi_great_old_one_gone);
        toggle_flag(fi_temple_unsunken);
        break;
	case ni_car:
		toggle_flag(fi_temple_ceiling_destroyed);
		break;
	case ni_lantern:
		toggle_flag(fi_temple_burning);
		break;
    default:
        message("%nnȤե饰Ϥʤ", nid);
        break;
    }
}
#endif
void set_command_callback(int (*callback)(char *)){
    command_callback = callback;
}
void clear_command_callback(void){
    command_callback = NULL;
    set_term_prompt(NULL);
}
void enter_door(area_id_t id, flag_id_t flag){
    message("򳫤ưư");
    if (flag != fi_invalid){
        set_flag(flag);
    }
    move_area(id);
}

int command_callback_input(char *line){
    char *noun;
    noun_id_t nid;

    if (*line != '\0'){
        parse_noun(line, &noun);
        nid = get_noun_id(noun);

        //        message("combine callbacked %s:%d:%s", line, nid, noun);
        switch (nid){
        case ni_english:
            message("ѸϤڤؤޤ");
            set_term_input_mode(im_english);
            break;
        case ni_hiragana:
            message("Ҥ餬Ϥڤؤޤ");
            set_term_input_mode(im_hiragana);
            break;
        case ni_katakana:
            message("Ϥڤؤޤ");
            set_term_input_mode(im_katakana);
            break;
        default:
            message("¾θϤ狼ޤ");
        }
    }
    //    clear_command_callback();
    //    set_console_prompt(NULL);
    return 0;
}



void clear_combine_flags(void){
    int i;
    for (i = 0 ; i < ni_end ; i++){
        combine_flags[i] = 0;
    }
    combine_query_count = 1;
    combine_item_count = 0;
}
void set_combine_flag(noun_id_t nid){
    assert(nid != ni_invalid);
    if (combine_flags[nid] == 0){
        combine_item_count ++;
        combine_flags[nid] = 1;
    }
}
int command_callback_combine(char *line){
    char *noun;
    noun_id_t nid;

    parse_noun(line, &noun);
    printf("line:%s: noun:%s:", line, noun);
    nid = get_noun_id(noun);
    if (nid == ni_unknown) return 0;

//    message("combine callbacked %s:%d:%s q:%d i:%d", line, nid, noun,
//            combine_query_count, combine_item_count);
    if (!has_item(nid)){
        message("%nnäƤʤ", nid);
        return 0;
    }
    combine_query_count --;
    set_combine_flag(nid);
    if (combine_query_count > 0) return 1;
    switch (combine_base_nid){
    case ni_toy_swordman:
    case ni_toy_lion:
    case ni_toy_bird:
        if (combine_item_count < 3){
            message("ϻιΤΤ褦");
        }
        else if (combine_flags[ni_toy_swordman] &&
                 combine_flags[ni_toy_lion] &&
                 combine_flags[ni_toy_bird])
        {
            message("ιΤ%nlˤ", ni_robot);
            get_item(ni_robot);
            lose_item(ni_toy_swordman);
            lose_item(ni_toy_lion);
            lose_item(ni_toy_bird);
        }
        else {
			msg_combine_unmatched();
        }
        break;
    case ni_robot:
    case ni_toy_dragon:
        if (combine_flags[ni_robot] && combine_flags[ni_toy_dragon]){
            message("Τ%nlˤ", ni_large_robot);
            get_item(ni_large_robot);
            lose_item(ni_robot);
            lose_item(ni_toy_dragon);
        }
        else {
			msg_combine_unmatched();
        }
        break;
	case ni_branch:
	case ni_rubber_strip:
        if (combine_flags[ni_branch] && combine_flags[ni_rubber_strip]){
            message("%nn%nnӤĤ%nlä",
					ni_branch, ni_rubber_strip, ni_slingshot);
			Set(slingshot_repaired);
            get_item(ni_slingshot);
            lose_item(ni_branch);
            lose_item(ni_rubber_strip);
        }
        else {
			msg_combine_unmatched();
        }
        break;
	case ni_fishing_rod:
	case ni_sponge:
        if (combine_flags[ni_fishing_rod] && combine_flags[ni_sponge]){
            if (Not(fishing_rod_with_sponge)){
                message("ˤ%nnä",
                        ni_sponge);
                Set(fishing_rod_with_sponge);
            }
            else {
                message("%nnϤ⤦ˤ˰äƤ롣",
                        ni_sponge);
            }
        }
        else {
			msg_combine_unmatched();
        }
        break;
    default:
		msg_combine_unmatched();
        break;
    }
    //    command_callback = NULL;
    //    set_console_prompt(NULL);
    return 0;
}


void strip_space(char *line){
    unsigned int code;
    int byte;
    char buf[1024];
    char *lp = line, *bp = buf;

    while (*lp != '\0'){
        code = jstrcode(lp, &byte);
        if (byte > 1){
            jstrappend(bp, code, byte);
            bp += byte;
        }
        else {
            if (*lp != ' '){
                jstrappend(bp, code, byte);
                bp += byte;
            }
        }
        lp += byte;
    }
    *bp = '\0';
    strcpy(line, buf);
}
