#ifndef COMMAND_H
#define COMMAND_H
#include "layout.h"
#include "noun.h"
#include "verb.h"
#include "status.h"

#define COMMAND_MAX_LENGTH CONSOLE_CHR_WIDTH

#define ReturnNotExist {*exist=0; return 0;}
#define ReturnIfHasItem \
	if (has_item(nid)){	\
		*exist = 0;		\
		return 0;		\
	}
#define EnterDoor(area, flag) enter_door(ai_ ## area, fi_ ## flag ## _door_opened)

void init_command(void);
void interpret_line(char *line);
void parse_command(char *line, char **verb, char **noun);
char *parse_verb(char *line, char **verb);
void parse_noun(char *line, char **noun);

verb_id_t get_verb_id(char *verb, noun_id_t nid);
void exec_command(verb_id_t vid, noun_id_t nid, char *verb, char *noun);
//void set_post_message(void (*msg)(void));
int exec_command_item(verb_id_t vid, noun_id_t nid, int exist);
void show_help(noun_id_t nid, char *noun);
void show_inventory(void);
void show_debug(void);
void config(noun_id_t nid, char *noun);
void command_quit(void);
int command_callback_quit(char *line);
void command_recall(noun_id_t nid);
void list_recall(void);
void command_look_item(noun_id_t nid);
void command_examine_item(noun_id_t nid);
// åФnid롣fid!=fi_invalidʤfidONˤ롣
void command_get_item(noun_id_t nid, flag_id_t fid);
void command_put_item(noun_id_t nid, flag_id_t fid, char *msg);
void command_use_item(noun_id_t nid);
void command_read_item(noun_id_t nid);
void command_combine_item(noun_id_t nid);
void command_dismantle_item(noun_id_t nid);
void command_remove_item(noun_id_t nid);
void command_teleport(noun_id_t nid);
void command_summon(noun_id_t nid);
void command_flag(noun_id_t nid);
void set_command_callback(int (*callback)(char *));
void clear_command_callback(void);
void enter_door(area_id_t id, flag_id_t flag);

//int command_callback_adjust_clock(char *line);
//int command_callback_talk_dog(char *line);
int command_callback_input(char *line);
void clear_combine_flags(void);
void set_combine_flag(noun_id_t nid);
int command_callback_combine(char *line);
void strip_space(char *line);

#endif
