#ifndef DIC_H
#define DIC_H
#include "config.h"

#define INVALID_WORD_IX (-1)

typedef struct {
  char *word;
  int id;
} dic_entry_t;

typedef struct {
    dic_entry_t entries[WORD_MAX_NUM];
    int num;
} dic_t;

typedef struct {
    char *word;
    int id;
} esynonym_t;

typedef struct {
    char *hiragana;
    char *katakana;
    int id;
} jsynonym_t;

void init_dic(dic_t *dic);
void register_dic(dic_t *dic, char *word, int id);
int get_word_ix(char *word, dic_t *dic);
int word_ix2id(int ix, dic_t *dic);
char *ix2word(int ix, dic_t *dic);
#endif
