#include <stdio.h>
#include "config.h"
#include "history.h"
#include "verb.h"
#include "noun.h"

void prev_history(history_t *hist);
void next_history(history_t *hist);

static history_mode_t history_mode = hm_verb;

void init_history(history_t *hist){
    int i;
    for (i = 0 ; i < HISTORY_SIZE ; i++){
        hist->entries[i].ix = INVALID_WORD_IX;
    }
    hist->tail = 0;
    hist->ix = 0;
}

void register_history(int dic_ix, history_t *hist){
	int ix, found = 0;

    //	printf("register_hist dic_ix:%d\n", dic_ix);
	for (ix = 0 ; ix < HISTORY_SIZE ; ix++){
        //		printf("%d:%d ", ix, hist->entries[ix].ix);
	}
    //	printf(" tail:%d\n", hist->tail);
    if (dic_ix < INVALID_WORD_IX) return; // ͭñΤϿ
    ix = (hist->tail + 1) % HISTORY_SIZE;
    while (ix != hist->tail){
//        printf("%d:%d %d\n", ix, verb_histories[ix].ix, history_tail);
        if (hist->entries[ix].ix == dic_ix){
            found = 1;
        }
        if (found){
            hist->entries[ix] = hist->entries[(ix + 1) % HISTORY_SIZE];
        }
        else {
        }
        ix = (ix + 1) % HISTORY_SIZE;
    }
    if (found){
        hist->tail = (hist->tail + HISTORY_SIZE - 1) % HISTORY_SIZE;
    }
    //	printf("tail:%d\n", hist->tail);
	hist->entries[hist->tail].ix = dic_ix;
	hist->tail = (hist->tail + 1) % HISTORY_SIZE;
	hist->ix = hist->tail;
    hist->entries[hist->tail].ix = INVALID_WORD_IX;
#ifdef DEBUG
	for (ix = 0 ; ix < HISTORY_SIZE ; ix++){
		printf("%d:%d ", ix, hist->entries[ix].ix);
	}
	printf("\n");
#endif
}

void prev_history(history_t *hist){
    int ix_old = hist->ix;

	if (hist->entries[hist->ix].ix == INVALID_WORD_IX){
        while (hist->entries[hist->ix].ix == INVALID_WORD_IX){
            //	printf("hist ix %d %d\n", hist->ix, hist->entries[hist->ix].ix);
            hist->ix = (hist->ix + HISTORY_SIZE - 1) % HISTORY_SIZE;
            if (hist->ix == ix_old) break;
        }
    }
    else {
        hist->ix = (hist->ix + HISTORY_SIZE - 1) % HISTORY_SIZE;
    }
    //	printf("hist prev %d->%d\n", ix_old, hist->ix);
}
void next_history(history_t *hist){
    int ix_old = hist->ix;

	if (hist->entries[hist->ix].ix == INVALID_WORD_IX){
        while (hist->entries[hist->ix].ix == INVALID_WORD_IX){
            //	printf("hist ix %d %d\n", hist->ix, hist->entries[hist->ix].ix);
            hist->ix = (hist->ix + 1) % HISTORY_SIZE;
            if (hist->ix == ix_old) break;
        }
    }
    else {
        hist->ix = (hist->ix + 1) % HISTORY_SIZE;
    }
    //	printf("hist next %d->%d\n", ix_old, hist->ix);
}


void prev_history_line(void){
	if (history_mode == hm_verb){
		prev_history_verb();
	}
	else {
		prev_history_noun();
	}
}
void next_history_line(void){
	if (history_mode == hm_verb){
		next_history_verb();
	}
	else {
		next_history_noun();
	}
}
char *get_history_line(void){
	if (history_mode == hm_verb){
		return get_history_verb();
	}
	else {
		return get_history_noun();
	}
}
void set_history_mode(history_mode_t mode){
	history_mode = mode;
}

