#ifndef HISTORY_H
#define HISTORY_H
#include "verb.h"
#include "noun.h"
#include "status.h"

typedef struct {
	int ix;
} history_entry_t;

typedef struct {
    history_entry_t entries[HISTORY_SIZE];
    int tail;
    int ix;
} history_t;

typedef enum {
	hm_verb, hm_noun
} history_mode_t;

void register_history(int dic_ix, history_t *hist);
void init_history(history_t *hist);

void prev_history(history_t *hist);
void next_history(history_t *hist);
void prev_history_line(void);
void next_history_line(void);
char *get_history_line(void);
void set_history_mode(history_mode_t mode);


#endif
