#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>
#include "input_line.h"
#include "jstr.h"

// ʸγʸξ
typedef struct {
    int ix;      // ʸΰ(line[]Υǥå)
    int width;   // Ƭ餽ʸޤǤ
    //    int byte;    // Ƭ餽ʸޤǤΥХȿ
} chr_attr_t;
// ʸγñξ

// ʸΰ
static char *line;
// ʸĹ(Х)
static int line_byte;
// ʸ(եɽ)
static int line_width;
// ʸ
static int line_width_max;
// ʸʸ
static int chr_num;
// ʸñ(ʸǶڤ줿ΰ)
static int word_num;

// ʸγʸξ
static chr_attr_t *chr_attrs;
// ʸγñƬ
// (ññ̤char_attrsȤä䤹褦chr_attrs[]Υǥå)
static int *word_ixs;

// ߤʸʤ0
// ʸ󤬶ʸ(line_byte==0)λ0
static int is_tail_spc;

//static char prompt[JBufSize(PROMPT_WIDTH_MAX)+1];
static int prompt_byte = 0;
static int prompt_width = 0;

static char cursor = '_';


void terminate_input_line(void);

int input_line_init(int width_max){
    line_width_max = width_max;
    chr_attrs = malloc(sizeof(chr_attr_t)*width_max);
    word_ixs = malloc(sizeof(int)*width_max);
    line = malloc(JBufSize(width_max)+2);
    if (line == NULL) return 1;
    // ե饰mallocΰ襯ꥢΤclear()ɬ
    input_line_clear();
    return 0;
}

// ץץȡޤΤ(ɽѡʸѹԲ)
char *input_line_get_line(void){
    return line;
}
// (ץץȡ)ΰ˥ԡ
// inputɬפ礭ݤƤ
int input_line_get_input(char *input){
    strncpy(input, &line[prompt_byte], line_byte-prompt_byte);
    input[line_byte-prompt_byte] = '\0';
    return 0;
}

int input_line_get_byte(void){
    return line_byte;
}
int input_line_get_width(void){
    return line_width;
}
int input_line_get_chr_num(void){
    return chr_num;
}
// ñ(is_tail_spcΤȤϡñޤ
int input_line_get_word_num(void){
        return word_num;
}
int input_line_is_tail_spc(void){
        return is_tail_spc;
}


int input_line_clear(void){
    //    printf("clear %d %d\n", prompt_byte, prompt_width);
    line_byte = prompt_byte;
    line_width = prompt_width;
    chr_num = 0;
    word_num = 0;
    is_tail_spc = 1;
    terminate_input_line();
    return 0;
}

void terminate_input_line(void){
    line[line_byte] = cursor;
    //    line[line_byte] = '_';
    line[line_byte+1] = '\0';
}

int input_line_append_chr(char chr){

    if (line_width >= line_width_max) return 1;

    line[line_byte] = chr;
    chr_attrs[chr_num].ix = line_byte;
    chr_attrs[chr_num].width = line_width;
    //    char_bytes[char_num] = 1;
    line_byte ++;
    line_width ++;
    chr_num ++;
    terminate_input_line();

    if (chr == ' '){
        is_tail_spc = 1;
    }
    else {
        if (is_tail_spc){
            word_ixs[word_num] = chr_num-1; //chr_ixs[char_num-1];
            word_num ++;
            is_tail_spc = 0;
        }
    }
    return 0;
}

int input_line_append_code(unsigned int code, int byte){

    if (byte == 1) return input_line_append_chr((char)code);

    if (line_width + 2 >= line_width_max) return 1;

    jstrappend(&line[line_byte], code, byte);
    chr_attrs[chr_num].ix = line_byte;
    chr_attrs[chr_num].width = line_width;
    line_byte += byte;
    line_width += 2;
    chr_num ++;
    terminate_input_line();

    if (is_tail_spc){
        word_ixs[word_num] = chr_num-1; //chr_ixs[char_num-1];
        word_num ++;
        is_tail_spc = 0;
    }
    return 0;
}

int input_line_set_str(char *str){
    input_line_clear();
    return input_line_append_str(str);
}

int input_line_append_str(char *str){
    unsigned int code;
    int byte;
    while (*str != '\0'){
        code = jstrcode(str, &byte);
        input_line_append_code(code, byte);
        str += byte;
    }
    return 0;
}


int input_line_backspace(void){
    if (line_byte == prompt_byte) return 1;

    //    printf("bs chr_num:%d word_num:%d is_tail:%d  (%d, %d)\n", chr_num, word_num, is_tail_spc, word_ixs[word_num-1], chr_attrs[chr_num-1].ix);
    //    if (word_ixs[word_num-1] == chr_attrs[chr_num-1].ix){
    if (word_ixs[word_num-1] == chr_num-1){
        word_num --;
        is_tail_spc = 1;
    }
    else {
        is_tail_spc = 0;
    }
    chr_num --;
    assert(chr_num >= 0);
    line_byte = chr_attrs[chr_num].ix;
    line_width = chr_attrs[chr_num].width;
    //    printf("bs2 chr_num:%d word_num:%d is_tail:%d\n", chr_num, word_num, is_tail_spc);
    /*
    byte = char_bytes[char_num];
    line_byte -= byte;
    line_width -= (byte==1) ? 1 : 2;
    */
    terminate_input_line();
    return 0;
}

// ñ
int input_line_delete_word(void){
    if (word_num == 0) return 1;

    word_num --;
    is_tail_spc = 1;
    chr_num = word_ixs[word_num];
    line_byte = chr_attrs[chr_num].ix;
    line_width = chr_attrs[chr_num].width;
    terminate_input_line();
    return 0;
}

int input_line_set_prompt(char *new_prompt){
    int new_width, new_len, len;

    new_width = jstrwidth(new_prompt);
    if (new_width > PROMPT_WIDTH_MAX) return 1;
    new_len = strlen(new_prompt);
    // ư뤿+1
    len = line_byte - prompt_byte + 1;
    // '\0'ʬ+1
    memmove(line+new_len, line+prompt_byte, len+1);

    line_width -= prompt_width;
    prompt_width = new_width;
    line_width += prompt_width;

    line_byte -= prompt_byte;
    prompt_byte = new_len;
    line_byte += prompt_byte;

    assert(prompt_byte < JBufSize(PROMPT_WIDTH_MAX));
    memcpy(line, new_prompt, new_len);


    //    printf("set prompt %d %d %d %d|%s|%s|\n", prompt_width, prompt_byte, new_len, len, new_prompt, line);
    return 0;
}

int input_line_set_cursor(char new_cursor){
    //    printf("change cursor %c->%c\n", cursor, new_cursor);
    cursor = new_cursor;
    terminate_input_line();
    return 0;
}

#ifdef DEBUG
void input_line_print_line(void){
    int i;
    printf("%d %d|%s|\n", prompt_byte, line_byte, line);
    printf("chrs:%d:", chr_num);
    for (i = 0 ; i < chr_num ; i++){
        printf("%2d(%2d, %1d)", i, chr_attrs[i].ix, chr_attrs[i].width);
    }
    puts("");
    printf("words:%d(%d):", word_num, is_tail_spc);
    for (i = 0 ; i < word_num ; i++){
        printf("%2d, ", word_ixs[i]);
    }
    puts("");
}
#endif


