#include <stdio.h>
#include <stdlib.h>
#include <EzGraph.h>   
#include "config.h"
#include "layout.h"
#include "map.h"
#include "area.h"
#include "status.h"


// ǡΰŪʥեå
#define DRAW_OFFSET 90

int show_minimap = 1;
int minimap_location = 1;
int overlay_minimap = 1;
pos_t minimap_lt_table[] = {
    {GRAPHIC_LT_X + 2, GRAPHIC_LT_Y + 2},
    {GRAPHIC_RB_X - (MINIMAP_WIDTH + 2), GRAPHIC_LT_Y + 2},
    {GRAPHIC_RB_X - (MINIMAP_WIDTH + 2), GRAPHIC_RB_Y - (MINIMAP_HEIGHT + 2)},
    {GRAPHIC_LT_X + 2, GRAPHIC_RB_Y - (MINIMAP_HEIGHT + 2)},
};
#define MINIMAP_LOCATION_NUM (sizeof(minimap_lt_table)/sizeof(pos_t))
pos_t minimap_lt;

int aid2mid_table[ai_end];

int aid2mid(area_id_t aid){
    return aid2mid_table[aid];
}

// ϭ+8
//  16x20
map_area_t map_areas[] = {

    {ai_mailbox, 1,
     "",
     {{0, 0}, {0, 0}},
     {1, 158}, di_upright},
    {ai_opened_window, 1,
     "",
     {{0, 0}, {0, 0}},
     {184, 86}, di_up},
    {ai_washtub, 1,
     "",
     {{0, 0}, {0, 0}},
     {224, 56}, di_left},
    {ai_backdoor, 1,
     "",
     {{0, 0}, {0, 0}},
     {224, 36}, di_left},
    {ai_under_tree, 1,
     "",
     {{0, 0}, {0, 0}},
     {182, 24}, di_down},
    {ai_garden, 1,
     "",
     {{0, 0}, {0, 0}},
     {102, 58}, di_left},

	{ai_entrance, 1,
     "bl",
     {{150, 80}, {174, 90}, {158, 79}, {166, 79}},
     {0, 0}, di_up},
	{ai_entrance_hall, 1,
     "blll",
     {{150, 60}, {174, 80},
	  {158, 59}, {166, 59}, {149, 74}, {149, 78}, {175, 74}, {175, 78}},
     {0, 74}, di_up},
	{ai_corridor_1f_fl, 1,
     "llll",
     {{126, 72}, {126, 80}, {126, 80}, {150, 80}, {134, 72}, {150, 72},
	  {140, 71}, {144, 71}},
     {146, 76}, di_left},
    {ai_guestroom_1f, 1,
     "b",
     {{134, 52}, {150, 72}},
     {0, 66}, di_up},
    {ai_corridor_1f_bl, 1,
     "lllll",
	{{126, 52}, {126, 72}, {126, 52}, {134, 52}, {134, 52}, {134, 72},
      {125, 58}, {125, 62}, {128, 51}, {132, 51}},
     {130, 68}, di_up},
    {ai_playroom, 1,
     "b",
     {{110, 52}, {126, 80}},
     {120, 0}, di_left},
    {ai_living, 1,
     "bl",
     {{110, 32}, {150, 52}, {149, 34}, {149, 38}},
     {0, 46}, di_up},

	{ai_dining, 1,
     "bl",
     {{150, 32}, {174, 60}, {175, 34}, {175, 38}},
     {0, 54}, di_up},
    {ai_kitchen, 1,
     "bl",
     {{174, 32}, {190, 52}, {189, 34}, {189, 38}},
     {0, 44}, di_up},
    {ai_corridor_1f_br, 1,
     "llll",
     {{190, 32}, {190, 52}, {198, 32}, {198, 52}, {190, 32}, {198, 32},
      {199, 34}, {199, 38}},
     {194, 48}, di_up},
    {ai_laundry, 1,
     "bl",
     {{198, 32}, {218, 48}, {217, 34}, {217, 38}},
     {204, 0}, di_right},
    {ai_corridor_1f_mr, 1,
     "llll",
     {{190, 52}, {190, 72}, {198, 52}, {198, 80}, {190, 80}, {198, 80},
      {199, 58}, {199, 62}},
     {194, 68}, di_up},
    {ai_storage, 1,
     "b",
     {{198, 48}, {218, 80}},
     {204, 0}, di_right},
    {ai_corridor_1f_fr, 1,
     "lll",
     {{174, 72}, {190, 72}, {174, 80}, {190, 80},
     {180, 71}, {184, 71}},
     {178, 76}, di_right},
	{ai_bathroom, 1,
     "b",
     {{174, 52}, {190, 72}},
     {0, 66}, di_up},

	{ai_landing, 2,
     "bl",
     {{150, 60}, {174, 72}, {158, 59}, {166, 59}},
     {0, 0}, di_up},
    {ai_corridor_2f_c, 2,
     "lll",
     {{150, 52}, {174, 52}, {150, 60}, {174, 60},
     {162, 51}, {166, 51}},
     {164, 57}, di_up},
    {ai_boys_room, 2,
     "b",
     {{156,  32}, {174, 52}},
     {0, 46}, di_up},
    {ai_bed, 2,
     "",
	{{0, 0}, {0, 0}},
     {166, 40}, di_right},
    {ai_corridor_2f_l, 2,
     "llllll",
     {{134, 52}, {150, 52}, {134, 60}, {150, 60}, {134, 52}, {134, 60}, 
      {140, 51}, {144, 51}, {140, 61}, {144, 61}, {133, 54}, {133, 58}},
     {148, 56}, di_left},
    {ai_girls_room, 2,
     "bl",
     {{134,  32}, {156, 52},
      {133,  34}, {133, 38},},
     {0, 46}, di_up},
    {ai_guestroom_2f, 2,
     "b",
     {{134, 60}, {150, 80}},
     {0, 66}, di_down},
    {ai_music_room, 2,
     "bll",
     {{110,  32}, {134, 60},
      {111,  44}, {111, 48}, {112,  61}, {116, 61}},
     {128, 0}, di_left},
    {ai_balcony, 2,
     "b",
     {{102,  32}, {110, 80}},
     {0, 0}, di_left},
    {ai_balcony_down, 2,
     "",
	 {{0, 0}, {0, 0}},
     {102, 56}, di_left},
    {ai_bathroom_2f, 2,
     "b",
     {{110,  60}, {134, 80}},
     {0, 66}, di_down},

	{ai_corridor_2f_cr, 2,
     "lll",
     {{174, 52}, {190, 52}, {174, 60}, {190, 60},
     {180, 51}, {184, 51}},
     {176, 56}, di_right},
    {ai_ladys_room, 2,
     "b",
     {{174,  32}, {190, 52}},
     {0, 46}, di_up},
    {ai_wardrobe, 2,
     "",
	 {{0, 0}, {0, 0}},
     {178, 36}, di_right},
    {ai_study, 2,
     "bll",
     {{174,  60}, {190, 80},
      {189,  74}, {189, 78}, {180, 61}, {184, 61}},
     {0, 66}, di_down},

    {ai_corridor_2f_r, 2,
     "lllll",
     {{190, 52}, {206, 52}, {190, 60}, {206, 60}, {206, 52}, {206, 60},
      {196, 51}, {200, 51}, {196, 61}, {200, 61}},
     {192, 56}, di_right},
    {ai_bedroom, 2,
     "b",
     {{190,  32}, {206, 52}},
     {0, 46}, di_up},
    {ai_library, 2,
     "b",
     {{190,  60}, {218, 80}},
     {210, 0}, di_left},
    {ai_bookshelf, 2,
     "",
	 {{0, 0}, {0, 0}},
     {200, 74}, di_down},
    {ai_secret_room, 2,
//     "lllllllll",
     "bb",
	{{206, 32}, {218, 52}, {210, 53}, {214, 59}},
/*
{{206, 32}, {218, 32}, {206, 32}, {206, 52}, {218, 32}, {218, 52},
	  {206, 52}, {210, 52}, {214, 52}, {218, 52},
	  {210, 52}, {210, 60}, {214, 52}, {214, 60},
      {210, 59}, {214, 59}, {210, 53}, {214, 53}},
*/
     {212, 46}, di_up},


    {ai_cellar, 0,
     "bl",
     {{198, 32}, {218, 56}, {206, 55}, {210, 55}},
     {208, 36}, di_down},
    {ai_boiler_room, 0,
     "b",
     {{198, 56}, {218, 80}},
     {208, 60}, di_down},
    {ai_corridor_0f, 0,
     "llllll",
     {{198, 40}, {162, 38}, {162, 38}, {120, 66}, {120, 66}, {94, 68},
      {198, 48}, {164, 46}, {164, 46}, {120, 74}, {120, 74}, {90, 76}},
     {162, 42}, di_downleft},
    {ai_temple, 0,
     "llllllll",
     {{30, 30}, {65, 25}, {65, 25}, {90, 40}, 
      {90, 40}, {95, 65}, {95, 65}, {75,100},
      {75,100}, {35,120}, {35,120}, {-1,115},
      {-1,115}, {-1, 40}, {-1, 40}, {30, 30},
     /*
     {{45, 30}, {65, 25}, {65, 25}, {90, 40}, 
      {90, 40}, {95, 65}, {95, 65}, {75,100},
      {75,100}, {45,120}, {45,120}, {20,115},
      {20,115}, { 5, 85}, { 5, 85}, {15, 45},
      {15, 45}, {35, 30}, {35, 30}, {45, 30},
     */
     /*
     {{50, 30}, {65, 25}, {65, 25}, {90, 40}, 
      {90, 40}, {95, 65}, {95, 65}, {85, 80},
      {85, 80}, {50, 75}, {50, 75}, {35, 50},
      {35, 50}, {40, 35}, {40, 35}, {50, 30},
     */
     },
     {88, 70}, di_upleft},
    {ai_cave_entrance, 0,
     "llll",
	 {{75, 30}, {85, 20}, {85, 20}, {87, 12},
	  {81, 33}, {91, 21}, {91, 21}, {93, 12},
	 },
     {81, 28}, di_downleft},
    {ai_cave, 0,
     "llll",
	 {{75, 30}, {85, 20}, {85, 20}, {87, 12},
	  {81, 33}, {91, 21}, {91, 21}, {93, 12},
	 },
//     "",
//     {{0, 0}, {0, 0}},
     {83, 26}, di_upright},
{ai_under_cliff, 0,
     "",
     {{0, 0}, {0, 0}},
     {90, 8}, di_down},


};
#define MAP_AREA_NUM (sizeof(map_areas)/sizeof(map_area_t))

//#define TMP_X 96
#define TMP_X 0
// ǥХåλפʤΤǺ
int current_level;

void init_map(void){
    int i;
    for (i = 0 ; i < MAP_AREA_NUM ; i++){
        aid2mid_table[i] = INVALID_MAP_ID;
    }
    for (i = 0 ; i < MAP_AREA_NUM ; i++){
        aid2mid_table[map_areas[i].aid] = i;
    }
    minimap_lt = minimap_lt_table[minimap_location];
}


int x2mx(int x){
	return x + minimap_lt.x + TMP_X;
}
int y2my(int y){
	y += minimap_lt.y;
	if (current_level == 2){
        //         y += DRAW_OFFSET;
	}
	return y;
}

void draw_minimap_line(int sx, int sy, int ex, int ey){
    EzDrawLineB(x2mx(sx), y2my(sy), x2mx(ex), y2my(ey));
}
void draw_minimap_box(int sx, int sy, int ex, int ey){
    EzDrawBoxB(x2mx(sx), y2my(sy), x2mx(ex), y2my(ey));
}

void draw_minimap(void){
    int i, pos_ix;
    char *cmd;
    int sx, sy, ex, ey;
    map_id_t mid;
    int level;

    if (show_minimap == 0) return;
    if (current_area() < ai_system_end) return;

    mid = aid2mid(current_area());
    level = map_areas[mid].level;

    if (overlay_minimap){
        EzSetColorByRGB(128, 128, 128);
    }
    else {
        EzSetColorByRGB(0, 0, 0);
        EzFillBoxB(x2mx(0), y2my(0), x2mx(MINIMAP_WIDTH), y2my(MINIMAP_HEIGHT));
        EzSetColorByRGB(255, 255, 255);
    }

	current_level = 1;
    draw_minimap_box(-1-TMP_X, -1, MINIMAP_WIDTH+1-TMP_X, MINIMAP_HEIGHT+1);

    for (i = 0 ; i < MAP_AREA_NUM ; i++){
        // ̤ȯ褷ʤ
        if (!is_area_discovered(map_areas[i].aid)) continue;
        // ߤ볬ʳ褷ʤ
        if (map_areas[i].level != level) continue;
        pos_ix = 0;
        cmd = map_areas[i].cmd;
		current_level = map_areas[i].level; //!!
        while (*cmd != '\0'){
			sx = map_areas[i].pos[pos_ix].x;
            sy = map_areas[i].pos[pos_ix].y;
            pos_ix ++;
            ex = map_areas[i].pos[pos_ix].x;
            ey = map_areas[i].pos[pos_ix].y;
            pos_ix ++;
            switch (*cmd){
            case 'b':
				draw_minimap_box(sx, sy, ex, ey);
				break;
            case 'l':
				draw_minimap_line(sx, sy, ex, ey);
				break;
            default:
                printf("unknown map command %c(%d)\n", *cmd, *cmd);
                exit(1);
            }
            cmd ++;
        }
        //                draw_minimap_arrow(i);
    }
    if (mid != INVALID_MAP_ID){
        draw_minimap_arrow(mid);
    }
    // Ͼ塦ϲʤ鳳
	if (level < 2){
        draw_minimap_line(0, 8, 72, 12);
        draw_minimap_line(72, 12, 160, 10);
        draw_minimap_line(160, 10, 240, 16);
	}
    // Ͼʤ鲰ߤγɤ
    if (level > 0){
        current_level = 1;
        draw_minimap_box(110, 32, 218, 80);
        current_level = 2;
        draw_minimap_box(110, 32, 218, 80);
    }
}

void draw_minimap_arrow(map_id_t mid){
    int x, y;
	dir_t dir;

	if (map_areas[mid].apos.x > 0){
//        x = map_areas[mid].apos.x + SMAP_LT_X + TMP_X;
        x = map_areas[mid].apos.x;
    }
    else {
//        x = (map_areas[mid].pos[0].x + map_areas[mid].pos[1].x) / 2 + SMAP_LT_X + TMP_X;
        x = (map_areas[mid].pos[0].x + map_areas[mid].pos[1].x) / 2;
    }
    if (map_areas[mid].apos.y > 0){
//        y = map_areas[mid].apos.y + SMAP_LT_Y;
        y = map_areas[mid].apos.y;
    }
    else {
//        y = (map_areas[mid].pos[0].y + map_areas[mid].pos[1].y) / 2 + SMAP_LT_Y;
        y = (map_areas[mid].pos[0].y + map_areas[mid].pos[1].y) / 2;
    }

//    if (map_areas[mid].level == 2){
//        y += DRAW_OFFSET;
//    }

    dir = map_areas[mid].dir;
    if (dir == di_up || dir == di_down){
        draw_minimap_line(x, y-3, x, y+3);
    }
    else if (dir == di_left || dir == di_right){
        draw_minimap_line(x-3, y, x+3, y);
    }
    else if (dir == di_upright || dir == di_downleft){
        draw_minimap_line(x-2, y+2, x+2, y-2);
	}
    else {
        draw_minimap_line(x-2, y-2, x+2, y+2);
    }
    switch (dir){
    case di_up:
        draw_minimap_line(x, y-3, x-2, y-1);
        draw_minimap_line(x, y-3, x+2, y-1);
        break;
    case di_down:
        draw_minimap_line(x, y+3, x-2, y+1);
        draw_minimap_line(x, y+3, x+2, y+1);
        break;
    case di_left:
        draw_minimap_line(x-3, y, x-1, y-2);
        draw_minimap_line(x-3, y, x-1, y+2);
        break;
    case di_right:
        draw_minimap_line(x+3, y, x+1, y-2);
        draw_minimap_line(x+3, y, x+1, y+2);
        break;
    case di_upright:
        draw_minimap_line(x+0, y-2, x+2, y-2);
        draw_minimap_line(x+2, y-2, x+2, y-0);
        break;
    case di_upleft:
        draw_minimap_line(x-0, y-2, x-2, y-2);
        draw_minimap_line(x-2, y-2, x-2, y-0);
        break;
    case di_downleft:
        draw_minimap_line(x+0, y+2, x-2, y+2);
        draw_minimap_line(x-2, y+2, x-2, y+0);
        break;
    default:
        assert(0);
    }
}

void toggle_show_minimap(void){
    set_show_minimap(!is_minimap_shown());
}
void toggle_overlay_minimap(void){
    set_overlay_minimap(!is_overlay_minimap());
}
void toggle_minimap_location(void){
    int new_location;

    new_location = get_minimap_location() + 1;

    if (new_location == MINIMAP_LOCATION_NUM){
        new_location = 0;
    }
    set_minimap_location(new_location);
}
int is_minimap_shown(void){
    return show_minimap;
}
int is_overlay_minimap(void){
    return overlay_minimap;
}
int get_minimap_location(void){
    return minimap_location;
}
void set_show_minimap(int val){
    show_minimap = val;
}
void set_overlay_minimap(int val){
    overlay_minimap = val;
}
void set_minimap_location(int val){
    minimap_location = val;
    minimap_lt = minimap_lt_table[minimap_location];
    printf("minimap_loc:%d\n", minimap_location);
}
