#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "config.h"
#include "message.h"
#include "layout.h"
#include "console.h"
#include "jstr.h"
#include "command.h"
#include "verb.h"

void message(char *msg, ...){
    va_list ap;
    char buf[MESSAGE_MAX_LEN];
    char *msgp = msg, *bufp = buf, *p;
    int n;
    noun_id_t nid;
    verb_id_t vid;
    int byte;
    unsigned int code;

    //    printf("message:%s:\n", msg);

	va_start(ap, msg);
    while (*msgp != '\0'){
        //        printf("bufp:%p msgp:%s:\n", bufp, msgp);
        code = jstrcode(msgp, &byte);
        msgp += byte;
        if (byte > 1){
            jstrappend(bufp, code, byte);
            bufp += byte;
        }
        else if (code == '\\'){
            *bufp = '\0';
            print_term(buf);
            bufp = buf;
        }
        else if (code == '%'){
            switch(*msgp){
            case 's':
                p = va_arg(ap, char *);
                strcpy(bufp, p);
                bufp += strlen(p);
                break;
            case 'd':
                n = va_arg(ap, int);
                bufp += sprintf(bufp, "%d", n);
                break;
            // idǻꤷ̾ɽ
            case 'n':
                nid = va_arg(ap, noun_id_t);
                msgp ++;
                switch(*msgp){
                // ̾̾Ρñɽ
                case 'l':
                    p = noun_name(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = '[';
                    p = nid2noun(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = ']';
                    break;
                // ̾̾Τɽ
                case 'n':
                    p = noun_name(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    break;
                // ̾ñɽ
                case 'w':
                    *bufp++ = '[';
                    p = nid2noun(nid);
                    strcpy(bufp, p);
                    bufp += strlen(p);
                    *bufp++ = ']';
                    break;
                default:
                    printf("%%n%c is not supported in message().", *msgp);
                    exit(1);
                }
                break;
            case 'v':
                vid = va_arg(ap, verb_id_t); 
                p = vid2verb(vid);
                //                printf("hoge:%d:%s:\n", vid, p);
                strcpy(bufp, p);
                bufp += strlen(p);
                break;
			// ΰ֤ǥåϤǤ꥿󥭡Ԥ򤹤
            // ºݤνtermǤ롣
            case 'w':
                *bufp = '\0';                
                puts_term_waited(buf);
                bufp = buf;
                break;
            default:
                printf("%%%c is not supported in message().", *msgp);
                exit(1);
            }
            msgp ++;
        }
        else {
            *bufp++ = code;
        }
    }
    *bufp = '\0';
    va_end(ap);

    // message("")ϲԤ뤿puts_term
    // åǤʤbufʸޤäƤʤΤ
    // Ǥputs/printѤߤʤΤǡ;פʲԤɲäʤ褦putsʤ
    if (bufp != buf || *msg == '\0'){
        puts_term(buf);
    }
}

Msg(cannot_do, "ǤϤǤʤ");
Msg(cannot_destroy, "Τ̵");
Msg(cannot_read, "ɤʤ");
Msg(cannot_move, "ӤȤ⤷ʤ");
Msg(cannot_climb, "褸ФΤ̵");
Msg(no_effect, "ʤˤⵯʤä");
Msg(nothing_special, "ȤѤäȤϤʤ");
Msg(no_object, "ˤϸʤ");
Msg(nothing_any_more, "⤦ʤ");
Msg(need_to_get, "ޤϼ˼äƤߤۤ");
Msg(no_need_to_carry, "äƹԤɬפϤʤ");
Msg(which_door, "ʣ롣");
Msg(which_bookshelf, "êʣ롣");
Msg(door_locked, "ˤϸݤäƤ롣");
Msg(door_unlocked, MSG_DOOR_UNLOCKED);
Msg(door_already_unlocked, MSG_DOOR_ALREADY_UNLOCKED);
Msg(door_closed, "⤬ĤޤäƤ롣");
Msg(door_already_closed, "ϤǤĤޤäƤ롣");
Msg(door_unlocked_by_opening, "μü󤹤ȡȸ줿");
Msg(key_unmatched, "θϸ˹ʤ");
Msg(too_large, "äƤˤ礭롣");
Msg(too_heavy, "Ť롣");
Msg(too_far, "Ǥϱ󤹤롣");
Msg(combine_unmatched, "Ȥ߹碌ʤ");
Msg(bootstrap, "ʿǤΤϥߥҥϥ˼ߤ餤");
Msg(multiple_climb, "ʾɤФȤΤ");

void msg_armor_standing(void){
    message("ܤˤ%nnΩäƤ롣", ni_armor);
}
void msg_look_standing_armor(void){
    message("%nl򹽤ˤ⤢ʤ˻¤꤫ȤƤ롪",
            ni_sword);
}
Msg(look_standing_armor_sword, "ڤ̣ɤ");
Msg(no_magic_circle, "⤦ˡؤϻĤäƤʤ");
Msg(blocked_by_furniture, "¤ȶ񤬼ǶŤʤ");
Msg(no_space_to_move, "ư꤬ʤ");


void msg_to_start(void){
    message("%v(ǽ餫)ޤ"
			"%v(³)ϤƤ", vi_start, vi_load);
}
void msg_start(void){
    message("ʤϳդγξΩĸŤߤˤäƤ");
    message("ٹ뤬ƤȤǡʺ̲ȸƤ롣"
            "Ԥ꼡줿ۤȤƤͭ̾Ǥꡢ"
            "Ƕ̾ȤǤ륵纴ǹˤʤä"
            "ʹ󤸤줿Ф");
    message("긵ˤϿʹڤȴ%nw롣", ni_newspaper);
}

void msg_to_title(void){
    message("ȥʤ%vס"
            "ǡɤʤ%vפϤƤ",
            vi_title, vi_load);
}
void msg_read_newspaper(void){
    message("֡إ纴ͩߤǹ");
    message("ȤΥ纴"
            "εޥɥʥšĴ˽Фޤ"
            "𤷤ƤʤȤȽ"
            "Ʊš1930ǯ"
            "ٹλ᤬ʤܤΤ˷Ƥ"
            "׿»˻᤬Τڤ˹Ԥ꼡"
            "1995ǯΥ襷ζȼ϶ȤȤʤäƤ롣"
            "α"
            "äԤäƤʤ줿ߤȤơ"
            "ϸǤݤƤ");
}
void msg_look_newspaper(void){
       message("纴ι󤸤"
                "ֺǯβơȶ鵢񤷤"
                "ͥ纴פ"
                "ФΤĤ̿ˡ纴餷ʪ̤äƤ롣");
}
void msg_read_essay(void){
    message("֤ܤΤФ󡡡襷");
    message("ܤΤФϤ郎ޤޤǤ"
            "礭ʤäƤܤ̤ˤʤäȤ"
            "βȤˤäơΥ٥åɤ餤ޤ"
            "Ǥ⡢ޤǤʥ٥åɤΤ"
            "ФΤ礦Ȥäơ"
            "褯ܤɤߤˤޤ"
            "ܤȤܤޤ"
            "Τޤä̤ߤΤäݤǤ֤ޤ"
            "ܤȤ⤤ޤǤ䤵Ȥ⤢ޤ"
            "");
}
void msg_read_diary(void){
	message("κǸɤǤߤ");
    message("1222"
			"ޤ줿"
            "޽񼼤ä㤵êΤΤˤĤޤŤߤ"
			"㤬ڤä椷ʤƤ褫ä");
    message("1223"
            "Ƕ褯Ѥ̴򸫤롣"
            "٥åɤǿƤȡ"
            "ϲ鲿ŤƤ褦ʡ"
            "ϥꥹޥ֡"
		    "ߤʤǳڤᤴȤ"
            "");
            message("ʹߤΥڡ");
}
void msg_examine_diary(void){
    message("ѤѤ᤯ȡˤ줿ڡä");
    message("107"
			"˾夬ꤳͷǤ"
			"̤ˤʤäƤΥ٥åɤϻΤäƸäƤΤˡ"
			"ޤˡʥʤΡ");
    message("μΥڡܤˤȤƤ롣");
}

void msg_read_diary_piece(void){
	message("֤äݤǤä顢"
			"פ鷺äѤƤޤä"
			"ˤϰȤ򤷤äޤʤ");
}
void msg_read_logbook(void){
    message("Ǹͤˤޥɥʥ׿ͤδǸϿ");
    message(
            "ǽκϤޤä餷ڼǥԥΤƤꡢ"
            "ƲפȿȤäꤹͤ񤫤Ƥ롣"
            "˿夬ʤߡ"
            "椫ϲڼ٤οǤۤȤɿȤʤäƤ롣"
            "ޥɥʥɻˤޤԤ"
            "Ťܽ褬ΩجäƤ餷"
            "ϿκǸǤϡʥȵƬ"
            "ǸͤҤɤ̣äƤ롣"
            );
}
void msg_read_postcard(void){
	message("֤ϸǤäƤ롣"
			"ꥪ"
			"(ʤߤ3ܤ"
			"ä2ܤϺǯŷ˾줿)"
			"ȰפõƤ衣");
    message("  μˤäޥɥʥšäϡ"
		    "ʽ롣"
			"ꤷߤ"
			"餬դޤǻ֤ꤽ"
			"ޤ̵򤻤ѤäȤФ˲ߤФۤ"
		);
}
void msg_read_sanders_note(void){
    message("֥å");
    message("ɤǤʤ顢"
            "οȤˤʤˤäȤȤ"
            "ϴ"
            "ȤȤϡ֤ѤǤ륬ȤäƤ졣");
    message("̵äϢ쵢äߤ"
            "̵ۤۤ̾Ƥ٤иȤʹ");
    message("ˡ");
}
void msg_read_easy_necromancy(void){
	message("5ʬǤǤѡ٤Ȥ󤯤Ƥ񤫤Ƥ롣");
    msg_recall_easy_necromancy();
}
void msg_recall_easy_necromancy(void){
	message("ֽѼξˤϡԤۤο֤٤");
	message("Ԥȱοʤ򡢰Ȥۤ٤");
	message("ʪȿΤ٤");
}

void msg_read_yoshino_notebook(void){
	message("ۤȤɤΥڡˤϿޤ񤭻餵Ƥ뤬"
            "Ǹ˼국Τ褦ʤΤƤ롣");
	msg_recall_yoshino_notebook();
    message("국ϤǽäƤ롣");
}
void msg_recall_yoshino_notebook(void){
	message("ֿʹ֤Τ褦ʰդ¸ߤȤפʤ"
			"ۤäΤ褦ˡꥹޥ֤ͼ٤˻䤿ۤ褦Ȥ"
			"ʤȻҶΰռϤǤˤʤ"
			"ϤޤˤϻۤƤʤ"
			"ĤޤѤ뤫%w");
	message("ۤ˻ۤʤΤϡ"
			"ϲε뤿餷"
			"׹Ϥ򼺤äͷǤϡŻ̵ʤΤ"
			"ߤΤۤδƻδ㤬æФԲǽ"
			"ιͤư٤ƸƤ櫓Ǥʤ褦"
			"ʤȤۤ΢򤫤ʤΤ%w");
	message("޽񼼤õäơ"
			"鷺ʤޥɥʥɤĤ򸫤Ĥ"
			"ޥɥʥɤϥȥ󵡴ؤȸƤǤ뤬"
			"䤬Τ륵ȥȤϰۤʤ֤Τ褦"
			"ܺ٤ưϧǤꡢ"
			"ޥɥʥɤۤ򾤴ݡ"
			"۳򳫤ưϸˤ褦%w");
	message("虜Ƚ٤餻ʤĴ٤Ƥ뤬"
            "ŪʵˤĤƤ糰ǤäѤ狼ʤ"
			"ʤȤ纴ƤС"
            "ϫΤἼζ˸Τ̽ǤäΤ򸫤ơ"
            "𤷤ƶáäƤޤä"
            "⤽ʤ褦%w");
    message("ۤˤΰտޤ򱣤Τ³"
            "ؤνˡϡۤܤ˿ʤȤ˽񤤤Ƥ"
            "ʬμǷĤä̵ǰ"
            "⤦ٳǿϤळȤǤʤ顢ϡ");
}

void msg_read_bathroom_1f_wall(void){
	message("ۤλϤޤäƤ"
			"Ϥ䤳ޤǤΤ褦");
	message(
			"ޥɥʥɤȥ󵡴ؤΥͥ륮"
            "۳򳫤ΤǤС"
			"Ʊ褦ˤ֤ƤӴ󤻤뤳Ȥǽ"
            "䤬ؤư򤷤"
			"ۤŤΤǤС"
			"ޤ޻ۤ櫓ˤ⤤ޤ"
			"Υͥ륮ۤԤ뤳ȤǤϤ"
			"ؤǳϡ");
    message("åϤڤƤ롣");
}
void msg_read_mirror(void){
	message("ֽʬ˻ĤäƤ뤬"
			"ޤȤƥ륷ɬפ롣"
			"¿Խʪʤϧȿˤϱƶʤ顢"
			"륷ޤǤФʤǤ褤");
	message("ˤۤѤʤ褦"
            "Υ֥ϥ硼ȤƤ롣"
			"֥֤路ƤФλưܥ򲡤С"
			"ʤưϤ");
}
void msg_read_mcdonald_notebook(void){
	msg_recall_mcdonald_notebook();
    message("국ϤǽäƤ롣");
}
void msg_recall_mcdonald_notebook(void){

    message("ֻ¤줿ʤߤȤϤ"
            "ѤäΤǤä");
    message("줿ΤϤä"
            "Ȱؤˡ˾ߤ𤨤Ƥȡ"
            "Ȥפʤä¤鷺"
            "غʤ̿ߤäƤдۤΤΤϤ٤Ƥ٤ȡ"
            "줬٤Ƥδְ㤤ä%w");
    message("ʤΤʤ⻺ˤϤʤä"
            "ѤˤμԤϡۤοʹ֤⤹٤ƼʬΤΤȤΤ"
            "ѿͤʤ⡢ƻ⡣"
            "μԤϤ˺ʤफߤäƤ줿"
            "ΤϤϤ䤢ΰ˲᤮ʤ"
            "ˡؤ˼줿Фִ֡"
            "ޤμԤβ̤ͤƤ%w");
    message("ǤѴȲѿͤ"
            "޾Ф뤫Τ褦ưäƤ롣"
            "伫ȤˤμԤλۤڤ֤椨"
            "˰Ĥ˾ߤʤ餬󤶤ΤԤ"
            "ߤæФޤ뤷ʤ");
    message("䡢ʡβϤʤ⤬⤬%w");
    message("ɤɤ줿褦"
            "ϤФ뤳Ȥ⤫ʤޤ"
            "ȤʤäƤϡĤ줿֤˾Ǥ뤢ޤꡢ"
            "ԤɬפʵΰǤ̤ޤ"
            "򶯹ԤȤޤ롣"
            "勞ϡβߤˬï" );
}
void msg_read_leaflet(void){
    message("֡إ轻̱פȤʸ");
    message("٤ˤ⡢ΦΤ˸褦轻̱"
            "פĤ뤳ȤΤƤ롣"
            "Ǥˤϡ"
            "ޤ路Ѥο۷μ²⤬ꡢ"
            "ΤΤɤʸˤ°ʤ̯д郎ڤ롣"
            "ߥȥ˥åؤˤǿȯĴ̤𤹤");
}
void msg_read_letter(void){
    message("ֵϤʤν񤫤줿ˡǴְ㤤ޤ"
			"ɤꤵ줿ȤΤȡ"
		    "ͤʶʪǤϡ"
            "Ǥӵꤷ²ƱԤäƤ̤˾Ǥ"
			"ʤΤͤΤ褦"
			"ʳؤϤˡؤ򶯲С"
			"򳫤Ϥ뤫⤷ޤ"
			);
}
void msg_read_secret_room_book(void){
//    message("ޤΤ 䤦 ĤˤΤ ʤܤ줤 Ȥ"
//    message("mumanokiz lyau kizni nooka nakak boleily qrento"
//    message("दޤΤä 㤦 äĤ ̤ ʤä ܤ줤ꤤ Ȣ"
//    message("ʤˤ饪ȤᤤƤǤäѤ狼ʤ"
      message("ȤߤŪƤܤѤѤ᤯äƤȡ"
              "ΤĤڡĤä%w");
	msg_recall_secret_room_book();
	message("ομʸʬ˿Ƥưɤ߼ʤ");
	message("ʸβˤϡĤΤ褦ʸͤƤ롣");
}


void msg_recall_secret_room_book(void){
	message("ֶιΤ̵٤ν٤ˤϡ"
			"Ԥɤ餻褦Ȥ"
			"۳¸ߤƤӽФƤޤäȤ"
			"ŤȤ⤷ʲΤ"
			"ΰǤưʲμʸ򾧤뤳Ȥǡ"
			"δޤ路ԤԤȤ롣");
//    message("ޤΤ   줤 Ȥ");
//    message("दޤΤä 㤦 äĤ ̤ ʤä ܤ줤ꤤ Ȣ");
    if (get_term_input_mode() == im_english){
        message("mumanoki_ _y__ _____ _____ __k_k ___eily qrento");
    }
    else {
        message("दޤΤ     줤ꤤ Ȣ");
    }
}


void msg_read_bathroom_2f_wall(void){
	message("ξüȽɤǤʬϰʲΤ褦ɤ롣");
    if (get_term_input_mode() == im_english){
        message("okiz lyau kizni nooka nakak bolei");
    }
    else {
        message("֤Τä 㤦 äĤ ̤ ʤä ܤ줤");
    }
}


void msg_read_boiler_room_wall(void){
	msg_recall_boiler_room_wall();
    message("국ϤǽäƤ롣");
}
void msg_recall_boiler_room_wall(void){
    message("ֲʤ鱪Ǥä"
            "˾ˡؤʤᡢ"
            "ϲˤƧΤ"
            "ޤͤˤʤȤϡ"
			"ãäƤ15ǯʾ夿"
			"̲֤ۤȻפäƤΤ"
			"Ƥˤˬ줿Ϣ椬"
			"ʹα¤ˤʤäƤ褦"
			"%w");
    message("ĴȤǤϡ轻̱ˤ"
            "ҤȸƤФ"
            "̾񤤻ۼԤ˻Ť²¸ߤƤꡢ"
            "ˤϳ̱ߤƶαŪʿ¤򸫤Ȥ"
            "ϿĤäƤ롣"
			"%w");
    message("Ǥӵä²ޤ"
            "ޥɥʥɤƤӽФƤޤäΤǤС"
            "Τϡƿؤλųݤäο"
			"ڤ껥ϥꥪΥ٥ȤˤꡢΤȤϰ"
			"%w");
    message("֤ƿؤưϸΤ褦"
			"ξ㤷Ƥ褦ǻμˤ館ʤ"
			"ʤʤȤǤˡ"
			"Ф줿顢ʤõƤߤ褦"
			"%w");
	message("ʤȤƤꡢˡؤ򸫤ĤʤС"
            "Ťα˷򤯤٤СˡؤưϤ"
			"ȤϤ֤ưȤǤС"
            "ƿؤβǵΰ˼ʸ򾧤"
			"ۤԤ"
            "%w");
	message("ۤοϺ⤳γƤꡢ"
			"ԤƤ롣"
			"åȥǤꧤ"
			"ϰ줫Ȭ");
}




void msg_touching_water(void){
    message("̤˼򿭤Фȡä夬ư褦˸");
    message("ְ㤤ȻפäΤȤ̤ޤ夬ꡢ"
            "ʤμ߹"
            "Ȥ夬Ӥ礤夬ꡢ"
            "ƨ֤ʤȤ߹ࡣ");
}
void msg_shadow_appeared(void){
	message("󤯤ǶڤΤ褦ʶӤ夬ꡢԤϭŤƤ벻롪");
}
void msg_shadow_behind_door(void){
	message("ΤˡԤΩäƤ뵤ۤ롣"
			"Τȩ롣");
}
void msg_shadow_approaching(void){
	message("ϭθ顢ͤĤͤλѤΤ褦ʹƤŤƤ");
}
void msg_shadow_in_room(void){
    message("⤬ͤĤͤλѤΤ褦ʹƤäƤ"
            "Ƥȯ䵤ǡΤĤ");
}
void msg_shadow_in_room_hiding(void){
    message("⤬ơԤäƤ褦");
}
void msg_shadow_wandering(void){
	message("⤭ޤ­ʹ"
			"ýڤη֤ΤĤ褦䵤Ǥ롣");
}
void msg_touching_shadow(void){
    //    if (IsCurrentArea(ladys_room) && IsNewArea(corridor_2f_cr)){
    if (MovingTo(corridor_2f_cr)){
        message("ʤƤʤʤ蘆ä");
    }
    else {
        message("ƤϤäȤ֤ܤꡢʤʤ蘆ä");
    }
    message("볦ǤĤ졢"
            "ڤ褦ʴ˿Ȥޤ롣");
}
void msg_shadow_gone(void){
	message("©Ƥȡ䤬­Фơϭ󤶤äƤä");
}

void msg_phone_call_started(void){
	message("äȤζäĤϤ᤿");
}
void msg_phone_call_continued(void){
	message("äϤޤĤ³Ƥ롣");
}
void msg_phone_call_stopped(void){
	message("äĤ");
}
void msg_answer_phone_call(void){
	message("ô򼪤Ƥȡ"
			"Ϥ˶褦ŪʹƤ");
	message("ϼᡢϻ");
	message("줭äϤȤ⤹Ȥʤʤä");
}
void msg_clock_adjusting_guide(void){
    message("(0715פΤ褦˿4ƤϤ꥿󥭡)");
}
void msg_clock_door_opened(void){
	message("ɤλפĤ"
	  	    "ʸפξξ뤫ʤˤӽФƤ");
}
void msg_clock_door_closed(void){
	message("פĤ꽪ꡢ뤬Ĥ");
}

void msg_attacked_on_2f(void){
    message("󳬤­Ƨ줿Ȥ󡢻볦ðŤˤʤä");
    message("Τդ褦䵤ޤ졢ưȤǤʤ");
    message("ʤΰռϤΤޤڤ줿ġ");
}
void msg_moved_on_2f(void){
    message("ĤȡΤˤ"
            "ɤä褦");
}

void msg_secret_passage(void){
    message("êä%nl롣", ni_passage);
}
void msg_locked_in_secret_room(void){
    message("޽񼼤Ȥ⤬ĤޤäƤ롣");
    message("ʤɬ˳褦Ȥ"
            "¦ϤɤƤⳫʤäġ");
}
void msg_starved(void){
    message("Ĥ줫鲿ä"
            "¾˽иʤˤϿ⿩ʤ");
    message("ˤ⤢ʤϡޥɥʥɤŲƧǤޤä褦");
 }
void msg_tentacle_in(void){
    //    message("ʤ򳫤ȡ"
    message("ʿ꤬ͤʤäƤ");

}
void msg_tentacle_death(void){
//    msg_tentacle_in();
    message("äȤ֤˿Ϥʤ˴դ"
            "رӵä");
}
void msg_tentacle_duck(void){
    msg_tentacle_in();
    message("äȤ֤˿ϥҥ˴դ"
            "رӵä");
}
void msg_tentacle_blocked(void){
    msg_tentacle_in();
    message("ˡؤˤޤ졢ΤޤƤ롣");
}


void msg_far_door_opened(void){
    message("󤯤⤬");
}
void msg_armor_moving_sound(void){
    message("㥬ȲΩƤơŤƤ롣");
}
void msg_armor_moving(void){
    message("㥬ȲΩƤơŤƤ롣");
}
void msg_armor_into_guestroom(void){
    message("ϵҼ򳫤ȡäƤä");
}
void msg_armor_appeared(void){
    message("ܤˡ򹽤%nl줿!", ni_armor);
}
void msg_killed_by_armor(void){
    message("̵򿶤겼ʤϿĤˤʤä");
}
void msg_exiting_window(void){
    message("˽Ф褦뤫ȤФȤ"
            "褯ƤȤʤοΤ򿿤Ĥˤ");
}
void msg_feeling_magic_circle_power(void){
    message("ΤˡΤԻ׵ĤϤ򴶤롣");
}
void msg_looking_pocket_notebook(void){
    message("%nn˵ˤ%nlƤ롣",
            ni_skeleton, ni_pocket_notebook);
}
void msg_no_light(void){
    message("ðŤǲ⸫ʤ"
            "򸫤ĤƤ褵");
}

void message_dragon_too_high(noun_id_t nid){
    message("%nn˾äƼ򿭤ФƤ⡢"
            "%nnϼϤʤȤƨƤޤ", nid, ni_toy_dragon);
}
