#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "config.h"
#include "noun.h"
#include "status.h"
#include "message.h"
#include "layout.h"
#include "history.h"
#include "term.h"


static noun_t nouns[] = {
	{ni_invalid, "", {"", "", ""}, ""},
    {ni_newspaper, "ʹڤȴ", 
     {"newspaper", "֤", "֥"},
     ""
    },
    {ni_leaflet, "饷", 
     {"leaflet", "餷", "饷"},
     "ֱΥ饷Τ褦"
     //     "ϥ襷ζȤʤäƤ롣"
     //     "пͤϥ֥Ļɤʤ"
     //     "褯ȤǤڤƤ롣"
    },
    {ni_medal, "",
     {"medal", "", ""},
     "򤷤°Υ"
    },
    {ni_brass_key, "﫤θ", 
     {"brass key", "夦Τ", "奦Υ"},
     "θ"
    },
    {ni_wooden_key, "ڤθ", 
     {"wooden key", "Τ", "Υ"}, 
     "δΤ褦ʸ"
    },
    {ni_bronze_key, "Ƽθ", 
     {"bronze key", "ɤΤ", "ɥΥ"}, 
     "Ƽθ"
    },
    {ni_steel_key, "Ŵθ", 
     {"steel key", "ƤĤΤ", "ƥĥΥ"}, 
     "Ŵθ"
    },
    {ni_golden_key, "⿧θ", 
     {"golden key", "Τ", "Υ"}, 
     "ʶå줿"
    },
    {ni_silver_key, "θ", 
     {"silver key", "Τ", "Υ"}, 
     "Ǻ줿"
    },
    {ni_glasses, "", 
     {"glasses", "᤬", "ᥬ"}, 
     ""
    },
    {ni_necklace, "", 
     {"necklace", "Ӥ", "ӥ"}, 
     "ʤʼ"
    },
    {ni_clothes, "",
     {"clothes", "դ", "ե"},
     ""
    },
    {ni_chicken, "ܤδݾƤ",
     {"roast chicken", "ޤ䤭", "ޥ䥭"},
     "ܤδݾƤ"
    },
    {ni_chicken_bone, "ܤι",
     {"chicken bone", "ȤΤۤ", "ȥΥۥ"},
     "ܤι"
    },
    {ni_human_bone, "",
     {"bone", "ۤ", "ۥ"},
     "ޥɥʥɤȤܤʪ­ι"
    },




	{ni_rubber_duck, "Υҥ", 
     {"duck", "Ҥ", "ҥ"}, 
     "Υҥδ"
    },
    {ni_mirror, "",
     {"mirror", "", ""},
     "Ἴζ"
    },
    {ni_screw, "ͤ",
     {"screw", "ͤ", "ͥ"},
     "ꤷƤ°Τͤ"
    },
    {ni_screwdriver, "ͤ",
     {"screwdriver", "ͤޤ路", "ͥޥ亮"},
     "ͤ󤹤ι"
    },
    {ni_toy_swordman, "η", 
     //     {"toy swordman", "Τ", "Υ"},
     {"swordman", "", ""},
     "򹽤ܥåȤδ©ҤΤΤ"
    },
    {ni_toy_lion, "Υ饤",
     //     {"toy lion", "Τ餤", "Υ饤"},
     {"lion", "餤", "饤"},
     "饤󷿥ᥫδ©ҤΤΤ"
    },
    {ni_toy_bird, "Ļ",
     //     {"toy bird", "ΤȤ", "Υȥ"}, 
     {"bird", "Ȥ", "ȥ"}, 
     "Ļᥫδ©ҤΤΤ"
    },
    {ni_robot, "Υܥå",
     {"robot", "ܤä", "ܥå"},
     "ιΤΤ"
    },
    {ni_toy_dragon, "Υɥ饴",
     //     {"toy dragon", "Τɤ餴", "Υɥ饴"},
     {"dragon", "ɤ餴", "ɥ饴"},
     "ɥ饴󷿥ᥫΤ©ҤΤΤ"
    },
    {ni_large_robot, "εܥå",
     {"large robot", "ܤä", "ܥå"},
     "ΥܥåȤȥɥ饴ΤΤ"
    },
    {ni_plush_cat, "̤",
     {"plush cat", "̤", "̥"},
     "ǭΤ̤ߤ"
    },
    {ni_girl_doll, "οͷ",
     {"doll", "ˤ󤮤礦", "˥󥮥祦"},
     "ȱΤ򤷤οͷ̼ΤΤ"
    },
    {ni_witch_doll, "οͷ",
     {"witch", "ޤ", "ޥ"},
     "οͷ"
    },
    {ni_slingshot, "Ѥ",
     {"slingshot", "Ѥ", "ѥ"},
     "Ѥ󤳤"
    },
    {ni_rubber_strip, "Ҥ",
     {"rubber strip", "Ҥ", "ҥ"},
     "Ѥ󤳤ΥҤ"
    },
    {ni_branch, "",
     {"branch", "", ""},
     "Ԥʬ줿ڤξޤ"
    },
    {ni_marble, "ӡ",
     {"marble", "ӡ", "ӡ"},
     "饹ξʶ̤"
    },
    {ni_poker, "Ф",
     {"poker", "Ҥܤ", "ҥܥ"},
     "ϧβФ"
    },





    {ni_billiard_ball, "ӥ䡼ɥܡ",
     {"billiard ball", "Ӥ䡼ɤܡ", "ӥ䡼ɥܡ"},
     "ӥ䡼ɤζ̤"
    },
    {ni_logbook, "",
     {"logbook", "ˤä", "˥å"},
     "Ǹ"
    },
    {ni_diary, "Ģ",
     {"diary", "ˤä", "˥å"},
     "Ģ"
    },
    //    {ni_diary_piece, "Υڡ",
    //     {"diary piece", "ˤäΤڡ", "˥åΥڡ"},
    //     "Ե򳫤ڤĢΥڡˤΤΤ褦"
    {ni_paper, "",
     {"paper", "", ""},
     "Ե򳫤ڤ"
    },
    {ni_origami_plane, "Ե",
     {"origami plane", "ߤҤ", "ߥҥ"},
     "ޤäƺäԵ"
    },
    {ni_bottle, "",
     {"bottle", "Ӥ", "ӥ"},
     "Ի׵Ĥʸͤλܤ줿Ӥ"
    },
    {ni_amulet, "̯",
     {"stone", "", ""},
     "Ħ蘆줿Ф"
    },
    {ni_score, "",
     {"score", "", ""},
     ""
    },
    {ni_easy_necromancy, "ǭǤ狼ѡ",
     {"necromancy", "줤", "쥤"},
     "鿴ԸθѤܤ"
    },
    {ni_another_world, "ذ۳¸ߤȤξ",
     {"another world", "", ""},
     "桹Ȥϰۤʤν̱ȡƤӽФˡ񤫤Ƥ롣"
    },
    {ni_essay, "ʸ",
     {"essay", "֤", "֥"},
     "Ҷ񤤤ʸ"
    },
    {ni_wastepaper, "",
     {"wastepaper", "ߤ", "ߥ"},
     "ݤ᤿Τ褦"
    },
    {ni_fishing_rod, "",
     {"fishing rod", "Ĥꤶ", "ĥꥶ"},
     "ѤȤ"
    },
    {ni_sponge, "ݥ",
     {"sponge", "ݤ", "ݥ"},
     "ѤΥݥ󥸤"
    },
    {ni_fossil, "",
     {"fossil", "", ""},
     "ΩɤʥʥȤβФ"
    },
    {ni_postcard, "ս",
     {"postcard", "Ϥ", "ϥ"},
     "͹ս"
    },
    {ni_lantern, "󥿥",
     {"lantern", "󤿤", "󥿥"},
     "⤭ѤΥ󥿥"
    },
    {ni_ladder, "", 
     {"ladder", "Ϥ", "ϥ"}, 
     "ʥ٥åɤҤ"
    },
    {ni_candle, "Ϲ", 
     {"candle", "", ""}, 
     "礭Ϲ"
    },




    {ni_cuckoo, "ĦξĻ",
     {"cuckoo", "Ϥ", "ϥ"},
     "ĦξĻ"
    },




	
	
    {ni_water, "", 
     {"water", "ߤ", "ߥ"}, 
     ""
    },
    {ni_belt, "",
     {"belt", "٤", "٥"},
     "μؤ"
    },
    {ni_note, "",
     {"note", "", ""},
     "񤤤Ƥ롣"
    },
    {ni_pocket_notebook, "Ģ",
     {"pocket notebook", "Ƥ礦", "ƥ祦"},
     "Ģ"
    },
    {ni_notebook, "Ρ",
     {"notebook", "Ρ", "Ρ"},
     "ΡȤ"
    },
    //    {ni_paper, "ڤ",
    //     {"paper", "", ""},
    //     "ڤ"
    //    },
    //    {ni_card, "ȥ",
    //     {"card", "Ȥ", "ȥ"},
    //     "ȥפΥɤ"
    //    },
    {ni_hat, "˹",
     {"hat", "ܤ", "ܥ"},
     "˹"
    },


    /*
    {ni_note, "국",
     {"note", "夭", "奭"},
     "ʥΡȤ˽񤫤줿국"
     },*/

// ̾(Ūˤϡʸñ򼨤ʤ)
    {ni_door, "", 
     {"door", "ȤӤ", "ȥӥ"},
     "̤"
    },
    {ni_wall, "", 
     {"wall", "", ""},
     "̤ɤ"
    },
    {ni_window, "", 
     {"window", "ޤ", "ޤ"},
     "̤"
    },
    {ni_floor, "", 
     {"floor", "椫", "楫"},
     "̤ξ꤬ۤѤäƤ롣"
    },
    {ni_ceiling, "ŷ", 
     {"ceiling", "Ƥ󤸤礦", "ƥ󥸥祦"},
     "̤ŷ"
    },
    {ni_stairs, "", 
     {"stairs", "", ""},
     "̤γʤ"
    },
    {ni_room, "", 
     {"room", "ؤ", "إ"},
     ""
    },
    {ni_corridor, "ϭ", 
     {"corridor", "", ""},
     "ϭ"
    },

// ̾(ʣ̤о줹뤬ʸñ򼨤)
// ̤ˤ긫ܤۤʤǽΤǡdescriptionǾܤ̤Ϥʤ
    {ni_front_door, "̤", 
     {"front door", "ޤΤȤӤ", "ޥΥȥӥ"},
     "̤ˤ"
    },
    {ni_back_door, "ظ", 
     {"back door", "ΤȤӤ", "Υȥӥ"},
     "ظˤ"
    },
    {ni_left_door, "¦", 
     {"left door", "ҤΤȤӤ", "ҥΥȥӥ"},
     "¦ˤ"
    },
    {ni_right_door, "¦", 
     {"right door", "ߤΤȤӤ", "ߥΥȥӥ"},
     "¦ˤ"
    },
	{ni_table, "ơ֥",
     {"table", "ơ֤", "ơ֥"},
     "ơ֥"
    },
	{ni_chair, "ػ",
     {"chair", "", ""},
     "ػҤ"
    },
    {ni_bed, "٥å",
     {"bed", "٤ä", "٥å"},
     "٥åɤ"
    },
    {ni_mattress, "ޥåȥ쥹",
     {"mattress", "ޤäȤ줹", "ޥåȥ쥹"},
     "٥åɤΥޥåȥ쥹"
    },
    {ni_desk, "",
     {"desk", "Ĥ", "ĥ"},
     ""
    },
    {ni_drawer, "",
     {"drawer", "Ҥ", "ҥ"},
     "ͤ"
    },
    {ni_bookshelf, "ê",
     {"bookshelf", "ۤ", "ۥ"},
     "ê"
    },
    {ni_front_bookshelf, "̤ê", 
     {"front bookshelf", "ޤΤۤ", "ޥΥۥ"},
     "̤ˤê"
    },
    {ni_left_bookshelf, "¦ê", 
     {"left bookshelf", "ҤΤۤ", "ҥΥۥ"},
     "¦ˤê"
    },
    {ni_right_bookshelf, "¦ê", 
     {"right bookshelf", "ߤΤۤ", "ߥΥۥ"},
     "¦ˤê"
    },
    {ni_chain, "", 
     {"chain", "", ""},
     "٤°κ"
    },
    {ni_box, "Ȣ", 
     {"box", "Ϥ", "ϥ"},
     "Ȣ"
    },
    {ni_cabinet, "ӥͥå", 
     {"cabinet", "Ӥͤä", "ӥͥå"},
     "ӥͥåȤ"
    },
    {ni_chest, "ý", 
     {"chest", "", ""},
     "ýڤ"
    },
    {ni_book, "", 
     {"book", "ۤ", "ۥ"},
     "ܤ"
    },
    {ni_handle, "ü", 
     {"handle", "Ȥä", "ȥå"},
     "ü"
    },
    {ni_letter, "", 
     {"letter", "Ƥ", "ƥ"},
     ""
    },



// ƾ̸ͭ̾(Ūˡ˰ĤĤ¸ߤʤ)
	{ni_house, "",
     {"house", "", ""},
     "ޥɥʥš"
    },
	{ni_path, "ƻ",
     {"path", "ߤ", "ߥ"},
     "ۤθؤޤ³оξƻ"
    },
    {ni_mailbox, "͹ؼ", 
     {"mailbox", "椦Ӥ󤦤", "楦ӥ󥦥"},
     ""
    },
    {ni_flowerpot, "ȭ", 
     {"flowerpot", "Ф", "Х"},
     "ǾƤοȭ"
    },
    {ni_bathtub, "", 
     {"bathtub", "褯", "襯"},
     "ˤ꤬ۤѤäƤ롣"
    },
    {ni_washstand, "", 
     {"washstand", "", ""},
     "꤬ۤѤäƤ롣"
    },
    {ni_toilet, "ش", 
     {"toilet", "٤", "٥"},
     "μش꤬ۤѤäƤ롣"
    },
    {ni_washer, "", 
     {"washer", "󤿤", "󥿥"},
     ""
    },
    {ni_dryer, "絡", 
     {"dryer", "󤽤", "󥽥"},
     "絡"
    },
    {ni_dog, "",
     {"dog", "", ""},
     "緿"
    },
    {ni_orion, "ꥪ",
     {"Orion", "ꤪ", "ꥪ"},
     "纴θΤ褦"
    },
    {ni_treasure_chest, "Ȣ",
     {"treasure chest", "Ф", "Х"},
     "ҶѤδȢ"
    },



    {ni_fireplace, "ϧ",
     {"fireplace", "", ""},
     "ϧ"
    },
    {ni_tv, "ƥ",
     {"TV", "Ƥ", "ƥ"},
     "֥饦ɤΥƥӤ"
    },
    {ni_telephone, "õ",
     {"telephone", "Ǥ", "ǥ"},
     "Ťõ"
    },
    {ni_clock, "",
     {"clock", "Ȥ", "ȥ"},
     "פ"
    },
    {ni_clock_hands, "",
     {"clock hands", "Ϥ", "ϥ"},
     "פοˤ"
    },
    {ni_photo, "̿",
     {"photo", "㤷", "㥷"},
     "²ν̿"
    },
    {ni_man, "",
     {"man", "Ȥ", "ȥ"},
     "򤫤Ϥβ䤫Ƥοʪ"
     "餯襷ζ"
    },
    {ni_woman, "",
     {"woman", "", ""},
     "䤵ʽκʤ"
    },
    {ni_girl, "",
     {"girl", "ʤΤ", "ʥΥ"},
     "餤ξ̼"
     }, 
    {ni_boy, "ǯ", 
     {"boy", "ȤΤ", "ȥΥ"}, 
     "餤ξǯ©Ҥ" 
     "ʥܥåȤδ­˾ФäƤ롣" 
    }, 
    {ni_ash, "ǳ", 
     {"ash", "⤨", "⥨"}, // Ρ֤Ϥפni_yesȽŤʤ뤿 
     "ŤǳȤλĤ꤫" 
    },
    {ni_videotape, "ӥǥơ",
     {"videotape", "ӤǤơ", "ӥǥơ"},
     "ΤΥӥǥեȤ"
    },
    

    {ni_counter, "Ĵ",
     {"counter", "礦", "祦"},
     "Ĵ"
    },
    {ni_sink, "ή",
     {"sink", "ʤ", "ʥ"},
     "ή"
    },
    {ni_range, "",
     {"range", "", ""},
     ""
    },
    {ni_oven, "֥",
     {"oven", "֤", "֥"},
     "֥"
    },
	{ni_icebox, "¢",
     {"icebox", "줤", "쥤"},
     "¢ˤ"
    },
	{ni_cupboard, "ê",
     {"cupboard", "ä", "å"},
     "ê"
    },
	{ni_billiard_table, "ӥ䡼",
     {"billiard table", "Ӥ䡼ɤ", "ӥ䡼ɥ"},
     "ӥ䡼"
    },
	{ni_darts_target, "ĤŪ",
     {"target", "ޤ", "ޥ"},
     "ĤŪ"
    },

    {ni_portrait, "",
     {"portrait", "", ""},
     "ξ"
    },

    {ni_washtub, "",
     {"washtub", "", ""},
     "礭"
    },
    {ni_tree, "",
     {"tree", "", ""},
     "ڤ"
    },
    {ni_car, "",
     {"car", "", ""},
     "ԥååץȥåμѼ֤"
    },
    {ni_drum, "ɥ",
     {"drum", "ɤफ", "ɥ५"},
     "ɥ̤"
    },
    {ni_garden, "",
     {"garden", "Ƥ", "ƥ"},
     "Ӥ̤Ƥ"
    },




    {ni_wardrobe, "ý",
     {"wardrobe", "褦դ", "襦ե"},
     "Ωɤýڤ줽ʤۤ礭"
    },
    {ni_dressing_table, "",
     {"dressing table", "礦", "祦"},
     "ʬʴ˳Ƥ롣"
    },
    {ni_piano, "ԥ",
     {"piano", "Ԥ", "ԥ"},
     "ŤɥԥΤ"
    },
    // ˡؤȱˡؤ
    {ni_magic_circle, "ˡ",
     {"magic circle", "ޤۤ", "ޥۥ"},
     "ˡؤ"
    },
    {ni_altar, "",
     {"altar", "", ""},
     "Ť"
    },
    {ni_passage, "ϩ",
     {"passage", "Ĥ", "ĥ"},
     "ϩ"
    },
    {ni_skeleton, "",
     {"skeleton", "", ""},
     "Τ"
    },
    {ni_skull, "",
     {"skull", "ɤ", "ɥ"},
     ""
    },
    {ni_gun, "åȥ",
     {"shotgun", "夦", "奦"},
     "åȥ"
    },

    {ni_hatch, "ϥå", 
     {"hatch", "Ϥä", "ϥå"},
     "˼դ줿ϥå"
    },
    {ni_machine, "", 
     {"machine", "", ""},
     "ȤΤʤ"
    },
    {ni_button, "ܥ", 
     {"button", "ܤ", "ܥ"},
     "ܥ"
    },
    {ni_green_button, "пΥܥ", 
     {"green button", "ߤɤΤܤ", "ߥɥΥܥ"},
     "礭пΥܥ"
    },
    {ni_red_button, "ֿΥܥ", 
     {"red button", "ܤ", "ܥ"},
     "礭ֿΥܥ"
    },
    {ni_panel, "ѥͥ", 
     {"panel", "Ѥͤ", "ѥͥ"},
     "°Υѥͥ"
    },
    {ni_round_door, "", 
     {"round door", "ޤȤӤ", "ޥȥӥ"},
     "°δݤ"
    },
    {ni_small_door, "", 
     {"small door", "ʤȤӤ", "ʥȥӥ"},
     "°ξ"
    },
    {ni_cable, "֥", 
     {"cable", "֤", "֥"},
     "ӥˡʤ줿֥"
    },
    {ni_fuel_rod, "°", 
     {"rod", "ܤ", "ܥ"},
     "°򤤤Ĥ«ͤΤ"
    },
    {ni_it, "ۼ", 
     {"it", "Ϥ", "ϥ"},
     "̾Τ褦¸ߤ"
    },
    {ni_face, "", 
     {"face", "", ""},
     "⤫Ӿ夬äͤδ"
    },
    {ni_tentacle, "", 
     {"tentacle", "礯", "祯"},
     "ͤƹۤɤΤ롢ʿ"
    },
    {ni_spell, "ʸ", 
     {"spell", "", ""},
     "۳¸ߤԤʸ"
    },

    {ni_bathroom_1f_wall, "쳬Ἴ", 
     {"1f bathroom", "ä褯", "å襯"},
     ""
    },
    {ni_bathroom_2f_wall, "Ἴ", 
     {"2f bathroom", "ˤ褯", "˥襯"},
     ""
    },
    {ni_study_note, "ؤμ국", 
     {"study note", "礵Τ夭", "祵Υ奭"},
     ""
    },
    {ni_secret_room_note, "μ국", 
     {"secret room note", "٤Τ夭", "٥Υ奭"},
     ""
    },
    {ni_secret_room_book, "", 
     {"secret room book", "٤Τۤ", "٥Υۥ"},
     ""
    },
    {ni_secret_room_letter, "μ", 
     {"secret room letter", "٤ΤƤ", "٥Υƥ"},
     ""
    },
    {ni_boiler_room_note, "ܥ顼", 
     {"boiler room", "ܤ顼", "ܥ顼"},
     ""
    },





    {ni_armor, "", 
     {"samurai armor", "", ""},
     "ܤΤγμ̣"
    },
    {ni_sword, "", 
     {"samurai sword", "", ""},
     "褯ڤ줽"
    },



    {ni_noun, "̾", 
     {"noun", "ᤤ", "ᥤ"},
     NULL,
    },
    {ni_verb, "ư", 
     {"verb", "ɤ", "ɥ"},
     NULL,
    },
    {ni_basic, "ܥޥ", 
     {"basic", "ۤ", "ۥ"},
     NULL,
    },
    {ni_tips, "ҥ", 
     {"tips", "Ҥ", "ҥ"},
     NULL,
    },
    {ni_key, "", 
     {"key", "", ""},
     NULL,
    },
    {ni_assistance, "ǽ", 
     {"assist", "ۤ", "ۥ"},
     NULL,
    },
    {ni_input, "", 
     {"input", "ˤ夦礯", "˥奦祯"},
     NULL,
    },
    {ni_english, "Ѹ", 
     {"english", "", ""},
     NULL,
    },
    {ni_hiragana, "Ҥ餬", 
     {"hiragana", "Ҥ餬", "ҥ饬"},
     NULL,
    },
    {ni_katakana, "", 
     {"katakana", "", ""},
     NULL,
    },
    {ni_yes, "", 
     {"yes", "Ϥ", "ϥ"},
     NULL,
    },
    {ni_no, "", 
     {"no", "", ""},
     NULL,
    },

#ifdef DEBUG
    {ni_entrance, "", 
     {"entrance", "󥫥", "󥫥"},
     NULL,
    },
    {ni_entrance_hall, "إۡ", 
     {"hall", "ۡ", "ۡ"},
     NULL,
    },
    {ni_living, "", 
     {"living", "", ""},
     NULL,
    },
    {ni_dining, "Ʋ", 
     {"dining", "礯ɤ", "祯ɥ"},
     NULL,
    },
    {ni_kitchen, "", 
     {"kitchen", "ɤ", "ɥ"},
     NULL,
    },
    {ni_bathroom, "Ἴ", 
     {"bathroom", "褯", "襯"},
     NULL,
    },
    {ni_boys_room, "ˤλ", 
     {"boyroom", "ɤ٤", "ɥ٥"},
     NULL,
    },
    {ni_music_room, "ڼ", 
     {"music room", "󤬤", "󥬥"},
     NULL,
    },
    {ni_study, "", 
     {"study", "礵", "祵"},
     NULL,
    },
    {ni_library, "޽", 
     {"library", "Ȥ礷", "ȥ祷"},
     NULL,
    },
    {ni_cellar, "ϲ", 
     {"cellar", "", ""},
     NULL,
    },
    {ni_secret_room, "", 
     {"secret room", "٤", "٥"},
     NULL,
    },
    {ni_cave, "ƶ", 
     {"cave", "ɤ", "ɥ"},
     NULL,
    },
    {ni_working_room, "ߡ", 
     {"dummy", "ߡ", "ߡ"},
     NULL,
    },
#endif
    /*
    {ni_, "", 
     {"", "", ""},
     NULL,
    },
    */
};

#define NOUN_NUM (sizeof(nouns)/sizeof(noun_t))

static esynonym_t esynonyms[] = {
    {"y", ni_yes},
    {"n", ni_no},
    {"television", ni_tv},
    {"photograph", ni_photo},
	{"refrigerator", ni_icebox},
	{"fridge", ni_icebox},
};

static jsynonym_t jsynonyms[] = {
	{"ɤ", "ɥ", ni_door},
    {"ޤΤɤ", "ޥΥɥ", ni_front_door},
    {"Τɤ", "Υɥ", ni_back_door},
    {"ҤΤɤ", "ҥΥɥ", ni_left_door},
    {"ߤΤɤ", "ߥΥɥ", ni_right_door},
	{"", "", ni_door},
    {"ޤΤ", "ޥΥ", ni_front_door},
    {"Τ", "Υ", ni_back_door},
    {"ҤΤ", "ҥΥ", ni_left_door},
    {"ߤΤ", "ߥΥ", ni_right_door},
    {"Ȥ", "ȥ", ni_toilet},
    {"󤻤", "󥻥", ni_man},
    {"礻", "祻", ni_woman},
    {"礦", "祦", ni_girl},
    {"礦ͤ", "祦ͥ", ni_boy},
    {"ͤ", "ͥ", ni_plush_cat},
    {"", "", ni_robot},
    {"", "", ni_large_robot},
    {"", "", ni_bed},
    {"ͤä줹", "ͥå쥹", ni_necklace},
    {"䤷", "䥷", ni_house},
    {"Ӥ", "ӥ", ni_marble},
    {"Ӥ䤢ɤܤ", "ӥ䥢ɥܥ", ni_billiard_ball},
    {"Ӥ䤢ɤ", "ӥ䥢ɥ", ni_billiard_table},
    //    {"", "", ni_car},
    {"ɤ", "ɥ", ni_car},
    {"Ȥä", "ȥå", ni_car},
    {"ˤ", "˥", ni_garden},
    {"ɤ餤С", "ɥ饤С", ni_screwdriver},
    {"Τܤ", "Υܥ", ni_red_button},
    {"Τܤ", "Υܥ", ni_red_button},
    {"ߤɤꤤΤܤ", "ߥɥꥤΥܥ", ni_green_button},
    {"ޤ뤤ɤ", "ޥ륤ɥ", ni_round_door},
    {"ޤ뤤", "ޥ륤", ni_round_door},
    {"ȤӤ", "ȥӥ", ni_small_door},
    {"ʤɤ", "ʥɥ", ni_small_door},
    {"ɤ", "ɥ", ni_small_door},
    {"ʤ", "ʥ", ni_small_door},
    {"", "", ni_small_door},
    {"Ӥ", "ӥ", ni_belt},
    {"ˤȤ", "˥ȥ", ni_chicken},
    {"", "", ni_chicken},
    {"ҤȤΤۤ", "ҥȥΥۥ", ni_human_bone},
    {"ˤ󤲤Τۤ", "˥󥲥Υۥ", ni_human_bone},
    {"ޤɤʤɤΤۤ", "ޥɥʥɥΥۥ", ni_human_bone},
    {"Τۤ", "Υۥ", ni_human_bone},
};

#define ESYNONYM_NUM (sizeof(esynonyms)/sizeof(esynonym_t))
#define JSYNONYM_NUM (sizeof(jsynonyms)/sizeof(jsynonym_t))

static dic_t noun_dic;
static history_t noun_hist;

int nid2noun_ix[ni_end];


void noun_init(void){
    int i, j;
    noun_id_t nid;

	assert(ni_item_end <= 256); // ƥˤʤ̾ID8bit

	init_dic(&noun_dic);
    init_history(&noun_hist);    
    
    // ̾򼭽Ͽ
	// ƬΥߡФΤ1
    for (i = 1 ; i < NOUN_NUM ; i++){
        nid = nouns[i].id;
        if (nid2noun_ix[nid] != 0){
            printf("ƥ२顼: "
                   "̾%sפID(%d)"
                   "̾%sפIDȽʣƤޤ\n", 
                   nouns[i].name, nid, nouns[nid2noun_ix[nid]].name);
            exit(1);
        }
        //        printf("set nid:%d ix:%d\n", nid, i);
        nid2noun_ix[nid] = i;
        for (j = 0 ; j < 3 ; j++){
            register_dic(&noun_dic, nouns[i].word[j], nouns[i].id);
        }
	}
    // 򼭽Ͽ
    for (i = 0 ; i < ESYNONYM_NUM ; i++){
        register_dic(&noun_dic, esynonyms[i].word, esynonyms[i].id);
    }
    for (i = 0 ; i < JSYNONYM_NUM ; i++){
        register_dic(&noun_dic, jsynonyms[i].hiragana, jsynonyms[i].id);
        register_dic(&noun_dic, jsynonyms[i].katakana, jsynonyms[i].id);
    }	
	
	// ǡΤʤnidʤå
	for (nid = ni_begin+1 ; nid < ni_end ; nid++){
        if (nid == ni_item_end ||
            nid == ni_generic_begin ||
            nid == ni_generic_end)
        {
            continue;
        }
        if (nid2noun_ix[nid] == 0){
            printf("ƥ२顼: "
				"nid:%dΥǡޤ\n", nid);
            exit(1);
        }
    }
}

int get_noun_ix(char *word){
    return get_word_ix(word, &noun_dic);
}

noun_id_t get_noun_id(char *noun){
    int ix;
    noun_id_t nid = ni_unknown;

	if (noun == NULL) return ni_invalid;

    ix = get_noun_ix(noun);
    printf("get_noun_id %s:%d\n", noun, ix);
    register_noun_history(ix);
    if (ix >= 0){
        nid = word_ix2id(ix, &noun_dic);
    }
    return nid;
}
char *nid2noun(noun_id_t nid){
    input_mode_t mode = get_term_input_mode();
	int ix = nid2noun_ix[nid];

	if (ix > 0){
         return nouns[ix].word[mode];
    }
    return NULL;
}

char *noun_name(noun_id_t nid){
    //    printf("noun name %d(%d)\n", nid, nid2noun_ix[nid]);
    assert(nid2noun_ix[nid] > 0);

    return nouns[nid2noun_ix[nid]].name;
}
char *noun_description(noun_id_t nid){
    //    printf("nid:%d\n", nid);
    assert(nid2noun_ix[nid] > 0);

    return nouns[nid2noun_ix[nid]].description;
}

void register_noun_history(int noun_ix){
    register_history(noun_ix, &noun_hist);
}
char *get_history_noun(void){
	history_entry_t entry = noun_hist.entries[noun_hist.ix];
	if (entry.ix == INVALID_WORD_IX) return NULL;
	return ix2word(entry.ix, &noun_dic);
};
void prev_history_noun(void){
	prev_history(&noun_hist);
}
void next_history_noun(void){
	next_history(&noun_hist);
}

void show_help_noun(void){
    char buf[CONSOLE_CHR_WIDTH * CONSOLE_CHR_HEIGHT], *p, *word;
    noun_id_t nid;
    input_mode_t mode = get_term_input_mode();

    message("ʲΰŪ̾줬ѤǤޤ"
            "¾̾ϡå'[', ']'˼ޤ");
    buf[0] = '\0';
    p = buf;

    for (nid = ni_generic_begin+1 ; nid < ni_generic_end ; nid++){
        word = nouns[nid2noun_ix[nid]].word[mode];
        strcpy(p, word);
        p += strlen(word);
        *p++ = ' ';
    }
    *p = '\0';
    puts(buf);
    puts_console(buf);
}

