#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <assert.h>
#include "roman_conv.h"
#include "input_line.h"
#include "roman_input_line.h"

roman_input_line_mode_t roman_mode = im_english;
// ޻ѴʸĹ
static int roman_byte = 0;

// ޻ѴѤΥХåե
static char *roman_buf;


int roman_input_line_init(int byte_max){
    roman_conv_init();
    roman_buf = malloc(byte_max+1);
    return input_line_init(byte_max);
}

roman_input_line_mode_t roman_input_line_get_mode(void){
    return roman_mode;
}
void roman_input_line_set_mode(roman_input_line_mode_t mode){
    roman_mode = mode;
    if (mode == im_hiragana){
        roman_conv_set_mode(rc_mode_hiragana);
    }
    else if (mode == im_katakana){
        roman_conv_set_mode(rc_mode_katakana);
    }
}

char *roman_input_line_get_line(void){
    return input_line_get_line();
}

int roman_input_line_get_input(char *input){
    return input_line_get_input(input);
}

int roman_input_line_get_byte(void){
    return input_line_get_byte();
}
int roman_input_line_get_width(void){
    return input_line_get_width();
}
int roman_input_line_get_roman_byte(void){
    return roman_byte;
}

int roman_input_line_get_chr_num(void){
    return input_line_get_chr_num();
}
int roman_input_line_get_word_num(void){
    return input_line_get_word_num();
}
int roman_input_line_is_tail_spc(void){
    return input_line_is_tail_spc();
}


int roman_input_line_clear(void){
    roman_byte = 0;
    return input_line_clear();
}

int roman_input_line_backspace(void){
    if (roman_byte > 0){
        roman_byte --;
    }
    return input_line_backspace();
}

// ñ
int roman_input_line_delete_word(void){
    return input_line_delete_word();
}


int roman_input_line_append_chr(char chr){
    int i;
    int converted;
    char *leftstr;
    char result_buf[16];

    if (roman_mode == im_english){
        return input_line_append_chr(chr);
    }
    // ѻ'-'ʳʤ޻Ѵʤ
    if (!isalpha(chr) && chr != '-'){
        roman_byte = 0;
        return input_line_append_chr(chr);
    }

    roman_buf[roman_byte] = chr;
    roman_byte ++;
    roman_buf[roman_byte] = '\0';
    converted = !roman2kana(roman_buf, result_buf, &leftstr, 0);
    //    printf("roman conv|%s|%s| byte=%d\n", result_buf, roman_buf, roman_byte);
    if (converted){
        for (i = 0 ; i < roman_byte-1 ; i++){
            input_line_backspace();
        }
        input_line_append_str(result_buf);
        roman_byte = 0;
    }
    else {
        input_line_append_chr(chr);
    }
    return 0;
}

int roman_input_line_terminate(void){
    int i;
    int converted;
    char *leftstr;
    char result_buf[16];

    converted = !roman2kana(roman_buf, result_buf, &leftstr, 1);
    //    printf("roman conv|%s|%s| byte=%d\n", result_buf, roman_buf, roman_byte);
    if (converted){
        // ʸʤroman_bytebackspaceФ褤
        for (i = 0 ; i < roman_byte ; i++){
            input_line_backspace();
        }
        input_line_append_str(result_buf);
        roman_byte = 0;
    }
    return 0;
}

int roman_input_line_append_code(unsigned int code, int byte){
    return input_line_append_code(code, byte);
}

int roman_input_line_set_str(char *str){
    return input_line_set_str(str);
}

int roman_input_line_append_str(char *str){
    return input_line_append_str(str);
}

int roman_input_line_set_prompt(char *new_prompt){
    return input_line_set_prompt(new_prompt);
}
int roman_input_line_set_cursor(char new_cursor){
    return input_line_set_cursor(new_cursor);
}

#ifdef DEBUG
void roman_input_line_print_line(void){
    input_line_print_line();
    //    printf("roman(%d)|%s|\n", roman_byte, roman_buf);
}
#endif
