#ifndef VERB_H
#define VERB_H
#include "dic.h"
#include "verb_id.h"
#include "noun_id.h"


typedef struct {
    verb_id_t id;
    char *word[3];
    char *shortcut;
} verb_t;

typedef struct {
    char *word;
    noun_id_t nid;
    verb_id_t new_vid;
} verb_trans_t;

void verb_init(void);
int get_verb_ix(char *verb);
verb_id_t get_verb_id(char *verb, noun_id_t nid);
char *vid2verb(verb_id_t vid);
void register_verb_history(int verb_ix);
char *get_history_verb(void);
void prev_history_verb(void);
void next_history_verb(void);
void show_help_verb(void);
void show_help_basic(void);
void show_help_tips(void);
void show_help_key(void);
void show_help_assistance(void);

#endif
